<?php

/*
    PDR 2 to PDR 3 upgrade script
*/

require "./settings/settings.inc.php";

define("IPFM_RUNNING", 1);

// MySQL upgrade queries
$mySQL[] = "ALTER TABLE " . $settings["dbprefix"] . "_users CHANGE root_url root_url VARCHAR(255) DEFAULT NULL";
$mySQL[] = "ALTER TABLE " . $settings["dbprefix"] . "_users CHANGE root_path root_path VARCHAR(255) DEFAULT NULL";

require $settings["script_dir"] . "modules/db/" . $settings["dbtype"] . ".lib.php";

$link_id = db_connect($settings["dbserver"], $settings["dbuser"], $settings["dbpass"], $settings["dbname"]);
            
if (empty($link_id) == true)
{
    $error = db_error($link_id);
    if (empty($error) == true)
    {
        $error = "Invalid username or password";
    }
                
    die("There was an error connecting to the database server, the error returned was: {$error}");
}
else
{
    if (isset($$settings["dbtype"]) == false)
    {
        die("This upgrade does not appear to be compatible with the database driver you are using");
    }
    
    $error = false;
    foreach ($$settings["dbtype"] as $var)
    {
        if (db_query($var, $link_id) == false)
        {
            $error = db_error($link_id);
        }
    }
                
    db_close($link_id);                
    
    if ($error == false)
    {
        die("Upgrade complete, please delete this file now<br /><b>If you upgraded from PDR 1 to PDR 2 please also run fix_pdr2.php</b>");
    }
    else
    {
        die("Upgrade could not be completed, the following error occurred: {$error}");
    }
}                

?>