<?php

/*
 * Invision Power File Manager
 * Admin control panel
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 24th February 2005
 *
 */

$gzip = true;

error_reporting(E_USER_WARNING | E_ERROR | E_PARSE);
set_magic_quotes_runtime(0);
set_time_limit(0);

require "./settings/settings.inc.php";

if ($settings["debug"] == true)
{
    error_reporting(E_ALL & ~E_NOTICE);    
}

/* -----------------------------------------
               Program Execution
   ----------------------------------------- */

define("IPFM_RUNNING", true);   // Used for error checking

// Is the script directory setting valid?
if (file_exists($settings["script_dir"]) == false)
{
    // No! Then we have a problem, time to exit
    if (preg_match("/windows/i", php_uname()) == true)
    {
        die("The script directory setting is invalid");
    }
    else
    {
        die("The script directory setting is invalid.<br />Remember that on Unix based platforms directory names are case sensitive");
    }
}

require $settings["script_dir"] . "settings/languages.inc.php";
require $settings["script_dir"] . "modules/common.lib.php";

require $settings["script_dir"] . "modules/db/" . $settings["dbtype"] . ".lib.php";

// And they're off
$debug["start"] = start_clock();
$link_id        = db_connect($settings["dbserver"], $settings["dbuser"], $settings["dbpass"], $settings["dbname"]);
$input          = clean_input();

if (empty($_COOKIE[$settings["admin_user_cookie"]]) == false && empty($link_id) == false)
{
    $permissions = auth_user($_COOKIE[$settings["admin_user_cookie"]], $_COOKIE[$settings["admin_pass_cookie"]]);
}

$scripts = array("login" => "login", "err" => "../error", "idx" => "index", "set" => "settings", "misc" => "misc", "mem" => "users", "grp" => "groups", "temp" => "templates", "skin" => "skins", "lng" => "languages");

if (empty($link_id) == true)
{
    // Error connecting to the database;
    $input["act"] = "err";
    $global_tpl = "skin/global.tpl";
}
else if (is_array($permissions) == false)
{
    // Not logged in
    $input["act"] = "login";
}
else if (isset($scripts[$input["act"]]) == false)
{
    // Is the users action valid?
    $input["act"] = "idx";
}

// Enable GZIP output compression if possible
if (phpversion() >= "4.0.4" && extension_loaded("zlib") && $gzip == true)
{
    ob_end_clean();
    ob_start("ob_gzhandler");
}

// Load the language pack
load_language($permissions["lang"], "admin/" . $scripts[$input["act"]], true);  

// Otherwise load the required module
require $settings["script_dir"] . "modules/admin/" . $scripts[$input["act"]] . ".lib.php";

// Sort out CSS, JS and wrapper files
$global_tpl        = isset($global_tpl) ? $global_tpl : "skin/admin/global.tpl"; // If no global template is set, use the default
$page["js"]        = isset($page["js"]) ? $page["js"] : "";

echo static_template($settings["script_dir"] . $global_tpl, $page, 1);

db_close($link_id);

?>