<?php

/*
 * Invision Power File Manager
 * Installer
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball 
 * Version: 1.0.2
 * Last Modified: 5th March 2005
 *
 */

error_reporting(E_ERROR | E_WARNING | E_PARSE);
set_magic_quotes_runtime(0);
set_time_limit(0);

define("IPFM_RUNNING", 1);
define("IPFM_INSTALLER", 1);

/* -----------------------------------------
               Define functions
   ----------------------------------------- */
function outputMessage($body, $title)
{
    outputPage("
    <div class='tableborder'>
        <div class='maintitle' align='left'>{$title}</div>
        <table border='0' width='100%' cellpadding='4'>
            <tr>
                <td align='left' class='row1'>{$body}</td>
            </tr>
        </table>
        <div class='top'>&nbsp;</div>
    </div>");
}

function outputPage($body)
{
    /*
    echo "<?xml version='1.0' encoding='windows-1252' ?>\r\n";
    echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'\r\n";
    echo "    'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>\r\n";
    echo "<html xmlns='http://www.w3.org/1999/xhtml' dir='ltr' xml:lang='en' lang='en'>\r\n";
    */
    echo "<html>\r\n";
    echo "<head>\r\n";
    echo "    <title>Invision Power File Manager - Installer</title>\r\n";
    echo "    <meta http-equiv='Content-Type' content='text/html; charset=utf-8' />\r\n";
    echo "    <link rel='stylesheet' href='install/styles.css' type='text/css' />\r\n";
    echo "</head>\r\n";
    echo "<body>\r\n";
    echo "    <div style='text-align: center; width: 85%; margin: auto;'>\r\n";
    echo "        <div id='logostrip'><a href='install.php'><img src='install/logo.gif' alt='Powered by Invision Power File Manager' border='0' /></a></div>\r\n";
    echo "        <div id='description'>Please follow the on screen directions carefully to ensure you set up Invision Power File Manager correctly.</div>\r\n";
    echo "        {$body}";
    echo "        <div class='copyright'>Powered by <a href='http://www.invisionfilemanager.com/' target='_blank'>Invision Power File Manager</a> &copy; 2004 <a href='http://www.invisionpower.com/' target='_blank'>Invision PS, Inc</a>.</div>\r\n";
    echo "    </div>\r\n";
    echo "</body>\r\n";
    echo "</html>";
}

// Updates the settings file
function update_settings($updated)
{
    // Import the current values
    global $settings;

    // Generate the list of setting arrays which depend upon their keys
    $useKeys = array("icons", "filters");

    $toWrite = "<?php\r\n\r\n";

    foreach ($settings as $key => $var)
    {
        if (isset($updated[$key]) == true)
        {
            // A new value exists
            $data = $updated[$key];
        }
        else
        {
            // Use the old value
            $data = $var;
        }

        // Silly hack, damn slashes
        if ($key == "format")
        {
            $data = str_replace("<%\A\T%>", "<%\\A\\\T%>", $data);
        }

        // If the data is a string or array tidy it up
        if (is_array($data) == true)
        {
            if (in_array($key, $useKeys) == true)
            {
                $data = array_to_string($data, true);
            }
            else
            {
                $data = array_to_string($data);
            }
        }
        else if ($data === true)
        {
            // Check for value and type of true
            $data = 'true';
        }
        else if ($data === false)
        {
            // Check for value and type of false
            $data = 'false';
        }
        else
        {
            if (preg_match("/^[.0-9]+$/", $data) == false)
            {
                $data = '"' . str_replace('"', '\"', $data) . '"';
            }
        }

        $toWrite .= "\$settings[\"" . $key . "\"] = " . $data . ";\r\n";
    }

    $toWrite .= "\r\n?>";

    if (($fp = fopen($updated["script_dir"] . "settings/settings.inc.php", "w")) == false)
    {
        return false;
    }
    else
    {
        fwrite($fp, $toWrite);
        fclose($fp);

        return true;
    }
}

// Converts an array into a string to be written to the settings file
function array_to_string($info, $useKeys = false)
{
    $data = "array(";

    foreach ($info as $key => $var)
    {
        if ($useKeys == true)
        {
            $data .= "\"" . $key . "\" => ";
        }

        $var = str_replace('"', '\"', $var);

        $data .= "\"" . $var . "\", ";
    }

    $data .= ")";

    // Clean up the extra ,
    return preg_replace("/, \)$/", ")", $data);
}
/* -----------------------------------------
               Program Execution
   ----------------------------------------- */

// Check if the lock file exist, i.e. the user has completed installing the script but never deleted the installer
if (file_exists("install.lock") == true)
{
    $_REQUEST["step"] = "locked";

}
switch ($_REQUEST["step"])
{
    case "locked":
        /* -----------------------------------------
                      Installer is locked
           ----------------------------------------- */
        outputMessage("You cannot run the installer whilst the lock file &quot;install.lock&quot; exists, this was probably created when you originally installed Invision Power File Manager.", "Invision Power File Manager installer locked");
    break;
    case 1:
        /* -----------------------------------------
                    Show the database screen
           ----------------------------------------- */
		$drivers = "";

		$dp = opendir("./modules/db/") or $error = true;
        while($entry = readdir($dp))
        {
            if (is_dir($entry) == false && $entry != "." && $entry != "..")
            {
                if (preg_match("/\.lib.php$/i", $entry) == true && preg_match("/_queries/i", $entry) == false)
                {
                    $entry = explode(".", $entry);
                    $drivers .= "<option value='{$entry[0]}'>{$entry[0]}</option>";
                }
            }
        }
 		closedir($dp);

        if ($error == true)
        {
            outputMessage("There was an error opening the database driver folder, please ensure the folder &quot;/modules/db/&quot; exists and is readable", "Invision Power File Manager driver error");
        }
        else
        {
            outputPage("
            <form action='install.php' method='post'>
		        <input type='hidden' name='step' value='2'>
			    <div class='tableborder'>
	                <div class='maintitle'>System setup</div>
                    <table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
                        <tr>
                            <td align='left' class='catrow2' colspan='2'>Your SQL Environment</td>
                        </tr>
                        <tr>
                            <td align='left' class='info' colspan='2'>This section requires you to enter your SQL information. If in doubt, please check with your webhost before asking for support. You may choose to enter an existing database name, if not - you must create a new database before continuing.</td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>SQL driver</strong><br />Select the database engine you are using</td>
                            <td class='tdrow2' width='60%' valign='middle'><select name='dbtype'>{$drivers}</select></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>SQL host</strong><br />This is normally localhost</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='dbserver' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>SQL username</strong></td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='dbuser' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>SQL password</strong></td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='password' name='dbpass' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>SQL database</strong></td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='dbname' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>SQL table prefix</strong><br />You can leave this blank and IPFM will use 'ipfm' as a default</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='dbprefix' size='20' /></td>
                        </tr>
                        <tr>
                            <td align='left' class='catrow2' colspan='2'>Your Server Environment</td>
                        </tr>
                        <tr>
                            <td align='left' class='info' colspan='2'>This section requires you to enter the paths and URL's for the file manager.</td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>Script directory</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='script_dir' value='" . str_replace("\\", "/", getcwd()) . "/' size='60' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>Script URL</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='script_url' value='" . str_replace("/install.php", "", $_SERVER["HTTP_REFERER"]) . "/' size='60' /></td>
                        </tr>
                        <tr>
                            <td align='left' class='catrow2' colspan='2'>Your Admin Account</td>
                        </tr>
                        <tr>
                            <td align='left' class='info' colspan='2'>This section requires information to create your administration account. Your email address will be used for the outgoing email address and your root path will be set to the script directory, you can change this once you are inside the administration control panel. Please enter the data carefully!</td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>Username</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='username' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>Password</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='password' name='adminpass' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>Password confirmation</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='password' name='adminpass2' size='45' /></td>
                        </tr>
                        <tr>
                            <td class='tdrow1' width='40%' valign='middle'><strong>Email address</td>
                            <td class='tdrow2' width='60%' valign='middle'><input type='text' name='email' size='45' /></td>
                        </tr>
                        <tr>
                            <td align='center' class='pformstrip' colspan='2'><input type='submit' value='Submit changes' class='button' /></td>
                        </tr>
                    </table>
                </div>
            </form>
            ", "System setup");
        }
    break;
    case 2:
        /* -----------------------------------------
                       Save the settings
           ----------------------------------------- */
        require "./settings/settings.inc.php";

        // Set the default database prefix
        if (empty($_POST["dbprefix"]) == true)
        {
            $_POST["dbprefix"] = "ipfm";
        }

        // Add end slashes if they are missing
        if (preg_match("#/$#", $_POST["script_dir"]) == false)
        {
            $_POST["script_dir"] .= "/";
        }

        if (preg_match("#/$#", $_POST["script_url"]) == false)
        {
            $_POST["script_url"] .= "/";
        }

        if (empty($_POST["dbserver"]) == true)
        {
            outputMessage("Please enter an address for the SQL server<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (empty($_POST["dbuser"]) == true)
        {
            outputMessage("Please enter a username for the SQL server<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (empty($_POST["dbname"]) == true)
        {
            outputMessage("Please enter the name of the database on the SQL server to use<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (file_exists($_POST["script_dir"] . "modules/common.lib.php") == false)
        {
            outputMessage("The script directory does not appear to be valid<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (empty($_POST["username"]) == true)
        {
            outputMessage("Please enter a username for the admin account<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (strlen($_POST["username"]) < 5)
        {
            outputMessage("Please enter a longer username for the admin account<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (empty($_POST["adminpass"]) == $_POST)
        {
            outputMessage("Please enter a password for the admin account<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if ($_POST["adminpass"] != $_POST["adminpass2"])
        {
            outputMessage("The admin passwords you entered do not match<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (preg_match("/^[^@ ]+@[^@ ]+[\.][^@ \.]+$/", $_POST["email"]) == false)
        {
            outputMessage("The email address you entered is not valid<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else if (file_exists($_POST["script_dir"] . "modules/db/" . $_POST["dbtype"] . ".lib.php") == false)
        {
            outputMessage("The database driver you selected does not appear to be installed.<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
        }
        else
        {
            require $_POST["script_dir"] . "modules/db/" . $_POST["dbtype"] . ".lib.php";
            require $_POST["script_dir"] . "install/" . $_POST["dbtype"] . "_install.lib.php";

            $link_id = db_connect($_POST["dbserver"], $_POST["dbuser"], $_POST["dbpass"], $_POST["dbname"]);

            if (empty($link_id) == true)
            {
                $error = db_error($link_id);
                if (empty($error) == true)
                {
                    $error = "Invalid username or password";
                }

                outputMessage("The database server could not be connected to the following error was returned: {$error}<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Input error");
            }
            else
            {
                $error = false;
                $data["PREFIX"] = $_POST["dbprefix"];

                // Drop the groups table
                $sql = $queries["drop_table"];
                build_query($sql, array("TABLE" => $_POST["dbprefix"] . "_groups"));
                db_query($sql, $link_id);

                // Create the groups table
                build_query($queries["create_groups"], $data);
                if (db_query($queries["create_groups"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }

                // Insert the default values
                build_query($queries["admin_group"], $data);
                if (db_query($queries["admin_group"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }
                build_query($queries["guest_group"], $data);
                if (db_query($queries["guest_group"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }
                build_query($queries["member_group"], $data);
                if (db_query($queries["member_group"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }

                // Drop the users table
                $sql = $queries["drop_table"];
                build_query($sql, array("TABLE" => $_POST["dbprefix"] . "_users"));
                db_query($sql, $link_id);

                // Create the users table
                build_query($queries["create_users"], $data);
                if (db_query($queries["create_users"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }

                // Insert the default values
                $data["USERNAME"] = $_POST["username"];
                $data["PASSWORD"] = md5($_POST["adminpass"]);
                $data["EMAIL"]    = $_POST["email"];
                $data["URL"]      = $_POST["script_url"];
                $data["PATH"]     = $_POST["script_dir"];

                build_query($queries["admin_user"], $data);
                if (db_query($queries["admin_user"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }
                build_query($queries["guest_user"], $data);
                if (db_query($queries["guest_user"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }

                // Drop the validating table
                $sql = $queries["drop_table"];
                build_query($sql, array("TABLE" => $_POST["dbprefix"] . "_validating"));
                db_query($sql, $link_id);

                // Create the users table
                build_query($queries["create_validating"], $data);
                if (db_query($queries["create_validating"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }

                // Drop the users table
                $sql = $queries["drop_table"];
                build_query($sql, array("TABLE" => $_POST["dbprefix"] . "_reg_antispam"));
                db_query($sql, $link_id);

                // Create the users table
                build_query($queries["create_antispam"], $data);
                if (db_query($queries["create_antispam"], $link_id) == false)
                {
                    $error = db_error($link_id);
                }

                db_close($link_id);

                if ($error == false)
                {
                    // Add the extra items
                    $_POST["admin_out_email"] = $_POST["email"];
                    $_POST["admin_in_email"]  = $_POST["email"];
                    $_POST["new_path"]        = $_POST["script_dir"] . "users/<%GROUP%>/<%USERNAME%>/";
                    $_POST["new_url"]         = $_POST["script_url"] . "users/<%GROUP%>/<%USERNAME%>/";

                    unlink($_POST["script_dir"] . "users/Administrators/delete");
                    unlink($_POST["script_dir"] . "users/Guests/Guest/delete");
                    unlink($_POST["script_dir"] . "users/Members/delete");

                    if (update_settings($_POST) == false)
                    {
                        outputMessage("There was an error updating the configuration file. Please ensure that &quot;/settings/settings.inc.php&quot; is writeable.<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Server error");
                    }
                    else
                    {
                        outputMessage("The Invision Power File Manager database was setup successfully.<br /><br /><div align='center'><a href='install.php?step=3'>Proceed</a></div>", "Database setup complete");
                    }
                }
                else
                {
                    outputMessage("There was an error creating the SQL tables, the error returned was: {$error}<br /><br /><a href='javascript:history.back();'>Go back and try again</a>", "Database error");
                }
            }
        }
    break;
    case 3:
        /* -----------------------------------------
                    Finalise installation
           ----------------------------------------- */
        require "./settings/settings.inc.php";

        touch($settings["script_dir"] . "install.lock");

        if (file_exists($settings["script_dir"] . "install.lock") == false)
        {
            outputMessage("Invision Power File Manager has been installed successfully, however the installer could not be locked, <b>please delete install.php from your script directory NOW!</b>. If you do not you will leave you system open to attack.<br /><br /><div align='center'><a href='admin.php'>Proceed to administration control panel</a></div>", "Installation completed");
        }
        else
        {
            outputMessage("Invision Power File Manager has been installed successfully<br /><br /><div align='center'><a href='admin.php'>Proceed to administration control panel</a></div>", "Installation completed");
        }
    break;
    default:
        /* -----------------------------------------
                    Show the welcome screen
           ----------------------------------------- */
        // Test the PHP version
        $continue = true;
        $warnings = array();
        $version  = phpversion();
        if ($version < "4.1.0")
        {
            $warnings[] = "<li style='color: red; font-weight: bold;'>You cannot install Invision Power File Manager. Invision Power File Manager requires PHP Version 4.1.0 or better.</li>";
            $continue   = false;
        }
        else if ($version >= "5")
        {
            $warnings[] = "<li>Although Invision Power File Manager should run on PHP 5 it has not be tested extensively, please consider reporting your experience using PHP 5 with Invision Power File Manager on our <a href='http://forums.invisionpower.com/' target='_blank'>support forums</a>.</li>";
        }

        // Test that ZLIB is loaded
        if (extension_loaded("zlib") == false && ini_get("zlib.output_compression") == false)
        {
            $warnings[] = "<li>Although the ZLIB (Compression) module is not required for Invision Power File Manager to operate, it is used to create zip files &amp; to GZIP the HTML output. If you run Invision Power File Manager without ZLIB loaded you will not be able to create zip archives nor will you be able to decompress GZip compressed tar archives, also the output will not be sent to your browser in compressed format.</li>";
        }

        // Test that Zip support is loaded
        if (extension_loaded("zip") == false)
        {
            $warning[] = "<li>Although the Zip (Compression) module is not required for Invision Power File Manager to operate, it is used to read and extract zip files. If you run File Manager without the zip extension loaded you will not be able to extract files from zip archives.</li>";
        }

        // Test that BZip2 support is loaded
        if (extension_loaded("bz2") == false)
        {
            $warnings[] = "<li>Although the BZip2 (Compression) module is not required for Invision Power File Manager to operate, it is used to read and extract BZip2 compressed tar files files. If you run File Manager without the BZip2 extension loaded you will not be able to extract files from BZip2 tar archives.</li>";
        }

        // Test for Apache
        if (preg_match("/apache/i", $_SERVER["SERVER_SOFTWARE"]) == false)
        {
            $warnings[] = "<li>Invision Power File Manager should work on all modern web servers, however the (optional) directory password protection feature only works on the Apache web server software.</li>";
        }

        // Test that GD is loaded
        if (extension_loaded("gd") == false)
        {
            $warnings[] = "<li>Although the GD (Image Creation) module is not required for Invision Power File Manager to operate, it is used to generate pie charts showing space usage statistics. If you run Invision Power File Manager without GD loaded you will not be able to see these pie charts, just text based figures</li>";
        }

        // Test that safe mode is disabled
        if (get_cfg_var("safe_mode") == true)
        {
            $warnings[] = "<li>Safe Mode is known to cause problems with File Management scripts due to the restrictions it places on file access. You should request that your webhost disables safe mode because Invision Power File Manager can not run with safe mode enabled. Some times this setting is detected incorrectly, if you are sure it is disabled then you may continue installation. If you install Invision Power File Manager when safe mode is enabled you may not receive any support.</li>";
        }

        // Test that file uploads are allowed
        if (get_cfg_var("file_uploads") == false)
        {
            $warnings[] = "<li>Although you will be able to edit files which already exist on the file system, as well as create new files using Invision Power File Manager's built in text editor, you will not be able to upload files from your computer.You should request that your webhost re-enable file uploads</li>";
        }

        // Check that the configuration file exists
        if (file_exists("./settings/settings.inc.php") == false || is_writeable("./settings/settings.inc.php") == false)
        {
            $warnings[] = "<li style='color: red; font-weight: bold;'>The configuration file &quot;/settings/settings.inc.php&quot; does not exist or is not writeable</li>";
            $continue   = false;
        }

        $errors= "";
        if (count($warnings) > 0)
        {
  		    $err_string = implode("", $warnings);

	   	    $errors = "<br /><br /><strong>Warning! The following errors were detected!</strong><ul>$err_string</ul>";
        }
        if ($continue == true)
        {
            $errors = "<br /><br /><div align='center'><a href='install.php?step=1'>Proceed</a></div>";
        }

        outputMessage("
        Before we go any further, please ensure that all the files have been uploaded and CHMODed as stated in the install guide.
        <br /><br />
		<b>IPFM requires PHP 4.1.0 or better and an SQL database.</b>
        <br /><br />
		You will also need the following information that your webhost can provide:
		<ul>
		    <li>Your SQL database name</li>
		    <li>Your SQL username</li>
		    <li>Your SQL password</li>
		    <li>Your SQL host address (usually localhost)</li>
		</ul>
		Once you have clicked on proceed, you will be taken to a form to enter information the installer needs to set up your File Manager.
		<br><br>
		<b>PLEASE NOTE: USING THIS INSTALLER WILL DELETE ANY CURRENT INVISION POWER FILE MANAGER DATABASE IF YOU ARE USING THE SAME TABLE PREFIX</b>$errors
		", "Welcome to the Invision Power File Manager installer");
}

?>
