<?php

/*
 * Invision Power File Manager
 * Javascript loader (very messy, need to clean up later)
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 24th February 2005
 *
 */

set_magic_quotes_runtime(0);
set_time_limit(0);
error_reporting(0);

define("IPFM_RUNNING", true);   // Used for error checking

require "./settings/settings.inc.php";
require $settings["script_dir"] . "settings/languages.inc.php";
require $settings["script_dir"] . "modules/common.lib.php";

require $settings["script_dir"] . "modules/db/" . $settings["dbtype"] . ".lib.php";

$link_id = db_connect($settings["dbserver"], $settings["dbuser"], $settings["dbpass"], $settings["dbname"]);

if (empty($link_id) == true)
{
    exit;
}

// Enable GZIP output compression if possible
if (phpversion() >= "4.0.4" && extension_loaded("zlib") && $settings["use_gzip"] == true)
{
    ob_end_clean();
    ob_start("ob_gzhandler");
}

$page        = array();
$files       = array("popup" => "popup", "list" => "listing", "sql" => "database", "edit" => "editor", "reg" => "register", "cp" => "usercp", "admenu" => "admin/index", "adset" => "admin/settings", "admisc" => "admin/misc", "adusers" => "admin/users", "adtemp" => "admin/templates", "adlang" => "admin/languages");
$langs       = $files;

$permissions = auth_user($_COOKIE[$settings["user_cookie"]], $_COOKIE[$settings["pass_cookie"]]);

$input       = clean_input();

readfile($settings["script_dir"] . "skin/js/common.js");

if (isset($files[$input["act"]]) == false && preg_match("/^ad/i", $input["act"]) == false)
{
    $files[$input["act"]] = "popup";
    $langs[$input["act"]] = $input["act"];
}
else if ($input["act"] == "list")
{
    // Build a list for the ASCII filter, no need to define a seperate filter, just use the ASCII files array
    $settings["filters"]["txt"] = "";
    foreach ($settings["ascii"] as $var)
    {
       $settings["filters"]["txt"] .= $var . " ";
    }

    // Parse the dynamic template and construct the page
    $page["img_filter"] = trim($settings["filters"]["img"]);
    $page["mm_filter"]  = trim($settings["filters"]["mm"]);
    $page["arc_filter"] = trim($settings["filters"]["arc"]);
    $page["bin_filter"] = trim($settings["filters"]["bin"]);
    $page["db_filter"]  = trim($settings["filters"]["db"]);
    $page["txt_filter"] = trim($settings["filters"]["txt"]);
    $page["off_filter"] = trim($settings["filters"]["off"]);
}
else if ($input["act"] == "reg" || $input["act"] == "cp")
{
    $page["min_user_len"] = $settings["min_user_length"];
    $page["min_pass_len"] = $settings["min_pass_length"];
}

if (empty($input["act"]) == false && isset($files[$input["act"]]) == true)
{
    load_language($permissions["lang"], $langs[$input["act"]]);
}

echo static_template($settings["script_dir"] . "skin/js/" . $files[$input["act"]] . ".js", $page);

db_close($link_id);

?>