<?php

/*
 * Invision Power File Manager
 * Group management
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 16th October 2004
 *
 */

require $settings["script_dir"] . "settings/sys/zones.inc.php";

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */
switch ($input["op"])
{
    case "view":
        /* ----------------------------
              View group permissions
           ---------------------------- */
        $page["title"]              = $page["groupInfo"];

        // Show default group
        if (preg_match("/^[0-9]+$/", $input["gid"]) == false)
        {
            $input["gid"] = $settings["default_group"];
        }


        build_query($queries["get_group_info"], array("GID" => $input["gid"]));
        $result                     = db_query($queries["get_group_info"], $link_id);
        $query_data                 = db_fetch_array($result, $link_id);

        // Populate the fields
        $page["name"]               = $query_data["groupname"];
        $page["add_notes"]          = dualRadio("add_notes", $query_data["add_notes"]);
        $page["del_admin_msg"]      = dualradio("del_admin_msg", $query_data["del_admin_msg"]);
        $page["show_url"]           = dualradio("show_url", $query_data["show_url"]);
        $page["use_bookmarks"]      = dualradio("use_bookmarks", $query_data["use_bookmarks"]);
        $page["view_stats"]         = dualradio("view_stats", $query_data["stats"]);
        $page["access_ucp"]         = dualradio("access_ucp", $query_data["access_ucp"]);
        $page["access_acp"]         = dualradio("access_acp", $query_data["access_acp"]);
        $page["offline"]            = dualradio("offline", $query_data["offline"]);
        $page["chmod"]              = dualradio("chmod", $query_data["chmod"]);
        $page["upload"]             = dualradio("upload", $query_data["upload"]);
        $page["download"]           = dualradio("download", $query_data["download"]);
        $page["delete"]             = dualradio("delete", $query_data["delete"]);
        $page["rename"]             = dualradio("rename", $query_data["rename"]);
        $page["lock_dir"]           = dualradio("lock_dir", $query_data["lock_dir"]);
        $page["editor"]             = dualradio("editor", $query_data["editor"]);
        $page["view_source"]        = dualradio("view_source", $query_data["view_source"]);
        $page["view_img"]           = dualradio("view_img", $query_data["view_img"]);
        $page["view_mp3"]           = dualradio("view_mp3", $query_data["mp3"]);
        $page["copy"]               = dualradio("copy", $query_data["copy"]);
        $page["move"]               = dualradio("move", $query_data["move"]);
        $page["newfolder"]          = dualradio("newfolder", $query_data["newfolder"]);
        $page["newfile"]            = dualradio("newfile", $query_data["newfile"]);
        $page["overwrite"]          = dualradio("overwrite", $query_data["overwrite"]);
        $page["create_archive"]     = dualradio("create_archive", $query_data["create_archive"]);
        $page["view_archive"]       = dualradio("view_archive", $query_data["view_archive"]);
        $page["make_symlink"]       = dualradio("make_symlink", $query_data["make_symlink"]);
        $page["verify_file"]        = dualradio("verify_file", $query_data["verify_file"]);
        $page["allow_no_extension"] = dualradio("allow_no_extension", $query_data["allow_no_extension"]);
        $page["show_hidden_files"]  = dualradio("show_hidden_files", $query_data["show_hidden_files"]);
        $page["group_space"]        = format_bytes($query_data["group_space"]);

        // Sort out the file types
        if ($query_data["access_type"] == DISALLOW)
        {
            $page["access_type"] = $page["access_type_disallowed"];
        }
        else
        {
            $page["access_type"] = $page["access_type_allowed"];
        }

        if (empty($query_data["file_types"]) == true)
        {
            $page["file_types"] = $page["none"];
        }
        else
        {
            $file_permission  = explode(" ", $query_data["file_types"]);

            foreach ($file_permission as $var)
            {
                $extensions[] = $settings["filext.com"] == true ? "<a href=\"http://www.filext.com/detaillist.php?extdetail=" . $var . "\" target=\"_blank\" title=\"" . $page["ext_info"] . "\">" . $var . "</a>" : $var;
            }
            $page["file_types"] = build_list($extensions);
        }

        // Sort out the archiving options
        if ($query_data["archive_save_options"] == SAVE)
        {
            $page["archive_save_options"] = $page["save_archive"];
        }
        else if ($query_data["archive_save_options"] == DOWNL0AD)
        {
            $page["archive_save_options"] = $page["download_archive"];
        }
        else
        {
            $page["archive_save_options"] = $page["both_archive"];
        }

        $page["content"]            = static_template($settings["script_dir"] . "skin/admin/groups/view.tpl", $page);
        $global_tpl                 = "skin/admin/popup.tpl";
    break;
    case "add":
        /* ----------------------------
                Add a new group
           ---------------------------- */
        $page["section_title"]        = $page["section_title"] . $page["add_caption"];
        $page["header_description"]   = $page["add_description"];
        $page["caption"]              = $page["add_caption"];

        $page["next"]                 = "save_add";
    case "edit":
        /* ----------------------------
                  Edit a group
           ---------------------------- */
        if ($input["op"] == "edit")
        {
            $page["section_title"]        = $page["section_title"] . $page["edit_caption"];
            $page["header_description"]   = $page["edit_description"];
            $page["caption"]              = $page["edit_user_group"];

            $page["next"]                 = "save_edit";
        }

        $page["header"]                   = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);


        build_query($queries["get_group_info"], array("GID" => $input["gid"]));
        $result                           = db_query($queries["get_group_info"], $link_id);

        if (db_num_rows($result, $link_id) == 0)
        {
            $page["caption"]              = $page["input_error"];
            $page["msg"]                  = $page["no_such_group"] . "<br /><br />" . $page["go_back"];
            $page["content"]              = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else
        {
            $query_data                   = db_fetch_array($result, $link_id);

            // Populate the fields
            $page["gid"]                  = $query_data["gid"];
            $page["group_space"]          = $query_data["group_space"];
            $page["name"]                 = $input["op"] == "edit" ? $query_data["groupname"] : $page["new_name"];
            $page["ext_list"]             = $query_data["file_types"];

            $page["add_notes"]            = dualRadio("add_notes", $query_data["add_notes"]);
            $page["del_admin_msg"]        = dualradio("del_admin_msg", $query_data["del_admin_msg"]);
            $page["show_url"]             = dualradio("show_url", $query_data["show_url"]);
            $page["use_bookmarks"]        = dualradio("use_bookmarks", $query_data["use_bookmarks"]);
            $page["view_stats"]           = dualradio("view_stats", $query_data["stats"]);
            $page["access_ucp"]           = dualradio("access_ucp", $query_data["access_ucp"]);
            $page["access_acp"]           = dualradio("access_acp", $query_data["access_acp"]);
            $page["offline"]              = dualradio("offline", $query_data["offline"]);
            $page["chmod"]                = dualradio("chmod", $query_data["chmod"]);
            $page["upload"]               = dualradio("upload", $query_data["upload"]);
            $page["download"]             = dualradio("download", $query_data["download"]);
            $page["delete"]               = dualradio("delete", $query_data["delete"]);
            $page["rename"]               = dualradio("rename", $query_data["rename"]);
            $page["lock_dir"]             = dualradio("lock_dir", $query_data["lock_dir"]);
            $page["editor"]               = dualradio("editor", $query_data["editor"]);
            $page["view_source"]          = dualradio("view_source", $query_data["view_source"]);
            $page["view_img"]             = dualradio("view_img", $query_data["view_img"]);
            $page["view_mp3"]             = dualradio("view_mp3", $query_data["mp3"]);
            $page["copy"]                 = dualradio("copy", $query_data["copy"]);
            $page["move"]                 = dualradio("move", $query_data["move"]);
            $page["newfolder"]            = dualradio("newfolder", $query_data["newfolder"]);
            $page["newfile"]              = dualradio("newfile", $query_data["newfile"]);
            $page["overwrite"]            = dualradio("overwrite", $query_data["overwrite"]);
            $page["create_archive"]       = dualradio("create_archive", $query_data["create_archive"]);
            $page["view_archive"]         = dualradio("view_archive", $query_data["view_archive"]);
            $page["make_symlink"]         = dualradio("make_symlink", $query_data["make_symlink"]);
            $page["verify_file"]          = dualradio("verify_file", $query_data["verify_file"]);
            $page["allow_no_extension"]   = dualradio("allow_no_extension", $query_data["allow_no_extension"]);
            $page["show_hidden_files"]    = dualradio("show_hidden_files", $query_data["show_hidden_files"]);

            $page["archive_save_options"] = dropdown("arch_options", array(1 => $page["save_archive"], 2 => $page["download_archive"], 3 => $page["both_archive"]), $query_data["archive_save_options"]);
            $page["allow_type"]           = dropdown("allowed", array(0 => $page["disallow_list"], 1 => $page["allow_list"]), $query_data["access_type"]);

            $page["content"]              = static_template($settings["script_dir"] . "skin/admin/groups/add.tpl", $page);
        }
    break;
    case "save_add":
        /* ----------------------------
                Adds the new group
           ---------------------------- */
        // Check if name exists
        $input["gid"]  = 0;
        $exists        = false;

        $sql           = $queries["add_group"];
    case "save_edit":
        /* ----------------------------
                Edits the group
           ---------------------------- */
        $input["name"]   = preg_replace("/\s{2,}/", " ", $input["name"]);
        $input["types"]  = preg_replace("/\s{2,}/", " ", trim($input["types"]));

        $page["caption"] = $page["input_error"];

        // Check if groupname is unique
        build_query($queries["group_by_name"], array("GROUP" => strtolower($input["name"])));
        $result = db_query($queries["group_by_name"], $link_id);

        while ($query_data = db_fetch_array($result, $link_id))
        {
            if ($query_data["gid"] != $input["gid"])
            {
                $exists = true;
            }
        }

        if (preg_match("/[0-9a-z]/i", $input["name"]) == false || strlen($input["name"]) > 32)
        {
            $page["msg"] = $page["invalid_groupname"] . "<br /><br />" . $page["go_back"];
        }
        else if (preg_match("/^[0-9]+$/", $input["space"]) == false)
        {
            $page["msg"] = $page["invalid_space"] . "<br /><br />" . $page["go_back"];
        }
        else if (empty($input["types"]) == true && $input["allowed"] == ALLOW)
        {
            // Give the group access to a file manager script but access to no files
            // Am I the only one who sees a problem with that?
            $page["msg"] = $input["invalid_types"] . "<br /><br />" . $page["go_back"];
        }
        else if ($exists == true)
        {
            $page["msg"] = $page["group_used"] . "<br /><br />" . $page["go_back"];
        }
        else if ($input["gid"] == 1 && $input["access_acp"] == 0)
        {
            $page["msg"] = $page["admin_acp"] . "<br /><br />" . $page["go_back"];
        }
        else
        {

            // Use update query
            if (isset($sql) == false)
            {
                $sql = $queries["update_group"];
            }

            // Populate fields
            $queryData = array("GID"         => (int) $input["gid"],
                               "GROUP"       => $input["name"],
                               "NOTE"        => $input["add_notes"] == 1 ? 1 : 0,
                               "MSG"         => $input["del_admin_msg"] == 1 ? 1 : 0,
                               "URL"         => $input["show_url"] == 1 ? 1 : 0,
                               "BOOKMARKS"   => $input["use_bookmarks"] == 1 ? 1 : 0,
                               "STATS"       => $input["view_stats"] == 1 ? 1 : 0,
                               "LOCK"        => $input["lock_dir"] == 1 ? 1 : 0,
                               "UCP"         => $input["access_ucp"] == 1 ? 1 : 0,
                               "ACP"         => $input["access_acp"] == 1 ? 1 : 0,
                               "CHMOD"       => $input["chmod"] == 1 ? 1 : 0,
                               "UPLOAD"      => $input["upload"] == 1 ? 1 : 0,
                               "DOWNLOAD"    => $input["download"] == 1 ? 1 : 0,
                               "EDIT"        => $input["editor"] == 1 ? 1 : 0,
                               "SOURCE"      => $input["view_source"] == 1 ? 1 : 0,
                               "IMG"         => $input["view_img"] == 1 ? 1 : 0,
                               "MP3"         => $input["view_mp3"] == 1 ? 1 : 0,
                               "DELETE"      => $input["delete"] == 1 ? 1 : 0,
                               "RENAME"      => $input["rename"] == 1 ? 1 : 0,
                               "COPY"        => $input["copy"] == 1 ? 1 : 0,
                               "MOVE"        => $input["move"] == 1 ? 1 : 0,
                               "MKDIR"       => $input["newfolder"] == 1 ? 1 : 0,
                               "MKFILE"      => $input["newfile"] == 1 ? 1 : 0,
                               "OVERWRITE"   => $input["overwrite"] == 1 ? 1 : 0,
                               "MKARC"       => $input["create_archive"] == 1 ? 1 : 0,
                               "ARCHIVE"     => $input["view_archive"] == 1 ? 1 : 0,
                               "ARC_OPTIONS" => $input["arch_options"] <= 3 ? $input["arch_options"] : 1,
                               "SYMLINK"     => $input["make_symlink"] == 1 ? 1 : 0,
                               "MD5"         => $input["verify_file"] == 1 ? 1 : 0,
                               "SPACE"       => (int) $input["space"],
                               "HIDDEN"      => $input["hidden"] == 1 ? 1 : 0,
                               "ACCESS"      => $input["allowed"] == 1 ? 1 : 0,
                               "TYPES"       => $input["types"],
                               "NOEXT"       => $input["allow_no_extension"] == 1 ? 1 : 0,
                               "OFFLINE"     => $input["offline"] == 1 ? 1 : 0
                         );

            build_query($sql, $queryData);
            $result     = db_query($sql, $link_id);

            if (empty($result) == true)
            {
                $page["caption"]  = $input["server_error"];
                $page["msg"]      = $input["op"] == "save_edit" ? $page["update_error"] : $page["add_error"] . "<br /><br />" . $page["go_back"];
            }
            else
            {
                $page["caption"]  = $input["op"] == "save_edit" ? $page["edit_user_group"] : $page["add_caption"];
                $page["msg"]      = $input["op"] == "save_edit" ? $page["edit_done"] : $page["add_done"];
            }
        }
        $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    case "del":
        /* ----------------------------
                Confirm deletion
           ---------------------------- */
        $page["section_title"]      = $page["section_title"] . $page["delete_caption"];
        $page["header_description"] = $page["delete_description"];

        $page["caption"]            = $page["input_error"];

        if ($input["id"] <= 3)
        {
            $page["msg"]     = $page["protected_group"] . "<br /><br />" . $page["go_back"];
            $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else if ($input["id"] == $settings["default_group"])
        {
            $page["msg"]     = $page["default_group"] . "<br /><br />" . $page["go_back"];
            $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else
        {
            $page["header"]          = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

            build_query($queries["total_in_group"], array("GID" => (int) $input["id"]));
            $result     = db_query($queries["total_in_group"], $link_id);
            $query_data = db_fetch_array($result, $link_id);

            // Populate the fields
            $page["gid"]             = $input["id"];
            $page["total"]           = $query_data["total"] > 0 ? $query_data["total"] : 0;
            $page["confirm_delete"]  = str_replace("<%GROUP%>", $query_data["groupname"], $page["confirm_delete"]);

            // Get the group list
            $result = db_query($queries["group_list"], $link_id);

            $groups = array();
            while ($query_data = db_fetch_array($result, $link_id))
            {
                if ($query_data["gid"] != (int) $input["id"])
                {
                    $groups[$query_data["gid"]] = $query_data["groupname"];
                }
            }

            // Populate the fields
            $page["mgroup_dropdown"] = dropdown("mgroup", $groups, $settings["default_group"]);

            $page["content"]         = static_template($settings["script_dir"] . "skin/admin/groups/delete.tpl", $page);
        }
    break;
    case "do_delete":
        /* ----------------------------
            Actually delete the group
           ---------------------------- */
        $page["section_title"]      = $page["section_title"] . $page["delete_caption"];

        if ($input["gid"] == $input["mgroup"])
        {
            $page["caption"] = $page["input_error"];
            $page["msg"]     = $page["source_is_target"] . "<br /><br />" . $page["go_back"];
        }
        else
        {
            build_query($queries["move_groups"], array("NEW" => (int) $input["mgroup"], "GID" => (int) $input["id"]));
            $result = db_query($queries["move_groups"], $link_id);

            if (empty($result) == true)
            {
                $page["caption"] = $page["server_error"];
                $page["msg"]     = $page["update_error"];
            }
            else
            {
                build_query($queries["delete_group"], array("GID" => (int) $input["id"]));
                $result = db_query($queries["delete_group"], $link_id);

                if (empty($result) == true)
                {
                    $page["caption"] = $page["server_error"];
                    $page["msg"]     = $page["delete_error"];
                }
                else
                {
                    $page["caption"] = $page["group_gone"];
                    $page["msg"]     = $page["deleted"];
                }
            }
        }

        $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    default:
        /* ----------------------------
                 Manage groups
           ---------------------------- */
        $page["section_title"]        = $page["section_title"] . $page["manage_caption"];
        $page["header_description"]   = $page["manage_description"];
        $page["header"]               = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        // Get the blocks from the template file and then parse them
                $blocks = get_blocks($settings["script_dir"] . "skin/admin/groups/manage.tpl", array("groups"));

        // Get the group list
        $result = db_query($queries["group_total"], $link_id);

        $blocks["tmp"] = "";
        $groups        = array();
        while ($query_data = db_fetch_array($result, $link_id))
        {
            $groups[$query_data["gid"]] = $query_data["groupname"];

            $query_data["acp"] = $query_data["access_acp"] == 1 ? $page["yes"] : $page["no"];

            $query_data["del"] = "&nbsp;";
            if ($query_data["gid"] > 3)
            {
                $query_data["del"] = "<a href=\"admin.php?act=grp&op=del&id=" . $query_data["gid"] . "\">" . $page["delete_group"] . "</a>";
            }
            else
            {
                $query_data["del"] = $page["preset"];
            }

            $blocks["tmp"] .= parse_html($query_data, $blocks["groups"]);
        }
        $blocks["groups"] = $blocks["tmp"];

        // Populate the fields
        $page["mgroup_dropdown"]       = dropdown("gid", $groups, $settings["default_group"]);

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/groups/manage.tpl", $blocks));
}

?>