<?php

/*
 * Invision Power File Manager
 * ACP main menu
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 25th November 2004
 *
 */

require $settings["script_dir"] . "settings/sys/menu.inc.php";

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

switch ($input["op"])
{
    case "menu":
        /* ----------------------------
                    Main menu
           ---------------------------- */
        $showitems = array();

        if (empty($_COOKIE["ipfm_admin_menu"]) == false)
        {
             $showitems = explode(",", $_COOKIE["ipfm_admin_menu"]);
        }

        // Get the blocks from the template file and then parse them
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/menu.tpl", array("categories"));

        $blocks["tmp"] = "";
        foreach ($ACP["pages"] as $key => $var)
        {
            $page["key"]            = $key;
            $page["cat"]            = $ACP["cats"][$key];
            $page["description"]    = $ACP["desc"][$key];

            if (in_array($key, $showitems) == true)
            {
                $page["desc_display"]  = "none";
                $page["items_display"] = "block";
                $page["img"]           = "minus";
            }
            else
            {
                $page["desc_display"]  = "block";
                $page["items_display"] = "none";
                $page["img"]           = "plus";
            }

            $page["items"] = "";
            foreach ($ACP["pages"][$key] as $key => $var)
            {
                $page["items"] .= "<a href=\"admin.php?" . $var[1] . "\" target=\"main\">" . $var[0] . "</a><br />";
            }

            $blocks["tmp"] .= parse_html($page, $blocks["categories"]);
        }

        $blocks["categories"] = $blocks["tmp"];

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/menu.tpl", $blocks));

        $page["js"]      = "admenu";
    break;
    case "main":
        /* ----------------------------
                    Main pages
           ---------------------------- */
        $page["header"]  = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        $page["version"] = $version;
        $page["php"]     = PHP_VERSION;
        $page["sql"]     = db_version($link_id);
        $page["dbhome"]  =  $dbhome;

        // Get the blocks from the template file and then parse them
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/index.tpl", array("warning", "rating"));

        // Now to check for the installer
        if (file_exists($settings["script_dir"] . "install.php") == true)
        {
            // Installer exists! Better see if its locked
            if (file_exists($settings["script_dir"] . "install.lock") == true)
            {
                $page["warning_title"]   = $page["safe_warning"];
                $page["warning_message"] = $page["safe_message"];
            }
            else
            {
                $page["warning_title"]   = $page["danger_warning"];
                $page["warning_message"] = $page["danger_message"];
            }

            $blocks["warning"] = parse_html($page, $blocks["warning"]);
            $blocks["rating"]  = "";
        }
        else
        {
            $blocks["warning"] = "";
        }

        // Get the total member count
        $result = db_query($queries["total_members"], $link_id);
        $page["total_members_value"] = db_num_rows($result, $link_id) - 1; // No need to count the "guest" account

        // Get the waiting for validation count
        $result = db_query($queries["total_validate"], $link_id);
        $page["waiting_validation_value"] = db_num_rows($result, $link_id);

        $page["note"] = empty($settings["notepad"]) == true ? htmlspecialchars($page["note_default"]) : htmlspecialchars($settings["notepad"]);
        $page["vid"] = $version_id;

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/index.tpl", $blocks));
    break;
    default:
        /* ----------------------------
                Frames templates
           ---------------------------- */
        error_reporting(0);
        // No page has been called so we are using the frame page
        $global_tpl = "skin/admin/frames.tpl";
}

?>