<?php

/*
 * Invision Power File Manager
 * Misc screens
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 26th February 2005
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

$newIcons = 10; // Number of icon upload fields to show
$newLangs = 3;  // Number of language upload fields to show (should be lower than icons as they are alot larger)

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */
switch ($input["op"])
{
    case "bytes":
        /* ----------------------------
                 Bytes convertor
           ---------------------------- */
        $page["title"]   = $page["calc"];
        $page["content"] = static_template($settings["script_dir"] . "skin/admin/misc/convert.tpl", $page);
        $global_tpl      = "skin/admin/popup.tpl";
    break;
    case "view":
        /* ----------------------------
                 Log in as a user
           ---------------------------- */
        build_query($queries["get_guest_info"], array("UID" => (int) $input["id"]));
        $result = db_query($queries["get_guest_info"], $link_id);

        if (db_num_rows($result, $link_id) != 1)
        {
            // Lets go home
            go_to($settings["script_url"] . "admin.php?act=idx&op=main");
        }
        else if ($input["id"] == $settings["default_userid"] && $settings["require_auth"] == false)
        {
            // Go to the FM if the guest account is being used and is allowed, i.e. don't log in
            go_to($settings["script_url"] . "index.php?act=list");
        }
        else
        {
            while ($query_data = db_fetch_array($result, $link_id))
            {
                // Set the cookies
                setcookie($settings["user_cookie"], $query_data["username"]);
                setcookie($settings["pass_cookie"], $query_data["password"]);

                // Redirect to the correct page but don't update the history
                go_to($settings["script_url"] . "index.php?act=list");
            }
        }
    break;
    case "credits":
        /* ----------------------------
                 Show credits
           ---------------------------- */
        $page["caption"]       = $page["credits"];
        $page["section_title"] = $page["section_title"] . $page["credits"];

        $page["msg"] = "<div><strong>Author:</strong> Stephen Ball</div><br /><div>I would like to thank Charles, Matt and the rest of the IPS crew for putting up with me and keeping me motivated.<br /><br />Special thanks to: <blockquote>aent, zanthria, adamb10, Trel, empirex, Michael Scott, Starnox, Scoz, CTerry, Germany, themission, wikel, maccrazy, CrEaTi0n, mt2, KriTenKs, skenmy, Bry, bigreddog, SonG0han, athlonkmf, Michael Merritt, DonWilson, ryguy2008, Andrew, timdorr, FormulaC, volrathxp, cgriego, Tom, Apyone, Karl &amp; bgrd</blockquote> for their support, feedback and feed suggestions. (P.S. Sorry if I missed you out)</div>";

        $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    case "env":
        /* ----------------------------
                  Show PHP Info
           ---------------------------- */
        phpinfo();
        exit;
    break;
    case "upload":
        /* ----------------------------
                  File uploader
           ---------------------------- */
        // Get the blocks from the template file and then parse them
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/misc/upload.tpl", array("uploads"));

        if ($input["type"] == "icons")
        {
            $toUpload                   = $newIcons;
            $page["type"]               = "icons";
            $page["header_description"] = $page["icon_description"];
            $page["upload_caption"]     = $page["icon_title"];
            $page["filename"]           = $page["icon_input"];
        }
        else
        {
            $toUpload                   = $newLangs;
            $page["type"]               = "langs";
            $page["header_description"] = $page["lang_description"];
            $page["upload_caption"]     = $page["lang_title"];
            $page["filename"]           = $page["lang_input"];
        }

        $page["section_title"] = $page["section_title"] . $page["upload_caption"];

        $page["header"] = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        $blocks["tmp"] = "";
        for ($i=1; $i<=$toUpload; $i++)
        {
            $data["filename"] = str_replace("<%ID%>", $i, $page["filename"]);
            $blocks["tmp"] .= parse_html($data, $blocks["uploads"]);
        }
        $blocks["uploads"] = $blocks["tmp"];

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/misc/upload.tpl", $blocks));
    break;
    case "save":
        /* ----------------------------
                  Upload the files
           ---------------------------- */
        // Get the blocks from the template file and then parse them
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/misc/saved.tpl", array("uploads"));

        $x      = 0;

        if ($input["type"] == "icons")
        {
            $toUpload                   = $newIcons;
            $upDir                      = $settings["script_dir"] . "images/icons/";
            $nameMatch                  = "/\.gif$|\.png$/i";

            $page["caption"]            = $page["icon_title"];
            $page["header_description"] = $page["lang_upload_results"];
        }
        else
        {
            $toUpload                   = $newLangs;
            $upDir                      = $settings["script_dir"] . "languages/";
            $nameMatch                  = "/\.tar$/i";

            $page["caption"]            = $page["lang_title"];
            $page["header_description"] = $page["lang_upload_results"];
        }

        $page["section_title"] = $page["section_title"] . $page["caption"];
    
        $page["header"] = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        
        $blocks["tmp"] = "";
        for ($i=0; $i<$toUpload; $i++)
        {
            if ($_FILES["local"]["name"][$i] != "")
            {
                if (preg_match($nameMatch, $_FILES["local"]["name"][$i]) == FALSE)
                {
                    $data["result"] = $page["invalid_upload_type"];
                }
                else if (move_uploaded_file($_FILES["local"]["tmp_name"][$i], $upDir . $_FILES["local"]["name"][$i]) == FALSE)
                {
                    if ($_FILES["local"]["error"][$i] == 1 || $_FILES["local"]["error"][$i] == 2)
                    {
                        $data["result"] = $page["too_large"];
                    }
                    else if ($_FILES["local"]["error"][$i] == 3)
                    {
                        $data["result"] = $page["partially_uploaded"];
                    }
                    else 
                    {
                       $data["result"] = $page["other_upload_error"];
                    }
                }
                else
                {
                    $data["result"] = $page["file_uploaded"];
                } 
                $x++;

                $data["filename"] = basename($_FILES["local"]["name"][$i]);
                $blocks["tmp"] .= parse_html($data, $blocks["uploads"]);
            }
        }

        if ($x == 0)
        {
            $page["caption"] = $page["input_error"];
            $page["msg"]     = $page["no_file_selected"] . "<br />" . $page["go_back"];

            $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else
        {
            $blocks["uploads"] = $blocks["tmp"];

            $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/misc/saved.tpl", $blocks));
        }
    break;
    case "resources":
        // Go to the resources page
        go_to("http://www.invisionfilemanager.com/scripts/resources.php");
    break;
    default:
        // Lets go home
        go_to($settings["script_url"] . "admin.php?act=idx&op=main");
}

$page["js"] = "admisc";

?>