<?php

/*
 * Invision Power File Manager
 * Script settings screen
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 5th December 2004
 *
 */

require $settings["script_dir"] . "settings/sys/skins.inc.php";

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Define Constants
   ----------------------------------------- */
define("VARS", 1);
define("BLOCKS", 2);
define("LANGS", 3);

/* -----------------------------------------
                Module function
   ----------------------------------------- */
function load_lang_as($file)
{
    global $lang_dir, $settings, $permissions;

    if ($file != "")
    {
        require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/" . $file;

        if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$permissions["lang"]] . "/" . $file) == true)
        {
            require $settings["script_dir"] . "languages/" . $lang_dir[$permissions["lang"]] . "/" . $file;
        }
    }

    // Load the 'global' values at the end
    $page["----"] = "----"; // Very dirty messy hack
    require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/config.lng.php";
    require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/common.lng.php";

    if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$permissions["lang"]] . "/config.lng.php") == true)
    {
        require $settings["script_dir"] . "languages/" . $lang_dir[$permissions["lang"]] . "/config.lng.php";
    }

    if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$permissions["lang"]] . "/common.lng.php") == true)
    {
        require $settings["script_dir"] . "languages/" . $lang_dir[$permissions["lang"]] . "/common.lng.php";
    }


    return $page;
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */
switch ($input["op"])
{
    case "list":
        /* ----------------------------
               List the templates
           ---------------------------- */
        $page["section_title"]      = $page["section_title"] . $page["list_caption"];
        $page["header_description"] = $page["list_description"];

        $page["header"]  = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        // Get the blocks from the template file and then parse them
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/skin/list.tpl", array("categories", "shown"));

        // Get the sub block
        preg_match("/<!-- BEGIN DYNAMIC BLOCK: template -->(.+?)<!-- END DYNAMIC BLOCK: template -->/si", $blocks["shown"], $regs);
        $blocks["template"] = $regs[1];
        unset($regs);

        natcasesort($skin["categories"]);

        $blocks["tmp"] = "";
        foreach ($skin["categories"] as $key => $var)
        {
            if ($input["show"] == $key)
            {
                $blocks["rows"] = "";
                $total          = 0;
                foreach ($skin["templates"][$key] as $index => $value)
                {
                    $size  = filesize($settings["script_dir"] . "skin/" . $skin["files"][$index]);
                    $total = $total + $size;

                    $vars  = array("TEMPLATE" => $value,
                                   "CHARS"    => number_format($size),
                                   "FILESIZE" => format_bytes($size),
                                   "TID"      => $index
                             );

                    $blocks["rows"] .= parse_html($vars, $blocks["template"]);
                }

                $vars = array("NAME"           => $skin["categories"][$key],
                              "TOTAL_CHARS"    => number_format($total),
                              "TOTAL_FILESIZE" => format_bytes($total)
                        );

                $blocks["tmp"] .= parse_html($vars, $blocks["shown"]);

                $blocks["tmp"] = preg_replace("/<!-- BEGIN DYNAMIC BLOCK: template -->(.+?)<!-- END DYNAMIC BLOCK: template -->/si", $blocks["rows"], $blocks["tmp"]);
            }
            else
            {
                $vars = array("ID"          => $key,
                              "NAME"        => $skin["categories"][$key],
                              "DESCRIPTION" => $skin["descriptions"][$key],
                              "CHILDREN"    => count($skin["templates"][$key])
                        );

                $blocks["tmp"] .= parse_html($vars, $blocks["categories"]);
            }
        }
        $blocks["shown"]      = "";
        $blocks["categories"] = $blocks["tmp"];

       $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/skin/list.tpl", $blocks));
    break;
    case "edit":
        /* ----------------------------
                Edit the template
           ---------------------------- */
        $page["filename"]           = $settings["script_dir"] . "skin/" . $skin["files"][$input["id"]];

        $page["section_title"]      = $page["section_title"];
        $page["section_title"]      .= $input["id"] > 0 ? $page["html_title"] : $page["css_title"];

        $page["header_description"] = $page["edit_description"];

        if (isset($skin["files"][$input["id"]]) == false)
        {
            $page["caption"] = $page["input_error"];
            $page["msg"]     = $page["no_such_template"] . "<br /><br />" . $page["go_back"];
            $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else if (($fp = fopen($page["filename"], "r")) == false)
        {
            $page["caption"] = $page["server_error"];
            $page["msg"]     = $page["template_read_error"] . "<br /><br />" . $page["go_back"];
            $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else
        {
            $size = filesize($page["filename"]);

            file_lock($fp, LOCK_SH);
            $data = fread($fp, $size);
            file_lock($fp, LOCK_UN);
            fclose($fp);

            if (is_win() == true)
            {
                $page["filename"] = preg_replace("/[\/]/", "\\", $page["filename"]);
            }

            $page["header"]             = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

            // Populate the fields
            $page["skin"]               = make_safe($data);
            $page["id"]                 = $input["id"];
            $page["chars"]              = number_format($size);
            $page["filesize"]           = format_bytes($size);

            // Get the skin template name
            if ($input["id"] == 0)
            {
                $page["name"] = $page["css"];
            }
            else
            {
                foreach($skin["templates"] as $key => $var)
                {
                    foreach ($var as $index => $value)
                    {
                        if ($index == $input["id"])
                        {
                            $page["name"] = $value;
                            break;
                        }
                    }
                }
            }

            // Parse the template
            $blocks                     = get_blocks($settings["script_dir"] . "skin/admin/skin/edit.tpl", array("html", "css"));

            $blocks["html"] = parse_html($page, $blocks["html"]);
            if ($input["id"] == 0)
            {
                $blocks["html"] = "";
                $blocks["css"]  = "";
            }

            $page["content"]            = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/skin/edit.tpl", $blocks));
        }
    break;
    case "save":
        /* ----------------------------
                Save the template
           ---------------------------- */
        $page["section_title"]    = $page["section_title"];
        $page["section_title"]    .= $input["id"] > 0 ? $page["html_title"] : $page["css_title"];

        $page["caption"]          = $page["input_error"];

        $input["body"]            = trim($input["body"]);
        $input["body"]            = make_unsafe($input["body"]); // Check if empty

        // Check that all required variables exist
        $required = false;
        if (isset($skin["required"][$input["id"]]) == true)
        {
            foreach ($skin["required"][$input["id"]] as $var)
            {
                if (preg_match("/<%" . $var . "%>/", $input["body"]) == false)
                {
                    $required = $var;
                    break;
                }
            }
        }

        // Check that all blocks are defined
        $block = false;
        if (isset($skin["sections"][$input["id"]]) == true)
        {
            foreach ($skin["sections"][$input["id"]] as $key => $var)
            {
                $key = strtolower($key);

                if (preg_match("/<!-- BEGIN DYNAMIC BLOCK: " . $key . " -->(.+?)<!-- END DYNAMIC BLOCK: " . strtolower($key) . " -->/s", $input["body"]) == false)
                {
                    $block = $key;
                    break;
                }
            }
        }

        $path = $settings["script_dir"] . "skin/" . $skin["files"][$input["id"]];
        if (empty($input["body"]) == true)
        {
            $page["msg"] = $page["empty_skin"] . "<br /><br />" . $page["go_back"];
        }
        else if (isset($skin["files"][$input["id"]]) == false)
        {
            $page["msg"] = $page["no_such_template"] . "<br /><br />" . $page["go_back"];
        }
        else if ($required != false)
        {
            $page["msg"] = str_replace("<%REQUIRED%>", $required, $page["missing_var"]) . "<br /><br />" . $page["go_back"];
        }
        else if ($block != false)
        {
            $page["msg"] = str_replace("<%REQUIRED%>", $block, $page["missing_block"]) . "<br /><br />" . $page["go_back"];
        }
        else if (($fp = fopen($path, "r")) == false)
        {
            $page["caption"] = $page["server_error"];

            if (is_win() == true)
            {
                $path = preg_replace("/[\/]/", "\\", $path);
            }

            $page["msg"]     = str_replace("<%FILE%>", $path, $page["save_error"]) . "<br /><br />" . $page["go_back"];
        }
        else
        {
            fwrite($fp, $input["body"]);
            fclose($fp);

            $page["caption"] = $page["done"];
            $page["msg"]     = $page["skin_saved"];
        }

        $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    case "help":
        /* ----------------------------
                 Template help
           ---------------------------- */
        $page["title"] = $page["card_title"];

        // Parse the template
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/skin/card.tpl", array("vars", "local", "global"));

        $page["varname"] = $page["var"];
        $page["info"]    = $page["replacement"];

        if ($input["type"] == BLOCKS)
        {
            $page["type"]    = $page["dynamic_blocks"];
            $page["varname"] = $page["name"];
            $page["info"]    = $page["description"];

            $blocks["local"] = "";

            $items = $skin["sections"][$input["id"]];
        }
        else if ($input["type"] == LANGS)
        {
            // Need to load language pack
            $page["type"]   = $page["lang_vars"];
            $page["local"]  = $page["dependent"];
            $page["global"] = $page["global"];

            $items = load_lang_as($skin["languages"][$input["id"]]);

            if (current($items) == "----")
            {
                $blocks["local"] = "";
            }
        }
        else
        {
            $page["type"]   = $page["data_vars"];
            $page["info"]   = $page["description"];
            $page["local"]  = $page["optional"];
            $page["global"] = $page["required"];

            $items = $skin["variables"][$input["id"]];
        }

        if (empty($items) == true)
        {
            $page["content"] = static_template($settings["script_dir"] . "skin/admin/skin/none.tpl", $page);
        }
        else
        {
            if ($input["type"] != VARS)
            {
                // Parse the blocks
                $blocks["tmp"] = "";

                foreach ($items as $key => $var)
                {
                    if ($key == "----")
                    {
                        $blocks["tmp"] .= $blocks["global"];
                    }
                    else
                    {
                        // Change to use the local/global "headers"
                        $var = htmlspecialchars($var);

                        // Enclose in tags if not the dynamic blocks card
                        if ($input["type"] != BLOCKS)
                        {
                            $key = "&lt;%" . strtoupper($key) . "%&gt;";
                        }
                        else
                        {
                            $key = strtolower($key);
                        }

                        $blocks["tmp"] .= parse_html(array("VAR" => $key, "VALUE" => $var), $blocks["vars"]);
                    }
                }
                $blocks["vars"]   = $blocks["tmp"];
                $blocks["global"] = "";
            }
            else
            {
                $blocks["tmp"] = "";

                if (count($skin["required"][$input["id"]]) > 0)
                {
                    $blocks["tmp"] .= $blocks["global"];

                    foreach ($skin["required"][$input["id"]] as $var)
                    {
                        $blocks["tmp"] .= parse_html(array("VAR" => "&lt;%" . strtoupper($var) . "%&gt;", "VALUE" => htmlspecialchars($skin["variables"][$input["id"]][$var])), $blocks["vars"]);

                        unset($skin["variables"][$input["id"]][$var]);
                    }
                }

                $blocks["tmp"] .= $blocks["local"];

                foreach ($skin["variables"][$input["id"]] as $key => $var)
                {
                    $blocks["tmp"] .= parse_html(array("VAR" => "&lt;%" . strtoupper($key) . "%&gt;", "VALUE" => htmlspecialchars($var)), $blocks["vars"]);
                }
                $blocks["vars"]   = $blocks["tmp"];
                $blocks["global"] = "";
                $blocks["local"]  = "";
            }

            $page["content"]  = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/skin/card.tpl", $blocks));
        }
        $global_tpl = "skin/admin/popup.tpl";
    break;
    default:
        // Lets go home
        go_to($settings["script_url"] . "admin.php?act=idx&op=main");
}

$page["js"] = "adskin";

?>