<?php

/*
 * Invision Power File Manager
 * Template Management
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 29th August 2004
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

require $settings["script_dir"] . "settings/templates.inc.php";

/* -----------------------------------------
               Module Functions
   ----------------------------------------- */

// Builds a string of values for the template config file
function build_config($current, $name, $value, $makeSafe = false)
{
    global $input;

    $data = "";

    foreach ($current as $key => $var)
    {
        $tmp = $var;
        if ($key == $input["id"])
        {
            $tmp = $value;
        }

        if ($makeSafe == true)
        {
            $tmp = str_replace('"', '\"', $tmp);
        }

        $data .= "\$templates[\"" . $name . "\"][" . $key . "] = \"" . $tmp . "\";\r\n";
    }

    return $data;
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */
switch ($input["op"])
{
    case "list":
        /* ----------------------------
                List the templates
           ---------------------------- */
        $page["section_title"]        = $page["section_title"] . $page["edit_caption"];
        $page["header_description"]   = $page["edit_description"];
        $page["header"]               = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        load_language(0, "templates");
        natcasesort($templates["description"]);

        $templates["extension"][0] = $settings["default_type"];

        // Get the blocks from the template file and then parse them
        $blocks = get_blocks($settings["script_dir"] . "skin/admin/templates/manage.tpl", array("templates"));

        $blocks["tmp"] = "";
        foreach ($templates["description"] as $key => $var)
        {
            $vars = array("DESCRIPTION" => $key > 0 ? $var : "<a href=\"admin.php?act=lng&amp;op=edit&amp;id=25&amp;lid=" . $settings["default_lang"] . "\">" . $var  . "</a>",
                          "EXT"         => $key > 0 ? $templates["extension"][$key] : "<a href=\"admin.php?act=set&amp;op=edit\">" . $templates["extension"][$key] . "</a>",
                          "DOCS"        => empty($templates["help"][$key]) == true ? $page["none"] : "<a href=\"" . $templates["help"][$key] . "\" target=\"_blank\">" . $templates["help"][$key] . "</a>",
                          "EDIT"        => $key > 0 ? "<a href=\"admin.php?act=temp&amp;op=edit&amp;id=" . $key . "\">" . $page["edit"] . "</a>" : "<a href=\"javascript:void(0);\" onclick=\"info();\">" . $page["info"] . "</a>"
                    );

            $blocks["tmp"] .= parse_html($vars, $blocks["templates"]);
        }
        $blocks["templates"] = $blocks["tmp"];

        $page["content"]              = parse_html($page, dynamic_template($settings["script_dir"] . "skin/admin/templates/manage.tpl", $blocks));
    break;
    case "add":
        /* ----------------------------
                Add a new template
           ---------------------------- */
        $page["section_title"]      = $page["section_title"] . $page["add_caption"];
        $page["header_description"] = $page["add_description"];

        $page["caption"]            = $page["add_caption"];

        $page["header"]             = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        // Populate the fields
        $page["name"]     = "";
        $page["ext"]      = "";
        $page["url"]      = "";
        $page["file"]     = "";
        $page["template"] = "";

        $page["id"]       = 0;
        $page["next"]     = "do_add";

        $page["tpldir"] = $settings["script_dir"] . "templates/";
        if (is_win() == true)
        {
            $page["tpldir"] = preg_replace("/[\/]/", "\\", $page["tpldir"]);
        }

        $page["content"]            = static_template($settings["script_dir"] . "skin/admin/templates/edit.tpl", $page);
    break;
    case "do_add";
        /* ----------------------------
               Save the template
           ---------------------------- */
        $page["section_title"]  = $page["section_title"] . $page["add_caption"];
        $page["caption"]        = $page["input_error"];

        if (preg_match("/^[a-z0-9]+$/i", $input["ext"]) == false)
        {
            $page["msg"] = $page["invalid_extension"] . "<br /><br />" . $page["go_back"];
        }
        else if (preg_match("/^[a-z0-9_]+$/i", $input["file"]) == false)
        {
            $page["msg"] = $page["invalid_file"] . "<br /><br />" . $page["go_back"];
        }
        else if (empty($input["docs"]) == false && preg_match("/^(http|https|ftp)\:\/\/[a-z0-9\-\.]+\.[a-z]{2,}(\:[0-9]+)?(\/\S*)?$/i", $input["docs"]) == false)
        {
            // Original regex /^[a-z]{3,}\:\/\/[a-z0-9\-\.]+\.[a-z]{2,}(\:[0-9]+)?(\/\S*)?$/i
            // but we really don't need anything outside of http, https or ftp
            // the end (\/\S*)? could be modified to check for valid file names but not really worth it in the end
            $page["msg"] = $page["invalid_docs"] . "<br /><br />" . $page["go_back"];
        }
        else if (empty($input["name"]) == true)
        {
            $page["msg"] = $page["invalid_name"] . "<br /><br />" . $page["go_back"];
        }
        else if (in_array($input["file"], $templates["filename"]) == true)
        {
            $page["msg"] = $page["file_exists"] . "<br /><br />" . $page["go_back"];
        }
        else
        {
            $page["caption"] = $page["server_error"];

            if (($fp = fopen($settings["script_dir"] . "templates/" . $input["file"] . ".tpl", "w")) == false)
            {
                $page["msg"] = $page["save_template_error"] . "<br /><br />" . $page["go_back"];
            }
            else
            {
                file_lock($fp);
                fwrite($fp, make_unsafe($input["body"]));
                file_lock($fp, LOCK_UN);
                fclose($fp);

                // Template written now for the language file
                load_language(0, "templates");

                $data = "<?php\r\n\r\n";
                foreach ($templates["description"] as $key => $var)
                {
                    $data .= "\$templates[\"description\"][" . $key . "] = \"" . $var . "\";\r\n";
                }
                $new = $key + 1;

                $data .= "\$templates[\"description\"][" . $new . "] = \"" . $input["name"] . "\";\r\n";

                $data .= "\r\n?>";


                if (($fp = fopen($settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/templates.lng.php", "w")) == false)
                {
                    $page["msg"] = $page["save_lang_error"] . "<br /><br />" . $page["go_back"];
                }
                else
                {
                    file_lock($fp);
                    fwrite($fp, $data);
                    file_lock($fp, LOCK_UN);
                    fclose($fp);

                    // Build the template configuration file
                    $templates["extension"][$new] = $input["ext"];
                    $templates["filename"][$new]  = $input["file"];
                    $templates["help"][$new]      = str_replace('"', '\"', $input["docs"]);

                    $data = "<?php\r\n\r\n";
                    $data .= build_config($templates["extension"], "extension", "") . "\r\n";
                    $data .= build_config($templates["filename"], "filename", "") . "\r\n";
                    $data .= build_config($templates["help"], "help", "") . "\r\n";
                    $data .= "?>";

                    // Language file updated, finally update the template configuration file
                    if (($fp = fopen($settings["script_dir"] . "settings/templates.inc.php", "w")) == false)
                    {
                        $page["msg"] = $page["save_config_error"] . "<br /><br />" . $page["go_back"];
                    }
                    else
                    {
                        file_lock($fp);
                        fwrite($fp, $data);
                        file_lock($fp, LOCK_UN);
                        fclose($fp);

                        $page["caption"] = $page["done"];
                        $page["msg"]     = $page["template_saved"];
                    }
                }
            }
        }

        $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    case "edit":
        /* ----------------------------
                 Edit the template
           ---------------------------- */
        $page["section_title"]      = $page["section_title"] . $page["edit_caption"];
        $page["header_description"] = $page["change_description"];

        $page["caption"]            = $page["edit_caption"];

        if ($input["id"] == 0 || isset($templates["filename"][$input["id"]]) == false)
        {
             $page["caption"] = $page["input_error"];
             $page["msg"]     = $page["invalid_template"] . "<br /><br />" . $page["go_back"];

             $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
        }
        else
        {
            if (($fp = fopen($settings["script_dir"] . "templates/" . $templates["filename"][$input["id"]] . ".tpl", "r")) == false)
            {
                $page["caption"] = $page["server_error"];
                $page["msg"]     = $page["error_loading_template"] . "<br /><br />" . $page["go_back"];

                $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
            }
            else
            {
                $data = fread($fp, filesize($settings["script_dir"] . "templates/" . $templates["filename"][$input["id"]] . ".tpl") + 1);
                fclose($fp);

                load_language(0, "templates");

                $page["header"]   = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

                // Populate the fields
                $page["name"]     = $templates["description"][$input["id"]];
                $page["ext"]      = $templates["extension"][$input["id"]];
                $page["url"]      = $templates["help"][$input["id"]];
                $page["file"]     = $templates["filename"][$input["id"]];
                $page["template"] = make_safe($data);

                $page["id"]       = $input["id"];
                $page["next"]     = "do_edit";

                $page["tpldir"] = $settings["script_dir"] . "templates/";
                if (is_win() == true)
                {
                    $page["tpldir"] = preg_replace("/[\/]/", "\\", $page["tpldir"]);
                }

                $page["content"]  = static_template($settings["script_dir"] . "skin/admin/templates/edit.tpl", $page);
            }
        }
    break;
    case "do_edit":
        /* ----------------------------
               Update the template
           ---------------------------- */
        $page["section_title"]  = $page["section_title"] . $page["edit_caption"];
        $page["caption"]        = $page["input_error"];

        if ($input["id"] == 0 || isset($templates["filename"][$input["id"]]) == false)
        {
             $page["msg"] = $page["invalid_template"] . "<br /><br />" . $page["go_back"];
        }
        else if (preg_match("/^[a-z0-9]+$/i", $input["ext"]) == false)
        {
            $page["msg"] = $page["invalid_extension"] . "<br /><br />" . $page["go_back"];
        }
        else if (preg_match("/^[a-z0-9_]+$/i", $input["file"]) == false)
        {
            $page["msg"] = $page["invalid_file"] . "<br /><br />" . $page["go_back"];
        }
        else if (empty($input["docs"]) == false && preg_match("/^(http|https|ftp)\:\/\/[a-z0-9\-\.]+\.[a-z]{2,}(\:[0-9]+)?(\/\S*)?$/i", $input["docs"]) == false)
        {
            // Original regex /^[a-z]{3,}\:\/\/[a-z0-9\-\.]+\.[a-z]{2,}(\:[0-9]+)?(\/\S*)?$/i
            // but we really don't need anything outside of http, https or ftp
            // the end (\/\S*)? could be modified to check for valid file names but not really worth it in the end
            $page["msg"] = $page["invalid_docs"] . "<br /><br />" . $page["go_back"];
        }
        else if (empty($input["name"]) == true)
        {
            $page["msg"] = $page["invalid_name"] . "<br /><br />" . $page["go_back"];
        }
        else if (in_array($input["file"], $templates["filename"]) == true && $templates["filename"][$input["id"]] != $input["file"])
        {
            $page["msg"] = $page["file_exists"] . "<br /><br />" . $page["go_back"];
        }
        else
        {
            $page["caption"] = $page["server_error"];

            if (($fp = fopen($settings["script_dir"] . "templates/" . $input["file"] . ".tpl", "w")) == false)
            {
                $page["msg"] = $page["save_template_error"] . "<br /><br />" . $page["go_back"];
            }
            else
            {
                file_lock($fp);
                fwrite($fp, make_unsafe($input["body"]));
                file_lock($fp, LOCK_UN);
                fclose($fp);

                // Template written now for the language file
                load_language(0, "templates");

                $data = "<?php\r\n\r\n";
                foreach ($templates["description"] as $key => $var)
                {
                    if ($key == $input["id"])
                    {
                        $var = $input["name"];
                    }

                    $data .= "\$templates[\"description\"][" . $key . "] = \"" . $var . "\";\r\n";
                }
                $data .= "\r\n?>";

                if (($fp = fopen($settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/templates.lng.php", "w")) == false)
                {
                    $page["msg"] = $page["save_lang_error"] . "<br /><br />" . $page["go_back"];
                }
                else
                {
                    file_lock($fp);
                    fwrite($fp, $data);
                    file_lock($fp, LOCK_UN);
                    fclose($fp);

                    // Build the template configuration file
                    $data = "<?php\r\n\r\n";
                    $data .= build_config($templates["extension"], "extension", $input["ext"]) . "\r\n";
                    $data .= build_config($templates["filename"], "filename", $input["file"]) . "\r\n";
                    $data .= build_config($templates["help"], "help", $input["docs"], true) . "\r\n";
                    $data .= "?>";

                    // Language file updated, finally update the template configuration file
                    if (($fp = fopen($settings["script_dir"] . "settings/templates.inc.php", "w")) == false)
                    {
                        $page["msg"] = $page["save_config_error"] . "<br /><br />" . $page["go_back"];
                    }
                    else
                    {
                        file_lock($fp);
                        fwrite($fp, $data);
                        file_lock($fp, LOCK_UN);
                        fclose($fp);

                        $page["caption"] = $page["done"];
                        $page["msg"]     = $page["template_updated"];
                    }
                }
            }
        }

        $page["content"] = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    case "del":
        /* ----------------------------
               Show the delete form
           ---------------------------- */
        $page["section_title"]      = $page["section_title"] . $page["delete_caption"];
        $page["header_description"] = $page["delete_description"];

        $page["header"]             = static_template($settings["script_dir"] . "skin/admin/header.tpl", $page);

        // Sort out the drop down
        load_language(0, "templates");
        unset($templates["description"][0]);
        natcasesort($templates["description"]);

        $page["templates"]          = dropdown("tid", $templates["description"]);

        $page["content"]            = static_template($settings["script_dir"] . "skin/admin/templates/delete.tpl", $page);
    break;
    case "do_delete";
        /* ----------------------------
               Delete the template
           ---------------------------- */
        $page["section_title"] = $page["section_title"] . $page["delete_caption"];

        if ($input["tid"] == 0 || isset($templates["filename"][$input["tid"]]) == false)
        {
             $page["caption"] = $page["input_error"];
             $page["msg"]     = $page["invalid_template"] . "<br /><br />" . $page["go_back"];
        }
        else
        {
            $page["caption"] = $page["server_error"];

            // Template written now for the language file
            load_language(0, "templates");

            $data = "<?php\r\n\r\n";
            foreach ($templates["description"] as $key => $var)
            {
                if ($key != $input["tid"])
                {
                    $data .= "\$templates[\"description\"][" . $key . "] = \"" . $var . "\";\r\n";
                }
            }
            $data .= "\r\n?>";

            if (($fp = fopen($settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/templates.lng.php", "w")) == false)
            {
                $page["msg"] = $page["save_lang_error"] . "<br /><br />" . $page["go_back"];
            }
            else
            {
                file_lock($fp);
                fwrite($fp, $data);
                file_lock($fp, LOCK_UN);
                fclose($fp);

                $file = $templates["filename"][$input["tid"]];

                // Remove the related entries
                unset($templates["extension"][$input["tid"]]);
                unset($templates["filename"][$input["tid"]]);
                unset($templates["help"][$input["tid"]]);

                // Build the template configuration file
                $data = "<?php\r\n\r\n";
                $data .= build_config($templates["extension"], "extension", "") . "\r\n";
                $data .= build_config($templates["filename"], "filename", "") . "\r\n";
                $data .= build_config($templates["help"], "help", "") . "\r\n";
                $data .= "?>";

                // Language file updated, finally update the template configuration file
                if (($fp = fopen($settings["script_dir"] . "settings/templates.inc.php", "w")) == false)
                {
                    $page["msg"] = $page["save_config_error"] . "<br /><br />" . $page["go_back"];
                }
                else
                {
                    file_lock($fp);
                    fwrite($fp, $data);
                    file_lock($fp, LOCK_UN);
                    fclose($fp);

                    $page["caption"] = $page["done"];

                    if (unlink($settings["script_dir"] . "templates/" . $file . ".tpl") == false)
                    {
                        $page["msg"] = $page["delete_template_error"];
                    }
                    else
                    {
                        $page["msg"] = $page["template_deleted"];
                    }
                }
            }
        }

        $page["content"]       = static_template($settings["script_dir"] . "skin/admin/msg.tpl", $page);
    break;
    default:
        // Lets go home
        go_to($settings["script_url"] . "admin.php?act=idx&op=main");
}

$page["js"] = "adtemp";

?>