<?php

/*
 * Invision Power File Manager
 * Code library
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 25th February 2005
 *
 */

$version            = "2 PDR3";
$version_id         = "200b3";
$debug["copyright"] = $settings["license"] == 1 ? "" : "<div class=\"copyright\"><%POWERED%> <a href=\"http://www.invisionfilemanager.com\" target=\"_blank\">Invision Power File Manager</a> v" . $version . " &copy; " . date("Y"). " <a href=\"http://www.invisionpower.com\" target=\"_blank\">Invision PS, Inc</a>.</div>";

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Define Constants
   ----------------------------------------- */
define("DISALLOW", 0);          // File permissions
define("ALLOW", 1);

define("LOCATION", 0);          // Redirect type
define("REFRESH", 1);
define("HTML", 2);

define("LINK", 1);              // Icon types
define("LOCK", 2);
define("BOTH", 3);

define("NO_LINK", 0);           // Icon links
define("LINK_TO_URL", 1);
define("LINK_TO_FM", 2);

define("SAVE", 1);              // Archiving options
define("DOWNLOAD", 2);
define("SAVE_AND_DOWNLOAD", 3);

define("AUTH_NONE", 0);         // Validation options
define("AUTH_EMAIL", 1);
define("AUTH_ADMIN", 2);
define("AUTH_BOTH", 3);
define("LOST_PASS", 4);

/* -----------------------------------------
             Debugging Functions
   ----------------------------------------- */

// Returns the time that execution began
function start_clock()
{
    $mtime      = microtime();
    $mtime      = explode(" ",$mtime);
    $mtime      = $mtime[1] + $mtime[0];

    return $mtime;
}

// Returns the time that execution ended
function stop_clock($starttime)
{
    $mtime     = microtime();
    $mtime     = explode(" ",$mtime);
    $mtime     = $mtime[1] + $mtime[0];
    $totaltime = ($mtime - $starttime);

    return round($totaltime, 3);
}

// Defines a constant if it is not defined
function define_constant($constant, $value)
{
    if (defined($constant) == false)
    {
        define($constant, $value);
    }

    return;
}

/* -----------------------------------------
      User permission dependent functions
   ----------------------------------------- */

// Generates the tools links
function tool_links()
{
    global $permissions, $page, $settings;

    $html = ($permissions["ucp"] == 1 || $permissions["use_bookmarks"] == 1 || $permissions["stats"] == 1) ? "<a href=\"index.php?act=cp\">" . $page["cp"] . "</a> " . $page["seperator"] . " " : "";
    $html .= "<a href=\"index.php\">" . $page["home"] . "</a> " . $page["seperator"] . " <a href=\"javascript:open_window('index.php?act=card&amp;id=leg', 500, 400, 0);\">" . $page["legend"] . "</a>";
    $html .= empty($permissions["sql"]) == false ? " " . $page["seperator"] . " <a href=\"index.php?act=db\">" . $page["database"] . "</a>" : ""; // Can the user access MySQL?

    return $html;
}

// Generates the area links
function area_links()
{
    global $permissions, $page, $settings;

    $html = "<a href=\"index.php?act=login&amp;op=out\">" . $page["out"] . "</a>";

    // If the user is not logged in, show the login link
    if ($settings["require_auth"] == false && empty($_COOKIE[$settings["user_cookie"]]) == true)
    {
        $html = "<a href=\"index.php?act=login\">" . $page["in"] . "</a>";

        if ($settings["allow_reg"] == true)
        {
            $html .= " " . $page["seperator"] . " <a href=\"index.php?act=reg\">" . $page["register"] . "</a>";
        }
    }

    $html .= $permissions["admin"] == 1 ? " " . $page["seperator"] . " <a href=\"admin.php\" target=\"_blank\">" . $page["admin"] . "</a>" : ""; // Can the user access the ACP

    return $html;
}

// Generates the tools link for a file/folder
function file_tool_link($entry, $dir, $is_dir = false, $this = "")
{
    global $permissions, $settings, $page;

    if ($is_dir == true)
    {
        // Build the folder options links, messy but the only way I could think to do it so that the correct number of seperators showed up
        $tools = $permissions["htpasswd"] == 1 && preg_match("/apache/i", $_SERVER["SERVER_SOFTWARE"]) == true ? "(<a href=\"javascript:lock('" . str_replace("'", "\\'", $this) . "', '" . str_replace("'", "\\'", $entry) . "');\">" . $page["protect"] . "</a>" : "(";

        // Check that the root url is set, add the open URL option, with a seperator if the password option is shown
        if (empty($permissions["root_url"]) == false && $permissions["show_url"] == 1)
        {
            $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
            $tools .= "<a href=\"" . $permissions["root_url"] . relative_path($entry, $dir, 1) . "/\" target=\"_blank\">" . $page["open_url"] . "</a>";
        }

        // Check that the user can use bookmarks, if so add the option, with a seperator if the password or URL option is shown
        if ($permissions["bookmark"] == 1)
        {
            $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
            $tools .= "<a href=\"javascript:bookmark('" . str_replace("'", "\\'", $this) . "', '" . str_replace("'", "\\'", $entry) . "');\">" . $page["bookmark"] . "</a>";
        }

        $tools .= ")";
    }
    else
    {
        $tools = "(";

        if (is_ascii($entry) == true)
        {
            $tools .= file_permission($entry) == true && $permissions["edit"] == 1 ? "<a href=\"index.php?act=edit&amp;target=" . relative_path($entry, $dir, 1) . "\">" . $page["edit"] . "</a>" : "";

            // Check that the user can view source, add a seperator if the edit option is shown
            if (file_permission($entry) == true && $permissions["source"] == 1)
            {
                $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
                $tools .= "<a href=\"javascript:open_window('index.php?act=source&amp;target=" . str_replace("'", "\'", relative_path($entry, $dir, 1)) . "', 650, 500);\">" . $page["view_source"] . "</a>";
            }
        }
        else
        {
            // Check that the user can view images
            if (file_permission($entry) == true && $permissions["view_img"] == 1 && is_image($entry) == true)
            {
                $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
                $tools .= "<a href=\"index.php?act=img&amp;target=" . relative_path($entry, $dir) . "\" target=\"_blank\">" . $page["view_image"] . "</a>";
            }
            else if (file_permission($entry) == true && $permissions["mp3"] == 1 && preg_match("/\.mp3$/i", $entry) == true)
            {
                $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
                $tools .= "<a href=\"javascript:open_window('index.php?act=mp3&amp;target=" . str_replace("'", "\'", relative_path($entry, $dir, 1)) . "', 650, 500);\">" . $page["view_mp3"] . "</a>";
            }
        }

        // Check that the root url is set, add the open URL option, with a seperator if the edit or view option is shown
        if (empty($permissions["root_url"]) == false && $permissions["show_url"] == 1)
        {
            $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
            $tools .= "<a href=\"" . $permissions["root_url"] . relative_path($entry, $dir, 1) . "\" target=\"_blank\">" . $page["open_url"] . "</a>";
        }

        // Check that the user has access to the file
        if (file_permission($entry) == true && $permissions["verify"] == 1)
        {
            $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
            $tools .= "<a href=\"javascript:open_window('index.php?act=card&amp;id=ver&amp;target=" . relative_path($entry, $dir) . "', 650, 350);\">" . $page["verify"] . "</a>";
        }

        $types = array_keys(get_archives_types(1));

        // Check that the user has access to extract the file
        if (file_permission($entry) == true && $permissions["view_arc"] == 1 && in_array(ext($entry), $types) == true)
        {
            $tools .= strlen($tools) > 1 ? " " . $page["seperator"] . " " : "";
            $tools .= "<a href=\"javascript:extractor('" . str_replace("'", "\'", $entry) . "');\">" . $page["extract"] . "</a>";
        }

        $tools .= ")";
    }

    if (strlen($tools) == 2)
    {
       return "";
    }

    return $tools;
}

/* -----------------------------------------
           File Information Functions
   ----------------------------------------- */

// Gets a list of the valid archive types
// function get_archives_types($type = 0)
function get_archives_types($extracting = 0)
{
    global $settings;

    $types = array();

    if (file_permission("tmp.tar") == true)
    {
        $types["tar"] = ".tar";
    }

    // Check if ZLib (GZip/Zip) is supported
    if (extension_loaded("zlib") == true)
    {
        if (in_array("tgz", $settings["types"]) == true)
        {
            if (file_permission("tmp.gz") == true)
            {
                $types["gz"] = ".tar.gz";
            }

            if (file_permission("tmp.tgz") == true)
            {
                $types["tgz"] = ".tgz";
            }
        }
    }

    // When extracting zip files we need the zip library, when creating we need the zlib library
    if (($extracting == 1 && extension_loaded("zip") == true) || ($extracting == 0 && extension_loaded("zlib") == true))
    {
        if (in_array("zip", $settings["types"]) == true && file_permission("tmp.zip") == true)
        {
            $types["zip"] = ".zip";
        }
    }

    // Check if BZip2 is supported
    if (extension_loaded("bz2") == true && in_array("bz2", $settings["types"]) == true && file_permission("tmp.bz2") == true)
    {
        $types["bz2"] = ".tar.bz2";
    }

    return $types;
}
// Gets the extension of a file
function ext($file)
{
    $temparray = explode(".", $file);
    $extension = strtolower($temparray[count($temparray) - 1]);

    // There is no extension
    if (isset($temparray[1]) == false)
    {
        return "";
    }

    return $extension;
}

// Gets the icon for the file extension
function get_icon($file, $overlay = 0)
{
    global $settings;

    reset($settings["icons"]);

    $extension = ext($file);
    if (empty($extension) == true)
    {
        if ($overlay == LINK)
        {
            return "<img src=\"images/link-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/unknown.gif');\" class=\"icon\" />";
        }
        else if ($overlay == LOCK)
        {
            return "<img src=\"images/lock-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/unknown.gif');\" class=\"icon\" />";
        }
        else if ($overlay == BOTH)
        {
            return "<img src=\"images/locked-link-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/unknown.gif');\" class=\"icon\" />";
        }
        else
        {
            return "<img src=\"images/icons/unknown.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" class=\"icon\" />";
        }
    }

    while(list($key, $value) = each($settings["icons"]))
    {
        $iconlist = explode(" ", $value);
        foreach($iconlist as $icon)
        {
            if ($icon == $extension)
            {
                if ($overlay == LINK)
                {
                    return "<img src=\"images/link-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/" . $key . "');\" class=\"icon\" />";
                }
                else if ($overlay == LOCK)
                {
                    return "<img src=\"images/lock-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/" . $key . "');\" class=\"icon\" />";
                }
                else if ($overlay == BOTH)
                {
                    return "<img src=\"images/locked-link-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/" . $key . "');\" class=\"icon\" />";
                }
                else
                {
                    return "<img src=\"images/icons/" . $key . "\" alt=\"" . $file . "\" title=\"" . $file . "\" class=\"icon\" />";
                }
            }
        }
    }

    if ($overlay == 1)
    {
        return "<img src=\"images/link-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/unknown.gif');\" class=\"icon\" />";
    }
    else if ($overlay == 2)
    {
        return "<img src=\"images/lock-overlay.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" style=\"background:url('images/icons/unknown.gif');\" class=\"icon\" />";
    }
    else
    {
        return "<img src=\"images/icons/unknown.gif\" alt=\"" . $file . "\" title=\"" . $file . "\" class=\"icon\" />";
    }
}

// Creates the icon link
function icon_link($entry, $dir, $icon, $is_dir = false, $url = "")
{
    global $permissions, $settings;

    if ($is_dir == true)
    {
        if ($settings["folder_link"] == LINK_TO_FM)
        {
            if (empty($url) == true)
            {
                return "<a href=\"index.php?act=list&amp;dir=" . relative_path($entry, $dir, 1) . "\"><img src=\"images/icons/" . $icon . ".gif\" alt=\"" . $entry . "\" title=\"" . $entry . "\" class=\"icon\" /></a>";
            }
            else
            {
                return "<a href=\"index.php?act=" . $url . "\"><img src=\"images/icons/" . $icon . ".gif\" alt=\"" . $entry . "\" title=\"" . $entry . "\" class=\"icon\" /></a>";
            }
        }
        else if ($settings["folder_link"] == LINK_TO_URL && empty($permissions["root_url"]) == false && $permissions["show_url"] == 1)
        {
            return "<a href=\"" . $permissions["root_url"] . relative_path($entry, $dir, 1) . "/\" target=\"_blank\"><img src=\"images/icons/" . $icon . ".gif\" alt=\"" . $entry . "\" title=\"" . $entry . "\" class=\"icon\" /></a>";
        }

        return "<img src=\"images/icons/" . $icon . ".gif\" alt=\"" . $entry . "\" title=\"" . $entry . "\" class=\"icon\" />";
    }
    else
    {
        if ($settings["file_link"] == LINK_TO_FM && file_permission($entry) == true && $permissions["download"] == 1)
        {
            return "<a href=\"index.php?act=list&amp;op=get&amp;target=" . relative_path($entry, $dir, 1) . "\">" . $icon . "</a>";
        }
        else if ($settings["file_link"] == LINK_TO_URL && empty($permissions["root_url"]) == false && $permissions["show_url"] == 1)
        {
            return "<a href=\"" . $permissions["root_url"] . relative_path($entry, $dir, 1) . "\" target=\"_blank\">" . $icon . "</a>";
        }

        return $icon;
    }
}

// Checks to see if the file or directory is actually a symlink
// Blame all this on aent, very annoying!
function check_link($path, $isroot = false)
{
    global $permissions;

    // If the path ends in a trailing slash remove it
    $path = preg_replace("/\/$/", "", $path);

    $realpath = realpath($path);

    if (is_win() == true)
    {
        $realpath = str_replace("\\", "/", $realpath);
    }

    // If root is a link return because otherwise we will get nothing but errors
    if  ($isroot == false && check_link($permissions["root"], true) == true)
    {
        return false;
    }

    if ($realpath != $path)
    {
        return true;
    }
    return false;
}

// Gets Unix specific info such as owner, group and CHMOD
function unix_info($file)
{
    global $page;

    $owner = array();
    $group = array();
    $unix  = array("owner" => $page["na"], "group" => $page["na"], "chmod" => $page["na"]);

    // Check that the needed functions exist because they are disabled on some systems
    if (function_exists("posix_getpwuid") && function_exists("posix_getgrgid"))
    {
       // Check that the user is running on a UNIX system
       $owner = posix_getpwuid(fileowner($file));
       $group = posix_getgrgid(filegroup($file));

       $unix["owner"] = $owner["name"];
       $unix["group"] = $group["name"];
    }

    // Get the CHMOD value
    if (is_win() == false)
    {
        $unix["chmod"] = chmod_value($file);
    }
    return $unix;
}

// Returns the CHMOD value of a file, in octal
function chmod_value($file)
{
    global $settings;

    $mode = fileperms($file);
    $mode = sprintf("%o", $mode);

    if ($settings["full_chmod"] == true)
    {
        return substr($mode, strlen($mode) - 4);
    }
    else
    {
        return substr($mode, strlen($mode) - 3);
    }
}

// Formats a number of bytes into a human readable format
function format_bytes($filesize)
{
    global $page;

    if ($filesize >= 1073741824)
    {
        return round($filesize / 1073741824 * 100) / 100 . " " . $page["gb"];
    }
    else if ($filesize >= 1048576)
    {
        return round($filesize / 1048576 * 100) / 100 . " " . $page["mb"];
    }
    else if ($filesize >= 1024)
    {
        return round($filesize / 1024 * 100) / 100 . " " . $page["kb"];
    }
    else
    {
        return $filesize . " " . $page["bytes"];
    }
}

// Return the directory size
function directory_size($dir)
{
    $dp     = opendir($dir);
    $size   = 0;

    while (($entry = readdir($dp)) != false)
    {
        if ($entry != "." && $entry != ".." && check_link($dir . $entry) == false)
        {
            // Do not traverse links, otherwise the space will be counted twice
            if (is_dir($dir . $entry) == true)
            {
                $size = $size + directory_size($dir . $entry . "/");
            }
            else if (is_file($dir . $entry) == true)
            {
                $size = $size + filesize($dir . $entry);
            }
        }
    }

    closedir($dp);

    return $size;
}

// Gets the MD5 Hash of a file
function get_file_md5($file)
{
    global $page;

    if(function_exists("md5_file") == true)
    {
        return md5_file($file);
    }
    else
    {
        if (file_exists($file) == false)
        {
            return $page["unknown"];
        }
        else
        {
            $data = implode("", file($file));
            return md5($data);
        }
    }
}

/* -----------------------------------------
                  Data Cleanup
   ----------------------------------------- */

// Cleans the get and post data
function clean_input()
{
    $cleaned = array();

    foreach($_GET as $key => $var)
    {
        if(is_array($_GET[$key]) == true)
        {
            foreach ($_GET[$key] as $index => $value)
            {
                $cleaned[$key][$index] = clean_value($value);
            }
        }
        else
        {
            $cleaned[$key] = clean_value($var);
        }
    }

    foreach($_POST as $key => $var)
    {
        if(is_array($_POST[$key]) == true)
        {
            foreach ($_POST[$key] as $index => $value)
            {
                $cleaned[$key][$index] = clean_value($value, false);
            }
        }
        else
        {
            $cleaned[$key] = clean_value($var);
        }
    }

    $cleaned["IP_ADDRESS"] = "127.0.0.1";
    $check_ip = array($_SERVER["REMOTE_ADDR"], $_SERVER["HTTP_CLIENT_IP"], $_SERVER["HTTP_X_FORWARDED_FOR"], $_SERVER["HTTP_PROXY_USER"]);
    foreach ($check_ip as $var)
    {
        if (empty($var) == false && preg_match("/^(127)\./", $var) == false && preg_match("/unknown/i", $var) == false)
        {
            $cleaned["IP_ADDRESS"] = $var;
            break;
        }
    }

    return $cleaned;
}

// Cleans a string of data
function clean_value($value, $decode = true)
{
    if ($value == "")
    {
        return "";
    }

    $value = str_replace("%23", "#", $value);
    $value = get_magic_quotes_gpc() == true ? stripslashes($value) : $value; // Remove PHP added backslashes

    if ($decode == true)
    {
        $value = rawurldecode($value);                                        // Decode the data
    }

    return $value;
}

// Cleans the path so it is "safe"
function clean_path($path)
{
    $path = ereg_replace("\.[\.]+", "", $path); // Remove dots ..
    $path = ereg_replace("^[\/]+", "", $path);  // Remove leading slashes
    $path = ereg_replace("[\/]+$", "", $path);  // Remove trialing slashes
    $path = ereg_replace("/{2,}", "/", $path);  // Replace groups of // with /
    $path = str_replace("%23", "#", $path);

    return $path;
}

// Checks that an inputted file name is valid
function is_invalid_name($name)
{
 // return preg_match("/^[\\\\\\/:*?\"<>|%]/", $name);
    return !preg_match("/^[a-zA-Z0-9\._()-\s]+$/", $name);
}

// Changes HTML tags so they are safe to show in a textarea
function make_safe($string)
{
    $string = str_replace("&", "&#38;", $string);
    $string = str_replace("\"", "&#34;", $string);
    $string = str_replace(">", "&#62;", $string);
    $string = str_replace("%", "&#37;", $string);
    return str_replace("<", "&#60;", $string);
}

// Changes textarea safe tags back to normal HTML
function make_unsafe($string, $config = false)
{
   /*
        Did use htmlentities() but it converted more than we needed, plus could cause problems with converting user input
        $trans = get_html_translation_table(HTML_ENTITIES);
        $trans = array_flip($trans);
        return strtr($string, $trans);
   */

    $string = str_replace("&#38;", "&", $string);
    $string = str_replace("&#34;", "\"", $string);
    $string = str_replace("&#62;", ">", $string);
    $string = str_replace("&#37;", "%", $string);

    // Updating a config file so need to remove some extra stuff
    if ($config == true)
    {
        $string = str_replace("\"", "\\\"", $string);

        $string = str_replace("\r\n", "", $string);
        $string = str_replace("\n", "", $string);
        $string = str_replace("\r", "", $string);
    }

    return str_replace("&#60;", "<", $string);
}

/* -----------------------------------------
               Template Management
   ----------------------------------------- */

// Parses 'static' template files
function static_template($file, $data, $final = 0)
{
    global $debug, $settings, $executed;

    // Attempt to open the template
    if (($fp = fopen($file, "r")) == false)
    {
        return false;
    }

    // Read the template
    file_lock($fp, LOCK_SH);
    $template = fread($fp, filesize($file));
    file_lock($fp, LOCK_UN);
    fclose($fp);

    // If the is the final parse then add the debugging info
    if ($final == 1)
    {
        $data["gzip"]       = $debug["gzip"];
        $data["clock"]      = stop_clock($debug["start"]);
        $data["copyright"]  = preg_replace("/<%POWERED%>/i", $data["powered"], $debug["copyright"]);

        if ($settings["load"] == true && file_exists("/proc/loadavg") == true)
        {
            $fp = @fopen("/proc/loadavg", "r");

            if (empty($fp) == false)
            {
                $loadavg        = explode(" ", fread($fp, 6));
                fclose($fp);

                $data["load"]   = preg_replace("/<%LOAD%>/i", $loadavg[0], $data["load"]);
            }
            else
            {
                $data["load"]   = "";
            }
        }
        else
        {
            $data["load"]   = "";
        }

        if ($settings["queries"] == true)
        {
            $data["queries"] = preg_replace("/<%QUERIES%>/i", count($executed), $data["queries"]);
        }
        else
        {
            $data["queries"] = "";
        }
    }

    // Parse the tags, escape the slashes otherwise PCRE uses them as modifiers
    foreach ($data as $key => $var)
    {
        $template = preg_replace("/<%" . $key . "%>/i", str_replace("$", "\\$", str_replace("\\", "\\\\", $var)), $template);
    }
    return $template;
}

// Parses dynamic template files
function dynamic_template($file, $blocks)
{
    global $settings;

    // Attempt to open the template
    if (($fp = fopen($file, "r")) == false)
    {
        return false;
    }

    // Read the template file
    file_lock($fp, LOCK_SH);
    $template = fread($fp, filesize($file));
    file_lock($fp, LOCK_UN);
    fclose($fp);

    // 'Swap' the dynamic blocks for their 'real' content, , escape the slashes otherwise PCRE uses them as modifiers
    foreach ($blocks as $key => $var)
    {
        $template = preg_replace("/<!-- BEGIN DYNAMIC BLOCK: " . $key . " -->(.+?)<!-- END DYNAMIC BLOCK: " . $key . " -->/si", str_replace("$", "\\$", str_replace("\\", "\\\\", $var)), $template);
    }
    return $template;
}

// Gets the blocks of HTML from a dynamic template file
function get_blocks($file, $blocks)
{
    // Attempt to open the template
    if (($fp = fopen($file, "r")) == false)
    {
        return false;
    }

    file_lock($fp, LOCK_SH);
    $template = fread($fp, filesize($file));
    file_lock($fp, LOCK_UN);
    fclose($fp);

    foreach ($blocks as $var)
    {
        preg_match("/<!-- BEGIN DYNAMIC BLOCK: " . $var . " -->(.+?)<!-- END DYNAMIC BLOCK: " . $var . " -->/si", $template, $regs);
        $dynamic[$var] = $regs[1];
        unset($regs);
    }
    return $dynamic;
}

// Parses a single "block" of HTML code
function parse_html($data, $html)
{
    // Parse the tags, escape the slashes otherwise PCRE uses them as modifiers
    foreach ($data as $key => $var)
    {
        $html = preg_replace("/<%" . $key . "%>/i", str_replace("$", "\\$", str_replace("\\", "\\\\", $var)), $html);
    }
    return $html;
}

// Parses all the blocks of HTML
function parse_blocks($data, $blocks)
{
    foreach ($data as $name => $content)
    {
        $tmp = "";

        if (is_array($data[$name]))
        {
            foreach ($content as $var)
            {
                $tmp .= parse_html($var, $blocks[$name]);
            }
        }
        else if ($data[$name] != "")
        {
            // Escape the slashes otherwise PCRE uses them as modifiers
            $tmp .= preg_replace("/<%" . $name . "%>/i", str_replace("$", "\\$", str_replace("\\", "\\\\", $data[$name])), $blocks[$name]);
        }

        $blocks[$name] = $tmp;
    }
    return $blocks;
}

// Creates a HTML drop down list from an array
function dropdown($name, $items, $selected = 0, $filter = false)
{
    if ($filter == true)
    {
        $list = "<select name=\"" . $name . "\" onchange=\"javascript:update_filter();\" onblur=\"javascript:update_filter();\">";
    }
    else
    {
        $list = "<select name=\"" . $name . "\">";
    }

    foreach ($items as $key => $var)
    {
        if ($key == $selected)
        {
            $list .= "<option value=\"" . $key . "\" selected=\"selected\">" . $var . "</option>";
        }
        else
        {
            $list .= "<option value=\"" . $key . "\">" . $var . "</option>";
        }
    }

    $list .= "</select>";

    return $list;
}

// Creates Yes/No radio buttons
function dualRadio($name, $selected, $labels = "")
{
    global $page;

    $labels = empty($labels) == true ? array("yes" => $page["yes"], "no" => $page["no"]) : $labels;

    $data = $labels["yes"];

    if ($selected == 1)
    {
        $data .= " <input type=\"radio\" name=\"" . $name . "\" value=\"1\" checked=\"checked\" /> <input type=\"radio\" name=\"" . $name . "\" value=\"0\" /> ";
    }
    else
    {
        $data .= " <input type=\"radio\" name=\"" . $name . "\" value=\"1\" /> <input type=\"radio\" name=\"" . $name . "\" value=\"0\" checked=\"checked\" /> ";
    }

    $data .= $labels["no"];

    return $data;
}

// Creates a checkbox
function checkBox($name, $selected = false)
{
    $data = "<input type=\"checkbox\" name=\"" . $name . "\" value=\"1\"";

    if ($selected == true)
    {
        $data .= " checked=\"checked\"";
    }

    $data .= " />";

    return $data;
}

// Makes a set of navigation links from a path
function make_navigation($dir)
{
    global $permissions;

    $nav      = str_replace($permissions["root"], "", $dir);
    $exploded = explode("/", $nav);

    $nav = "/";
    $next = "";
    foreach ($exploded as $var)
    {
        if ($var != "")
        {
            $next .= $var;
            $nav .= "<a href=\"index.php?act=list&amp;dir=" . url_safe($next) . "\">" . $var . "</a>" . "/";
            $next .= "/";
        }
    }

    // If we are running on Windows we need to reverse the slashes
    if (is_win() == true)
    {
        // Replace the slashes, dirty but it does the job
        $nav = preg_replace("/^[\/]/", "\\", $nav);
        $nav = preg_replace("/<\/a>[\/]/", "</a>\\", $nav);
    }

    return $nav;
}

/* -----------------------------------------
               User Functions
   ----------------------------------------- */

// Gets the user permissions
function auth_user($user, $pass, $useID = false)
{
    global $settings, $link_id, $queries;

    $permissions = false;

    $sql = $queries["get_user_info"];
    if ($useID == true)
    {
        $sql = $queries["get_user_info_id"];    
    }

    build_query($sql, array("USERNAME" => strtolower($user), "PASSWORD" => $pass, "ID" => $user));     
    $results = db_query($sql, $link_id);
    
    if (db_num_rows($results, $link_id) > 0)
    {
        $data = db_fetch_array($results, $link_id);

        $permissions = array(
                        "uid"       => $data["uid"],
                        "gid"       => $data["gid"],
                        "name"      => $data["username"],
                        "password"  => $data["password"],
                        "email"     => $data["email"],
                        "offset"    => $data["offset"],
                        "isdst"     => $data["dst"],
                        "notes"     => $data["add_notes"],
                        "adminmsg"  => $data["del_admin_msg"],
                        "bookmark"  => $data["use_bookmarks"],
                        "group"     => $data["groupname"],
                        "htpasswd"  => $data["lock_dir"],
                        "ucp"       => $data["access_ucp"],
                        "chmod"     => $data["chmod"],
                        "upload"    => $data["upload"],
                        "download"  => $data["download"],
                        "rename"    => $data["rename"],
                        "edit"      => $data["editor"],
                        "source"    => $data["view_source"],
                        "view_img"  => $data["view_img"],
                        "mp3"       => $data["mp3"],
                        "delete"    => $data["delete"],
                        "copy"      => $data["copy"],
                        "move"      => $data["move"],
                        "newfolder" => $data["newfolder"],
                        "newfile"   => $data["newfile"],
                        "overwrite" => $data["overwrite"],
                        "archive"   => $data["create_archive"],
                        "view_arc"  => $data["view_archive"],
                        "arc_save"  => $data["archive_save_options"],
                        "symlink"   => $data["make_symlink"],
                        "admin"     => $data["access_acp"],
                        "sql"       => $data["sql"],
                        "dbhost"    => $data["dbhost"],
                        "dbuser"    => $data["dbuser"],
                        "dbpass"    => $data["dbpass"],
                        "dbname"    => $data["dbname"],
                        "root"      => $data["root_path"],
                        "root_url"  => $data["root_url"],
                        "show_url"  => $data["show_url"],
                        "verify"    => $data["verify_file"],
                        "space"     => empty($data["user_space"]) == false ? $data["user_space"] : $data["group_space"],
                        "lang"      => $data["language"],
                        "showall"   => $data["show_hidden_files"],
                        "access"    => $data["access_type"],
                        "files"     => $data["file_types"],
                        "no_ext"    => $data["allow_no_extension"],
                        "validate"  => $data["type"],
                        "offline"   => $data["offline"],
                        "stats"     => $data["stats"]
                       );
    }

    return $permissions;
}

// Checks if the file is allowed to be edited
function is_ascii($file)
{
    global $settings, $permissions;

    $ext = ext($file);

    if (empty($ext) == true && $permissions["no_ext"] == 1)
    {
        return true;
    }

    return in_array($ext, $settings["ascii"]);
}

// Checks if a file is an image
function is_image($file)
{
    // Hardcoded for the time being
    $images = array("gif", "jpg", "jpeg", "png", "bmp");
    return in_array(ext($file), $images);
}

// Checks the users permission to act upon a file
function file_permission($file)
{
    global $permissions;

    if ($permissions["access"] == DISALLOW && empty($permissions["files"]) == true)
    {
        return true;
    }
    else if ($permissions["access"] == ALLOW && empty($permissions["files"]) == true)
    {
        return false;
    }

    $ext  = ext($file);

    $list = explode(" ", $permissions["files"]);

    if (empty($ext) == true && $permissions["no_ext"] == 1)
    {
        return true;
    }

    if (($permissions["access"] == DISALLOW && in_array($ext, $list) == true) || ($permissions["access"] == ALLOW && in_array($ext, $list) == false))
    {
        return false;
    }
    else if (($permissions["access"] == DISALLOW && in_array($ext, $list) == false) || ($permissions["access"] == ALLOW && in_array($ext, $list) == true))
    {
       return true;
    }
    return false;
}

// Checks that the file isn't hidden or a system file
function is_sys_file($path, $isdir = false)
{
    global $settings;

    $ext    = ext($path);
    $file   = basename($path);
    $dir    = dirname($path);

    $system = array($settings["msg"], $settings["notes"], $settings["bookmarks"], $settings["history"]);

    if ($settings["hide_dot"] == true && (preg_match("/\/\./", $dir) == true || preg_match("/^\./", $file) == true))
    {
        // The file is hidden if it has a leading dot, or if we find /. in the path, ie if one of its folders has a leading dot
        return true;
    }
    else if (substr($path, strlen($path) - strlen($settings["editing"]), strlen($path)) == $settings["editing"] && is_file($path) == true)
    {
        // The file is a lock file
        return true;
    }
    else if (in_array($file, $system) == true && $isdir == false)
    {
        return true;
    }

    return false;

}

// Returns true if the user is a guest
function is_guest()
{
    global $settings;

    if ($settings["require_auth"] == false && empty($_COOKIE[$settings["user_cookie"]]) == true)
    {
        return true;
    }

    return false;
}

/* -----------------------------------------
              Other General functions
   ----------------------------------------- */

// Creates the full path (open basedir safe)
function create_directory_structure($path)
{
    global $settings;
    
    $base = $path;
    $found = false;
    
    do {
        if (file_exists($base) == false)
        {   
            $x = strrpos(substr($base, 0, strlen($base) - 1), "/");
            $base = substr($base, 0, $x);  
        }
        else
        {
            $found = true;
        } 
        
        if ($base == "/") $found = true; // Break out
    } while ($found == false);
    
    $tmp .= $base;    
    foreach(explode("/", str_replace($base, "", $path)) as $var)
    {
        if ($var != "." && $var != "..")
        {
            $tmp .= str_replace("//", "", $var . "/");

            if (file_exists($tmp) == false && mkdir($tmp, octdec((int) $settings["default_chmod"])) == false)
            {
                return false;
            }
        }
    }
    return true; 
}

// Locks or unlocks a file
function file_lock(&$fp, $lock = LOCK_EX)
{
    global $settings;

    if ($settings["flock"] == true)
    {
        flock($fp, $lock);
    }

    return $fp;
}

// Redirects to the selected page
function go_to($url)
{
    global $settings;

    switch ($settings["redirect_header"])
    {
        case REFRESH:
            header("Refresh: 0;url=" . $url);
        break;
        case HTML:
            echo "<html><head><meta http-equiv=\"refresh\" content=\"0; url=" . $url . "\"></head><body></body></html>";
        break;
        default:
            header("Location: " . $url);
    }
    exit;
}

// Detects if the system is Windows
function is_win()
{
    return preg_match("/windows/i", php_uname());
}

// Gets the path relative to the root directory
function relative_path($entry, $dir, $is_link = 0)
{
    global $permissions;

    // Get the relative path from the root
    $path = $dir . $entry;
    #$path = str_replace($permissions["root"], "", $path);
    $path = preg_replace("#^" . $permissions["root"] . "#", "", $path);

    $path = str_replace("#", "%23", $path);

    // If we are making a URL link, don't encode it

    if ($is_link == 1)
    {
        return $path;
    }

    $path = str_replace("'", "\'", $path);


    return url_safe($path);
}

// A function to make variables URL safe
function url_safe($var)
{
    $var = str_replace("#", "%23", $var);
    return str_replace("%00", "%2F", rawurlencode($var));
}

// Builds a "list" from an array
function build_list($items, $quote = false, $finale = "&amp;")
{
    if (count($items) == 1)
    {
        return $items[0];
    }

    $list = "";

    foreach ($items as $fname)
    {
        if ($quote == true)
        {
            $list .= "&quot;" . $fname . "&quot;, ";
        }
        else
        {
            $list .= $fname . ", ";
        }
    }
    $list = substr($list, 0, strlen($list) - 2);
    $list = substr_replace($list, " " . $finale, strrpos($list, ","), 1);

    return $list;
}

// Creates the error message
function create_message($items, $single, $many)
{
    $debug["msg"] = "";

    if (is_array($items) == true)
    {
        if (count($items) == 1)
        {
            $debug["msg"] .= preg_replace("/<%FILE%>/i", "&quot;" . $items[0] . "&quot;", $single). "<br />";
        }
        else
        {
            $debug["msg"] .= preg_replace("/<%FILE%>/i", build_list($items, true), $many) . "<br />";
        }
    }
    return $debug["msg"];
}

// Creates the bookmark form
function bookmark_form()
{
    global $permissions, $settings, $page;

    // Read the bookmarks
    $bookmark_list   = "";
    $bookmark_count = 0;
    if (file_exists($permissions["root"] . $settings["bookmarks"]) == true && $permissions["bookmark"] == 1)
    {
        $bookmarks = file($permissions["root"] . $settings["bookmarks"]);

        natcasesort($bookmarks);

        if (count($bookmarks) != 0)
        {
            $bookmark_list .= "<select name=\"bookmark\">";
            $bookmark_list .= "<option selected=\"selected\" value=\"\">" . $page["bookmark_list"] . "</option>"; // Enter a invalid value, this way we know it's not a directory

            while(list(,$value) = each($bookmarks))
            {
                list($text, $link) = split("[|]", $value);

                if (file_exists($permissions["root"] . trim($link) . "/") == true)
                {
                    $bookmark_list .= "<option value=\"" . trim($link) . "\">&nbsp;&nbsp;" . trim($text) . "</option>";
                    $bookmark_count++;
                }
            }

            $bookmark_list .= "</select>";
        }
    }

    return array("count" => $bookmark_count, "list" => $bookmark_list);
}

// Load the language packs
function load_language($lang, $file, $acp = false)
{
    global $lang_dir, $settings, $page, $templates;

    // Load the default global language pack
    require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/config.lng.php";
    require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/common.lng.php";

    // Load the default global admin language pack
    if ($acp == true)
    {
        require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/admin/common.lng.php";
    }

    // Load the default page language pack
    require $settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/" . $file . ".lng.php";

    // Load the user language pack (use include because they all not vital for the script)
    if ($lang != 0 && isset($lang_dir[$lang]) == true)
    {
        if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/config.lng.php") == true)
        {
            include $settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/config.lng.php";
        }

        if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/common.lng.php") == true)
        {
            include $settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/common.lng.php";
        }

        if ($acp == true)
        {
            if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/admin/common.lng.php") == true)
            {
               include $settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/admin/common.lng.php";
            }
        }

        if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/" . $file . ".lng.php") == true)
        {
            include $settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/" . $file . ".lng.php";
        }
    }
    return true;
}

// Load a whole text file from the language pack
function load_lang_file($lang, $file)
{
    global $lang_dir, $settings;

    if (file_exists($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/" . $file) == true && filesize($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/" . $file) > 0)
    {
        return implode("", file($settings["script_dir"] . "languages/" . $lang_dir[$lang] . "/" . $file));
    }
    else
    {
        return implode("", file($settings["script_dir"] . "languages/" . $lang_dir[$settings["default_lang"]] . "/" . $file));
    }
}

// Finds out which browser the user is using by checking the USER_AGENT string
function web_browser()
{
    global $_SERVER;

    if (preg_match("/msie/i", $_SERVER["HTTP_USER_AGENT"]) == true)
    {
        return "ie";
    }
    else if (preg_match("/opera/i", $_SERVER["HTTP_USER_AGENT"]) == true)
    {
        return "opera";
    }
    else if (preg_match("/konqueror/i", $_SERVER["HTTP_USER_AGENT"]) == true)
    {
        return "konqueror";
    }
    else if (preg_match("/mozilla/i", $_SERVER["HTTP_USER_AGENT"]) == true)
    {
        // Have the mozilla check last as a lot of browsers have mozilla in their user agent string
        return "mozilla";
    }
    else
    {
        return "other";
    }
}

/* -----------------------------------------
             History functions
   ----------------------------------------- */

// Updates the users login history
function set_history()
{
    global $permissions, $settings, $input;

    if ($settings["keep_history"] == false)
    {
        return;
    }

    touch($permissions["root"] . $settings["history"]);
    $data = file($permissions["root"] . $settings["history"]);

    if (($fp = fopen($permissions["root"] . $settings["history"], "w")) == true)
    {
        file_lock($fp);
        fwrite($fp, timestamp(time()) . "\r\n" . gethostbyaddr($input["IP_ADDRESS"]) . "\r\n" . trim($data[0]) . "\r\n" . trim($data[1]));
        file_lock($fp, LOCK_UN);
        fclose($fp);
    }

    return;
}

// Gets the users login history
function get_history()
{
    global $permissions, $settings, $page;

    if (is_guest() == true || $settings["keep_history"] == false)
    {
        return "";
    }

    $data = file($permissions["root"] . $settings["history"]);

    if (count($data) < 4)
    {
        return "";
    }

    $page["login_history"] = preg_replace("/<%TIME%>/i", gmdate($settings["format"], timestamp(trim($data[2]))), $page["login_history"]);
    return preg_replace("/<%ADDRESS%>/i", trim($data[3]), $page["login_history"]);
}

// Applies a time offset
function timestamp($time)
{
    global $permissions;

    if ($permissions["isdst"] == 1)
    {
        $time = $time + 3600;
    }

    if (preg_match("/^\-/", $permissions["offset"]) == true)
    {
        $offset = str_replace("-", "", $permissions["offset"]);
        return $time - (int) $offset;
    }
    else
    {
        return $time + (int) $permissions["offset"];
    }
}

/* -----------------------------------------
              Email functions
   ----------------------------------------- */

// Wrapper function to send the email
function sendmail($to, $subject, $body)
{
    global $settings;

    // Build the email
    $headers  = "From: " . $settings["admin_name"] . " <" . $settings["admin_out_email"] . ">\n";
    $headers .= "To: " . $to . "\n";
    $headers .= "Subject: " . $subject . "\n";
    $headers .= "Return-Path: " . $settings["admin_in_email"] . "\n";
    $headers .= "X-Priority: 3\n";
    $headers .= "X-Mailer: IPFM PHP Mailer\n";

    if ($settings["mail_type"] == "smtp")
    {
        return SMTPmail($to, $subject, $body, $headers);
    }
    else
    {
        // Use PHP's built in mail function
        return mail($to, $subject, $body, $headers);
    }
}

// Sends the actual email
function SMTPmail($to, $subject, $body, $headers)
{
    global $settings;

    $data = SMTP_cleanup($headers . "\n" . $body);

    if (($fp = fsockopen($settings["smtp_server"], (int) $settings["smtp_port"], $errno, $errstr, 10)) == false)
    {
        // Could not open a socket to the SMTP server
        return false;
    }

    // Get the status code
    $code = SMTP_read($fp);
    if (substr($code, 0, 3) == 220)
    {
        // Log in if the username and password are set
        if (empty($settings["smtp_username"]) == false && empty($settings["smtp_password"]) == false)
        {
            // Greet the server with ehlo
            $code = SMTP_write("EHLO " . $settings["smtp_server"], $fp);
            if (substr($code, 0, 3) != 250)
            {
                trigger_error("EHLO returned '$code'", E_USER_WARNING);
                return false;
            }

            // Send the auth command
            $code = SMTP_write("AUTH LOGIN", $fp);
            if (substr($code, 0, 3)== 334)
            {
                // Send the username
                $code = SMTP_write(base64_encode($settings["smtp_username"]), $fp);
                if (substr($code, 0, 3) != 334)
                {
                    // Username not accepted from the server
                    trigger_error("Username not accepted by the server", E_USER_WARNING);
                    return false;
                }

                // Send the password
                $code = SMTP_write(base64_encode($settings["smtp_password"]), $fp);
                if (substr($code, 0, 3) != 235)
                {
                    // Password not accepted from the server
                    trigger_error("Password not accepted by the server", E_USER_WARNING);
                    return false;
                }
            }
            else
            {
                // This server does not support authorisation
                trigger_error("AUTH LOGIN returned '$code'", E_USER_WARNING);
                return false;
            }
        }
        else
        {
            // Greet the server with helo
            $code = SMTP_write("HELO " . $settings["smtp_server"], $fp);
            if (substr($code, 0, 3) != 250)
            {
                trigger_error("HELO returned '$code'", E_USER_WARNING);
                return false;
            }
        }

        // Set the mail from parameter
        $code = SMTP_write("MAIL FROM: " . $settings["admin_out_email"], $fp);
        if (substr($code, 0, 3) != 250)
        {
            trigger_error("MAIL FROM returned '$code'", E_USER_WARNING);
            return false;
        }

        // Set the recipient address
        $code = SMTP_write("RCPT TO: " . $to, $fp);
        if (substr($code, 0, 3) != 250)
        {
            trigger_error("RCPT TO returned '$code'", E_USER_WARNING);
            return false;
        }

        // Send the email
        $code = SMTP_write("DATA", $fp);
        if (substr($code, 0, 3) == 354)
        {
            // DATA command accepted, send the email
            fputs($fp, $data . "\n");
        }
        else
        {
            // Error on write to SMTP server
            trigger_error("DATA returned '$code'", E_USER_WARNING);
            return false;
        }

        // Finalise email
        $code = SMTP_write(".", $fp);
        if (substr($code, 0, 3) != 250)
        {
            trigger_error(". returned '$code'", E_USER_WARNING);
            return false;
        }

        // Send final command
        $code = SMTP_write("QUIT", $fp);
        if (substr($code, 0, 3) != 221)
        {
            trigger_error("QUIT returned '$code'", E_USER_ERROR);
            return false;
        }

        // Close connection
        fclose($fp);
    }
    else
    {
        // Server didn't return 220 so there is an error
        trigger_error("Server returned '$code'", E_USER_WARNING);
        return false;
    }
}

// Read from the SMTP server
function SMTP_read($fp)
{
    $msg = "";

    while ($data = fgets($fp, 515))
    {
        $msg .= $data;

        if (substr($data, 3, 1) == " ")
        {
            break;
        }
    }

    return $msg;
}

// Writes to the STMP server
function SMTP_write($cmd, $fp)
{
    fputs($fp, $cmd . "\n");
    return SMTP_read($fp);
}

// Cleans up the email according to RFC 788 line endings
// in \r\n format with no periods on a new line
function SMTP_cleanup($data)
{
    $data .= "\n";

    $data  = str_replace("\n", "\r\n", str_replace("\r", "", $data));
        $data  = str_replace("\n.\r\n", "\n. \r\n", $data);

        return $data;
}

/* -----------------------------------------
            Administration functions
   ----------------------------------------- */
// Remove the users root directory
// Chopped down version of remove_dir
function remove_root($dir)
{
    // Create arrays to store files and directories
    $_files      = array();
    $_subdirs    = array();


    if (($dp = opendir($dir)) == false)
    {
        // The directory could not be opened
        return false;
    }

    // Loop through all directory entries, and construct two temporary arrays containing files and sub directories
    while($entry = readdir($dp))
    {
        if (is_dir($dir . $entry) && $entry !=  ".." && $entry !=  ".")
        {
            $_subdirs[] = $entry;
        }
        else if ($entry !=  ".." && $entry !=  ".")
        {
            $_files[] = $entry;
        }
    }

    // Close directory
    closedir($dp);

    // Delete all files in the curent directory return false and halt if a file cannot be removed
    for($i=0; $i<count($_files); $i++)
    {
        chmod($dir . $_files[$i], 0777);

        if (unlink($dir . $_files[$i]) == false)
        {
            return false;
        }
    }

    // Empty sub directories and then remove the directory
    for($i=0; $i<count($_subdirs); $i++)
    {
        chmod($dir . $_subdirs[$i] . "/", 0777);

        if (remove_root($dir . $_subdirs[$i] . "/") == false)
        {
            return false;
        }
    }

    chmod($dir, 0777);
    if (rmdir($dir) == false)
    {
        return false;
    }

    return true;
}

?>