<?php

/*
 * Invision Power File Manager
 * Database Manager
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 19th September 2004
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

// The user doesn't have permission to access mysql
if ($permissions["sql"] == 0)
{
    go_to("index.php?op=list&dir=" . $dir . "&msg=no_dbman_permission");
}
else
{
    $permissions["database"] = isset($input["database"]) == true ? $input["database"] : "";

    if (($dbman_link_id = db_connect($permissions["dbhost"], $permissions["dbuser"], $permissions["dbpass"], $permissions["database"])) == false)
    {
        $page["msg"]               = db_error($dbman_link_id);
        $page["error_intro"]       = $page["connect_error"];
        $page["selected_database"] = "";
        $page["continue"]          = $page["retry"];

        $page["content"]           = static_template($settings["script_dir"] . "skin/db/error.tpl", $page);
    }
    else
    {
        if (isset($input["sql"]) == true)
        {
            $result = db_query($input["sql"], $dbman_link_id);
            $page["selected_database"] = $input["database"];

            if (empty($result) == true)
            {
                $page["msg"]               = db_error($dbman_link_id);
                $page["error_intro"]       = $page["query_error"];
                $page["continue"]          = $page["new_query"];

                $page["content"]           = static_template($settings["script_dir"] . "skin/db/error.tpl", $page);
            }
            else if (db_num_rows($result, $dbman_link_id) == 0)
            {
                $page["result"]  = $page["no_data"];
                $page["sql"]     = htmlspecialchars($input["sql"]);

                $page["content"] = static_template($settings["script_dir"] . "skin/db/result.tpl", $page);
            }
            else if (in_array($input["database"], explode(",", $permissions["dbname"])) == false && empty($permissions["dbname"]) == false)
            {
                $page["msg"]               = $page["no_db_permission"];
                $page["error_intro"]       = $page["query_error"];
                $page["continue"]          = $page["new_query"];

                $page["content"]           = static_template($settings["script_dir"] . "skin/db/error.tpl", $page);
            }
            else
            {
                $page["result"] = "<table class=\"sqlResults\" cellspacing=\"0\" cellpadding=\"0\">\r\n";
                $page["result"] .= "    <tr>\r\n";

                // Rows where returned so produce a table of the output
                for ($i=0; $i<db_num_fields($result, $dbman_link_id); $i++)
                {
                    // Produce a header field for each column name
                    $page["result"] .= "        <th class=\"sqlHeader\">" . db_field_name($result, $i, $dbman_link_id) . "</th>\r\n";
                }
                $page["result"] .= "    </tr>\r\n";

                for ($i=0; $i<db_num_rows($result, $dbman_link_id); $i++)
                {
                    if ($i % 2 > 0)
                    {
                        $css = "sqlData1";
                    }
                    else
                    {
                        $css = "sqlData2";
                    }

                    $page["result"] .= "    <tr>\r\n";
                    $row_array = db_fetch_array($result, $dbman_link_id);

                    for ($j=0; $j < db_num_fields($result, $dbman_link_id); $j++)
                    {
                        // Make the output HTML safe
                        $data = htmlspecialchars($row_array[$j]);

                        if (empty($data) == true)
                        {
                            // If the cell is empty pad it
                            $data = "&nbsp;";
                        }
                        else
                        {
                            // Convert line breaks
                            $data = preg_replace("/\r\n/i", "<br />", $data);
                            $data = preg_replace("/\r/i", "<br />", $data);
                            $data = preg_replace("/\n/i", "<br />", $data);
                            $data = preg_replace("/\t/i", "&nbsp;&nbsp;&nbsp;&nbsp;", $data);
                        }

                        $page["result"] .= "        <td class=\"" . $css . "\">" . $data . "</td>\r\n";
                    }

                    $page["result"] .= "    </tr>\r\n";
                }
                $page["result"] .= "</table>\r\n";

                $page["sql"]    = htmlspecialchars($input["sql"]);

                $page["content"] = static_template($settings["script_dir"] . "skin/db/result.tpl", $page);
            }
        }
        else
        {
            $page["db_version"] = db_version($dbman_link_id);

            $databases = db_list_databases($dbman_link_id, $permissions["dbname"]);

            $page["database_list"] = dropdown("database", $databases, $input["database"]);

            $page["content"] = static_template($settings["script_dir"] . "skin/db/query.tpl", $page);
        }

        db_close($dbman_link_id);
    }
}

$page["js"] = "sql";

?>