<?php

/*
 * Invision Power File Manager
 * MySQL database module
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 26th February 2005
 *
 */

/*
 * You may notice below that link is passed to all functions, even if not used
 * this is to ensure all data needed by other RDMS systems are already
 * present, so no modifications are needed to the database loader
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

$dbhome   = "http://www.mysql.com/"; // The home page of the database system
$executed = array();
if (defined("IPFM_INSTALLER") == false) {
    require $settings["script_dir"] . "modules/db/" . $settings["dbtype"] . "_queries.lib.php"; // Load the queries
}
/* -----------------------------------------
                Module functions
   ----------------------------------------- */

// Parses any variables in a querylink
function build_query(&$sql, $data)
{
    foreach ($data as $key => $var)
    {
        #$var = str_replace("'", "\\'", $var);

        $sql = str_replace("{" . $key . "}", $var, $sql);
    }

    return;
}

// This function connects to the database server
// Returns a link identifier
function db_connect($server = "", $username = "", $password = "", $database = "")
{
    $link = mysql_connect($server, $username, $password);

    if (empty($database) == false && empty($link) == false)
    {
        mysql_select_db($database);

        // Trigger an error
        if (db_error($link) != "")
        {
            unset($link);
        }
    }

    return $link;
}

// Closes the database connection, requires a link identifier
function db_close($link)
{
    if (empty($link) == false) 
    {
        return mysql_close($link);
    }
}

// Returns the version of the database system
function db_version($link)
{
    if (function_exists("mysql_get_server_info") == true)
    {
        return "MySQL " . mysql_get_server_info($link);
    }
    else
    {
        list($version) = mysql_fetch_row(mysql_query("SELECT VERSION() as version", $link));

        return "MySQL " . $version;
    }
}

// Returns a list of databases, requires the users database list
function db_list_databases($link, $databases = "")
{
    if (empty($databases) == true)
    {
        $data = mysql_list_dbs($link);

        while ($result = mysql_fetch_row($data))
        {
            $databases[$result[0]] = $result[0];
        }

        return $databases;
    }
    else
    {
        $data = explode(",", $databases);

        unset($databases);
        foreach ($data as $var)
        {
            if (empty($var) == false)
            {
                $databases[$var] = $var;
            }
        }

        return $databases;
    }
}

// Runs the specified SQL
function db_query($sql, $link)
{
    global $executed;

    $executed[] = $sql;

    return mysql_query($sql, $link);
}

// Returns the number of fields in the result set
function db_num_fields($result, $link)
{
    return mysql_num_fields($result);
}

// Returns the number of rows in the result set
function db_num_rows($result, $link)
{
    return mysql_num_rows($result);
}

// Returns the result as an array
function db_fetch_array($result, $link)
{
    return mysql_fetch_array($result);
}

// Returns the list ID inserted
function db_insert_id($link)
{
    return mysql_insert_id($link);
}

// Returns the field name
function db_field_name($result, $offset, $link)
{
    return mysql_field_name($result, $offset);
}

// Return an error message when needed
function db_error($link)
{
    global $page;

    $errno = empty($link) == true ? mysql_errno() : mysql_errno($link);

    if ($errno < 1)
    {
        $msg = empty($link) == true ? mysql_error() : mysql_error($link);

        // Check to make sure a message was returned
        return empty($msg) == true ? $page["db_invalid_login"] : $msg;
    }
    else
    {
        return $errno . ": " . empty($link) == true ? mysql_error() : mysql_error($link);
    }
}

?>