<?php

/*
 * Invision Power File Manager
 * MySQL database queries
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 26th February 2005
 *
 */

/* -----------------------------------------
                Define queries
   ----------------------------------------- */
$queries["get_user_info"]   = 'SELECT ' . $settings["dbprefix"] . '_users.*, ' . $settings["dbprefix"] . '_groups.*, ' . $settings["dbprefix"] . '_validating.type FROM ' . $settings["dbprefix"] . '_users, ' . $settings["dbprefix"] . '_groups LEFT JOIN ' . $settings["dbprefix"] . '_validating ON (' . $settings["dbprefix"] . '_users.uid = ' . $settings["dbprefix"] . '_validating.uid) WHERE LCASE(' . $settings["dbprefix"] . '_users.username) = \'{USERNAME}\' AND ' . $settings["dbprefix"] . '_users.password = \'{PASSWORD}\' AND ' . $settings["dbprefix"] . '_groups.gid = ' . $settings["dbprefix"] . '_users.gid';
$queries["get_user_info_id"]   = 'SELECT ' . $settings["dbprefix"] . '_users.*, ' . $settings["dbprefix"] . '_groups.*, ' . $settings["dbprefix"] . '_validating.type FROM ' . $settings["dbprefix"] . '_users, ' . $settings["dbprefix"] . '_groups LEFT JOIN ' . $settings["dbprefix"] . '_validating ON (' . $settings["dbprefix"] . '_users.uid = ' . $settings["dbprefix"] . '_validating.uid) WHERE ' . $settings["dbprefix"] . '_users.uid = {ID} AND ' . $settings["dbprefix"] . '_users.password = \'{PASSWORD}\' AND ' . $settings["dbprefix"] . '_groups.gid = ' . $settings["dbprefix"] . '_users.gid';
$queries["get_guest_info"]  = 'SELECT * FROM ' . $settings["dbprefix"] . '_users WHERE uid = {UID}';
$queries["get_group_name"]  = 'SELECT groupname FROM ' . $settings["dbprefix"] . '_groups WHERE gid = {GID}';
$queries["update_timezone"] = 'UPDATE ' . $settings["dbprefix"] . '_users SET offset = \'{OFFSET}\', dst = \'{DST}\' WHERE uid = {UID}';
$queries["update_password"] = 'UPDATE ' . $settings["dbprefix"] . '_users SET password = \'{PASSWORD}\' WHERE uid = {UID}';
$queries["update_email"]    = 'UPDATE ' . $settings["dbprefix"] . '_users SET email = \'{EMAIL}\' WHERE uid = {UID}';
$queries["update_language"] = 'UPDATE ' . $settings["dbprefix"] . '_users SET language = \'{LANGUAGE}\' WHERE uid = {UID}';

// Converge
// $queries["converge_user"]   = "SELECT * FROM " . $settings["converge_prefix"] . "members_converge WHERE converge_email = '{EMAIL}'";

// Register
$queries["add_spambot"]        = 'INSERT INTO ' . $settings["dbprefix"] . '_reg_antispam (regid, regcode, regtime) VALUES (\'{MD5}\', \'{PLAIN}\', \'{TIME}\')';
$queries["clean_spambot"]      = 'DELETE FROM ' . $settings["dbprefix"] . '_reg_antispam WHERE regtime < \'{TIME}\'';
$queries["get_spambot"]        = 'SELECT regcode FROM ' . $settings["dbprefix"] . '_reg_antispam WHERE regid = \'{ID}\'';
$queries["remove_spambot"]     = 'DELETE FROM ' . $settings["dbprefix"] . '_reg_antispam WHERE regid = \'{ID}\'';
$queries["check_unique"]       = 'SELECT * FROM ' . $settings["dbprefix"] . '_users WHERE LCASE(email) = \'{EMAIL}\' OR LCASE(username) = \'{USERNAME}\'';
$queries["add_member"]         = 'INSERT INTO ' . $settings["dbprefix"] . '_users (username, password, email, gid, root_url, root_path) VALUES (\'{USERNAME}\', \'{PASSWORD}\', \'{EMAIL}\', \'{GID}\', \'{URL}\', \'{PATH}\')';

// Validation
$queries["add_validate"]       = 'INSERT INTO ' . $settings["dbprefix"] . '_validating (vid, uid, vtime, ip_address, type) VALUES (\'{VID}\', \'{UID}\', \'{TIME}\', \'{IP}\', \'{TYPE}\')';
$queries["check_validate"]     = 'SELECT ' . $settings["dbprefix"] . '_validating.uid, ' . $settings["dbprefix"] . '_validating.type, ' . $settings["dbprefix"] . '_users.username, ' . $settings["dbprefix"] . '_users.email FROM ' . $settings["dbprefix"] . '_validating, ' . $settings["dbprefix"] . '_users WHERE vid = \'{VID}\' AND ' . $settings["dbprefix"] . '_validating.uid = ' . $settings["dbprefix"] . '_users.uid';
$queries["delete_validate"]    = 'DELETE FROM ' . $settings["dbprefix"] . '_validating WHERE vid = \'{VID}\'';
$queries["set_admin_validate"] = 'UPDATE ' . $settings["dbprefix"] . '_validating SET type = 2 WHERE vid = \'{VID}\'';
$queries["delete_uid_validate"] = 'DELETE FROM ' . $settings["dbprefix"] . '_validating WHERE uid = {UID}';
$queries["update_validate"] = 'UPDATE ' . $settings["dbprefix"] . '_validating SET type = {TYPE} WHERE uid = {UID}';

// Lost password/Resent validation
$queries["check_username"] = 'SELECT ' . $settings["dbprefix"] . '_validating.type, ' . $settings["dbprefix"] . '_validating.vtime, ' . $settings["dbprefix"] . '_users.* FROM ' . $settings["dbprefix"] . '_users LEFT JOIN ' . $settings["dbprefix"] . '_validating ON (' . $settings["dbprefix"] . '_validating.uid = ' . $settings["dbprefix"] . '_users.uid) WHERE ' . $settings["dbprefix"] . '_users.username = \'{USERNAME}\'';
$queries["check_email"]    = 'SELECT ' . $settings["dbprefix"] . '_validating.type, ' . $settings["dbprefix"] . '_validating.vtime, ' . $settings["dbprefix"] . '_users.* FROM ' . $settings["dbprefix"] . '_users LEFT JOIN ' . $settings["dbprefix"] . '_validating ON (' . $settings["dbprefix"] . '_validating.uid = ' . $settings["dbprefix"] . '_users.uid) WHERE ' . $settings["dbprefix"] . '_users.email = \'{EMAIL}\'';
$queries["new_password"]   = 'UPDATE ' . $settings["dbprefix"] . '_users SET password = \'{PASSWORD}\' WHERE uid = \'{UID}\'';

// Admin CP
$queries["total_members"]    = 'SELECT * FROM ' . $settings["dbprefix"] . '_users';
$queries["total_validate"]   = 'SELECT ' . $settings["dbprefix"] . '_validating.uid FROM ' . $settings["dbprefix"] . '_validating, ' . $settings["dbprefix"] . '_users WHERE ' . $settings["dbprefix"] . '_validating.uid = ' . $settings["dbprefix"] . '_users.uid  AND ' . $settings["dbprefix"] . '_validating.type != 4';
$queries["group_list"]       = 'SELECT gid, groupname FROM ' . $settings["dbprefix"] . '_groups ORDER BY groupname ASC';
$queries["check_id"]         = 'SELECT COUNT(*) FROM ' . $settings["dbprefix"] . '_users WHERE uid = \'{UID}\'';
$queries["get_group_info"]   = 'SELECT * FROM ' . $settings["dbprefix"] . '_groups WHERE gid = \'{GID}\'';
$queries["update_user"]      = 'UPDATE ' . $settings["dbprefix"] . '_users SET username = \'{USERNAME}\', password = {PASSWORD}, email = \'{EMAIL}\', offset = \'{TIME}\', dst = {BST}, gid = {GID}, sql = {SQL}, dbhost = {DBHOST}, dbuser = {DBUSER}, dbpass = {DBPASS}, dbname = {DBNAME}, root_url = \'{URL}\', root_path = \'{ROOT}\', user_space = {SPACE}, language = {LANG} WHERE uid = {UID}';
$queries["add_user"]         = 'INSERT INTO ' . $settings["dbprefix"] . '_users (username, password, email, offset, dst, gid, sql, dbhost, dbuser, dbpass, dbname, root_url, root_path, user_space, language) VALUES (\'{USERNAME}\', \'{PASSWORD}\', \'{EMAIL}\', \'{TIME}\', {BST}, {GID}, {SQL}, {DBHOST}, {DBUSER}, {DBPASS}, {DBNAME}, \'{URL}\', \'{ROOT}\', {SPACE}, {LANG})';
$queries["find_user"]        = 'SELECT ' . $settings["dbprefix"] . '_users.*, ' . $settings["dbprefix"] . '_groups.* FROM ' . $settings["dbprefix"] . '_users, ' . $settings["dbprefix"] . '_groups WHERE LCASE(username) LIKE \'%{USERNAME}%\' AND ' . $settings["dbprefix"] . '_groups.gid = ' . $settings["dbprefix"] . '_users.gid ORDER BY username ASC';
$queries["find_user_by_gid"] = 'SELECT ' . $settings["dbprefix"] . '_users.*, ' . $settings["dbprefix"] . '_groups.* FROM ' . $settings["dbprefix"] . '_users, ' . $settings["dbprefix"] . '_groups WHERE LCASE(username) LIKE \'%{USERNAME}%\' AND ' . $settings["dbprefix"] . '_groups.gid = ' . $settings["dbprefix"] . '_users.gid AND ' . $settings["dbprefix"] . '_users.gid = \'{GID}\' ORDER BY username ASC';
$queries["delete_user"]      = 'DELETE FROM ' . $settings["dbprefix"] . '_users WHERE uid = \'{UID}\'';
$queries["users_by_group"]   = 'SELECT * FROM ' . $settings["dbprefix"] . '_users WHERE gid = {GID}';
$queries["users_by_name"]    = 'SELECT * FROM ' . $settings["dbprefix"] . '_users WHERE username IN({IN})';
$queries["group_total"]      = 'SELECT COUNT(' . $settings["dbprefix"] . '_users.gid) as total, ' . $settings["dbprefix"] . '_groups.* FROM ' . $settings["dbprefix"] . '_users RIGHT JOIN ' . $settings["dbprefix"] . '_groups ON (' . $settings["dbprefix"] . '_users.gid = ' . $settings["dbprefix"] . '_groups.gid) GROUP BY ' . $settings["dbprefix"] . '_groups.gid ORDER BY groupname ASC';
$queries["group_by_name"]    = 'SELECT * FROM ' . $settings["dbprefix"] . '_groups WHERE LCASE(groupname) = \'{GROUP}\'';
$queries["add_group"]        = 'INSERT INTO ' . $settings["dbprefix"] . '_groups (groupname, add_notes, del_admin_msg, show_url, use_bookmarks, stats, lock_dir, access_ucp, access_acp, chmod, upload, download, editor, view_source, view_img, mp3, `delete`, `rename`, copy, move, newfolder, newfile, overwrite, create_archive, view_archive, archive_save_options, make_symlink, verify_file, group_space, show_hidden_files, access_type, file_types, allow_no_extension, offline) VALUES (\'{GROUP}\', {NOTE}, {MSG}, {URL}, {BOOKMARKS}, {STATS}, {LOCK}, {UCP}, {ACP}, {CHMOD}, {UPLOAD}, {DOWNLOAD}, {EDIT}, {SOURCE}, {IMG}, {MP3}, {DELETE}, {RENAME}, {COPY}, {MOVE}, {MKDIR}, {MKFILE}, {OVERWRITE}, {MKARC}, {ARCHIVE}, {ARC_OPTIONS}, {SYMLINK}, {MD5}, {SPACE}, {HIDDEN}, {ACCESS}, \'{TYPES}\', {NOEXT}, {OFFLINE})';
$queries["total_in_group"]   = 'SELECT COUNT(' . $settings["dbprefix"] . '_users.gid) as total, ' . $settings["dbprefix"] . '_groups.groupname FROM ' . $settings["dbprefix"] . '_users RIGHT JOIN ' . $settings["dbprefix"] . '_groups ON (' . $settings["dbprefix"] . '_users.gid = ' . $settings["dbprefix"] . '_groups.gid) WHERE ' . $settings["dbprefix"] . '_users.gid = {GID} GROUP BY ' . $settings["dbprefix"] . '_groups.gid';
$queries["update_group"]     = 'UPDATE ' . $settings["dbprefix"] . '_groups SET groupname = \'{GROUP}\', add_notes = {NOTE}, del_admin_msg = {MSG}, show_url = {URL}, use_bookmarks = {BOOKMARKS}, stats = {STATS}, lock_dir = {LOCK}, access_ucp = {UCP}, access_acp = {ACP}, chmod = {CHMOD}, upload = {UPLOAD}, download = {DOWNLOAD}, editor = {EDIT}, view_source = {SOURCE}, view_img = {IMG}, mp3 = {MP3}, `delete` = {DELETE}, `rename` = {RENAME}, copy = {COPY}, move = {MOVE}, newfolder = {MKDIR}, newfile = {MKFILE}, overwrite = {OVERWRITE}, create_archive = {MKARC}, view_archive = {ARCHIVE}, archive_save_options = {ARC_OPTIONS}, make_symlink = {SYMLINK}, verify_file = {MD5}, group_space = {SPACE}, show_hidden_files = {HIDDEN}, access_type = {ACCESS}, file_types = \'{TYPES}\', allow_no_extension = {NOEXT}, offline = {OFFLINE} WHERE gid = {GID}';
$queries["move_groups"]      = 'UPDATE ' . $settings["dbprefix"] . '_users SET gid = {NEW} WHERE gid = {GID}';
$queries["delete_group"]     = 'DELETE FROM ' . $settings["dbprefix"] . '_groups WHERE gid = {GID}';
$queries["validate_list"]    = 'SELECT ' . $settings["dbprefix"] . '_users.*, ' . $settings["dbprefix"] . '_groups.*, ' . $settings["dbprefix"] . '_validating.* FROM ' . $settings["dbprefix"] . '_users, ' . $settings["dbprefix"] . '_groups, ' . $settings["dbprefix"] . '_validating WHERE ' . $settings["dbprefix"] . '_groups.gid = ' . $settings["dbprefix"] . '_users.gid AND ' . $settings["dbprefix"] . '_users.uid = ' . $settings["dbprefix"] . '_validating.uid AND ' . $settings["dbprefix"] . '_validating.type != 4';

?>