<?php

/*
 * Invision Power File Manager
 * Image viewer
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.0
 * Last Modified: 9th August 2004
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

// Clean the user input
$target     = clean_path($input["target"]);

// Set some parameters
$global_tpl = "skin/popup.tpl";

if (file_exists($permissions["root"] . $target) == false)
{
    // The user didn't select any existing object
    $page["title"] = $page["usererr"];
    $page["msg"]   = $page["noexist"];
}
else if (is_file($permissions["root"] . $target) == false)
{
    // The user didn't select a file, but selected folder or none supported file type, eg socket or block device
    $page["title"]  = $page["usererr"];
    $page["msg"]    = $page["nofile"];
}
else if (file_permission($target) == false || $permissions["view_img"] == 0 || is_image($target) == false)
{
    // The user doesn't have filetype permissions
    $page["title"]  = $page["usererr"];
    $page["msg"]    = $page["noperm"];
}
else if (filesize($permissions["root"] . $target) == 0)
{
    // The file is empty
    $page["title"]  = $page["blank"];
    $page["msg"]    = $page["empty"];
}
else
{
    // Open the file
    $fp = fopen($permissions["root"] . $target, "r");

    if (empty($fp) == true)
    {
        // The file could not be opened
        $page["title"]  = $page["system"];
        $page["msg"]    = $page["noopen"];
    }
    else
    {
        // Read the data
        $size = filesize($permissions["root"] . $target);
        $data = fread($fp, $size);
        fclose($fp);

        header("Content-type: image/" . ext($target), true);
        header("Content-length: " . $size);
        header("Content-Transfer-Encoding: binary");

        echo $data;

        exit;
    }
}

$page["js"]      = "";
$page["content"] = static_template($settings["script_dir"] . "skin/error.tpl", $page);

?>