<?php

/*
 * Invision Power File Manager
 * Login module
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 25th January 2005
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

// Always delete the cookies no matter what
setcookie($settings["user_cookie"]);
setcookie($settings["pass_cookie"]);

if ($input["op"] == "out")
{
    if ($settings["require_auth"] == false)
    {
        // Redirect to the guest file listing
        go_to($settings["script_url"] . "index.php?act=list");
    }
}
else if ($input["op"] == "in")
{
    // User is logging in, check their authorisation

    if (($permissions = auth_user($input["username"], md5($input["password"]))) != false)
    {
        // Stop the user being silly and trying to use the guest details
        if ($permissions["uid"] == $settings["default_userid"] && $settings["require_auth"] == false)
        {
            $page["msg"] = $page["invalid"];
        }
        else if (empty($permissions["validate"]) == false)
        {
            if ($permissions["validate"] == AUTH_ADMIN)
            {
                $page["msg"] = $page["admin_validation"];
            }
            else
            {
                $page["msg"] = $page["email_validation"];
            }
        }
        else
        {
            if ($settings["cookie_time"] != "")
            {
                // Find out the time the cookie should last
                $settings["cookie_time"] = time() + $settings["cookie_time"];
            }

            // Set the cookies
            setcookie($settings["user_cookie"], $permissions["uid"], (int) $settings["cookie_time"]);
            setcookie($settings["pass_cookie"], md5($input["password"]), (int) $settings["cookie_time"]);

            // Redirect to the correct page
            set_history();
            go_to($settings["script_url"] . "index.php?act=list");
        }
    }
    else
    {
        $page["msg"] = $page["invalid"];
    }
}

if ($settings["offline"] == true)
{
    // The page is offline and the user is not an admin,
    // so change the register message to the offline message
    $page["caption"]       = $page["offline_title"];
    $page["title"]         = $page["offline_title"];
    $page["msg"]           = $settings["offline_reason"];

    $settings["allow_reg"] = false;
}

$blocks = get_blocks($settings["script_dir"] . "skin/login.tpl", array("error", "register", "guest"));

// Registration has been disabled
if ($settings["allow_reg"] == false)
{
    $blocks["register"] = "";
}

// There is no error
if (isset($page["msg"]) == false)
{
    $blocks["error"] = "";
}

// The user is required to login, so no need to show the cancel button
if ($settings["require_auth"] == true)
{
    $blocks["guest"] = "";
}

$page["js"]      = "";
$page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/login.tpl", $blocks));

?>