<?PHP

/*
 * Invision Power File Manager
 * MP3 Info
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Ludovico Magnocavallo, Stephen Ball
 * Version: 1.0.0
 * Last Modified: 16th August 2004
 * -------------------------------------
 *
 * Modification of the MP3 Info class from Zend
 * Based on :
 *
 * http://www.zend.com/codex.php?id=160&single=1
 * By Ludovico Magnocavallo of Sumatra Solutions srl (http://www.sumatrasolutions.com)
 *
 * MP3 header reference at http://www.mp3-tech.org/
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

class MP3 {
    var $id3_genres_array = array(
            'Blues', 'Classic Rock', 'Country', 'Dance', 'Disco', 'Funk', 'Grunge', 'Hip-Hop', 'Jazz', 'Metal', 'New Age', 'Oldies', 'Other', 'Pop', 'R&B', 'Rap', 'Reggae', 'Rock', 'Techno', 'Industrial',
            'Alternative', 'Ska', 'Death Metal', 'Pranks', 'Soundtrack', 'Euro-Techno', 'Ambient', 'Trip-Hop', 'Vocal', 'Jazz+Funk', 'Fusion', 'Trance', 'Classical', 'Instrumental', 'Acid', 'House',
            'Game', 'Sound Clip', 'Gospel', 'Noise', 'AlternRock', 'Bass', 'Soul', 'Punk', 'Space', 'Meditative', 'Instrumental Pop', 'Instrumental Rock', 'Ethnic', 'Gothic', 'Darkwave',
            'Techno-Industrial', 'Electronic', 'Pop-Folk', 'Eurodance', 'Dream', 'Southern Rock', 'Comedy', 'Cult', 'Gangsta', 'Top 40', 'Christian Rap', 'Pop/Funk', 'Jungle', 'Native American', 'Cabaret',
            'New Wave', 'Psychadelic', 'Rave', 'Showtunes', 'Trailer', 'Lo-Fi', 'Tribal', 'Acid Punk', 'Acid Jazz', 'Polka', 'Retro', 'Musical', 'Rock & Roll', 'Hard Rock', 'Folk', 'Folk/Rock', 'National Folk',
            'Swing', 'Fast Fusion', 'Bebob', 'Latin', 'Revival', 'Celtic', 'Bluegrass', 'Avantgarde', 'Gothic Rock', 'Progressive Rock', 'Psychedelic Rock', 'Symphonic Rock', 'Slow Rock', 'Big Band',
            'Chorus', 'Easy Listening', 'Acoustic', 'Humour', 'Speech', 'Chanson', 'Opera', 'Chamber Music', 'Sonata', 'Symphony', 'Booty Bass', 'Primus', 'Porn Groove', 'Satire', 'Slow Jam', 'Club', 'Tango', 'Samba',
            'Folklore', 'Ballad', 'Power Ballad', 'Rhythmic Soul', 'Freestyle', 'Duet', 'Punk Rock', 'Drum Solo', 'Acapella', 'Euro-house', 'Dance Hall'
        );
    var $info_bitrates = array(1 => array(1 => array(0 => 0, 16 => 32, 32 => 64, 48 => 96, 64 => 128, 80 => 160, 96 => 192, 112 => 224, 128 => 256, 144 => 288, 160 => 320, 176 => 352, 192 => 384, 208 => 416, 224 => 448, 240 => false),
                                          2 => array(0 => 0, 16 => 32, 32 => 48, 48 => 56, 64 =>  64, 80 =>  80, 96 =>  96, 112 => 112, 128 => 128, 144 => 160, 160 => 192, 176 => 224, 192 => 256, 208 => 320, 224 => 384, 240 => false),
                                          3 => array(0 => 0, 16 => 32, 32 => 40, 48 => 48, 64 =>  56, 80 =>  64, 96 =>  80, 112 =>  96, 128 => 112, 144 => 128, 160 => 160, 176 => 192, 192 => 224, 208 => 256, 224 => 320, 240 => false)
                                    ),
                               2 => array(1 => array(0 => 0, 16 => 32, 32 => 48, 48 => 56, 64 =>  64, 80 => 80, 96 => 96, 112 => 112, 128 => 128, 144 => 144, 160 => 160, 176 => 176, 192 => 192, 208 => 224, 224 => 256, 240 => false),
                                          2 => array(0 => 0, 16 =>  8, 32 => 16, 48 => 24, 64 =>  32, 80 => 40, 96 => 48, 112 =>  56, 128 =>  64, 144 =>  80, 160 =>  96, 176 => 112, 192 => 128, 208 => 144, 224 => 160, 240 => false),
                                          3 => array(0 => 0, 16 =>  8, 32 => 16, 48 => 24, 64 =>  32, 80 => 40, 96 => 48, 112 =>  56, 128 =>  64, 144 =>  80, 160 =>  96, 176 => 112, 192 => 128, 208 => 144, 224 => 160, 240 => false)
                                    )
                         );
    var $info_versions = array(0 => "Reserved", 1 => "MPEG Version 1", 2 => "MPEG Version 2", 2.5 => "MPEG Version 2.5");
    var $info_layers   = array("Reserved", "Layer I", "Layer II", "Layer III");
    var $info_sampling_rates = array(0   => array(0 => false, 4 => false, 8 => false, 12 => false),
                                     1   => array(0 => 44100, 4 => 48000, 8 => 32000, 12 => false),
                                     2   => array(0 => 22050, 4 => 24000, 8 => 16000, 12 => false),
                                     2.5 => array(0 => 11025, 4 => 12000, 8 => 8000, 12 => false)
                               );

    var $info_channel_modes = array(0 => "Stereo", 64 => "Joint stereo", 128 => "Dual channel", 192 => "Single channel");

    var $file       = "";
    var $fh         = false;
    var $error      = false;
    var $id3_parsed = false;

    var $id3        = array();
    var $info       = array();

    function mp3($file)
    {
        $this->file  = $file;
        $this->fh    = fopen($this->file, "r");
    }

    function get_id3()
    {
        $this->id3_parsed = true;
        fseek($this->fh, -128, SEEK_END);
        $line = fread($this->fh, 10000);

        if (preg_match("/^TAG/", $line) == true)
        {
            // Found an ID3 tag
            $this->id3 = unpack("a3tag/a30title/a30author/a30album/a4year/a30comment/C1genre_id", $line);
            $this->id3["genre"] = $this->id3_genres_array[$this->id3["genre_id"]];
            return true;
        }
        else
        {
            $this->error = "no_id3";
            return false;
        }
    }

    // get_info() helper methods
    function calculate_length($id3v2_tagsize = 0)
    {
        $length = floor(($this->info["filesize"] - $id3v2_tagsize) / $this->info["bitrate"] * 0.008);
        $min = floor($length / 60);
        // $min = strlen($min) == 1 ? "0$min" : $min;
        $sec = $length % 60;
        $sec = strlen($sec) == 1 ? "0$sec" : $sec;

        return "$min:$sec";
    }

    function get_info()
    {
        $second = $this->synchronize();
        $third = ord(fread($this->fh, 1));
        $fourth = ord(fread($this->fh, 1));

        $this->info["version_id"]    = ($second & 16) > 0 ? (($second & 8) > 0 ? 1 : 2) : (($second & 8) > 0 ? 0 : 2.5);
        $this->info["version"]       = $this->info_versions[$this->info["version_id"]];
        $this->info["layer_id"]      = ($second & 4) > 0 ? (($second & 2) > 0 ? 1 : 2) : (($second & 2) > 0 ? 3 : 0);
        $this->info["layer"]         = $this->info_layers[$this->info["layer_id"]];
        $this->info["protection"]    = ($second & 1) > 0 ? 0 : 1;
        $this->info["bitrate"]       = $this->info_bitrates[$this->info["version_id"]][$this->info["layer_id"]][($third & 240)];
        $this->info["sampling_rate"] = $this->info_sampling_rates[$this->info["version_id"]][($third & 12)];
        $this->info["channel_mode"]  = $this->info_channel_modes[$fourth & 192];
        $this->info["copyright"]     = ($fourth & 8) > 0 ? 1 : 0;
        $this->info["original"]      = ($fourth & 4) > 0 ? 1 : 0;
        $this->info["filesize"]      = filesize($this->file);
        $this->info["length"]        = $this->calculate_length();
    }

    function synchronize()
    {
        $finished = false;
        rewind($this->fh);

        while ($finished == false)
        {
            $skip = ord(fread($this->fh, 1));

            while ($skip != 255 && !feof($this->fh))
            {
                $skip = ord(fread($this->fh, 1));
            }

            if (feof($this->fh))
            {
                $this->error = "no info header found";
            }

            $store = ord(fread($this->fh, 1));

            if ($store >= 225)
            {
                $finished = true;
            }
            else if (feof($this->fh))
            {
                $this->error = "no info header found";
            }
        }
        return $store;
    }

    function close()
    {
        @fclose($this->fh);
    }
}

?>