<?php

/*
 * Invision Power File Manager
 * Simple popup dialogs
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.0
 * Last Modified: 9th August 2004
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

// Set some parameters
$global_tpl = "skin/popup.tpl";

switch($input["id"])
{
    case "mup":
        /* ----------------------------
                Multi-file upload
           ---------------------------- */
        // When showing the multi file upload form, we need to create the form fields
        $blocks = get_blocks($settings["script_dir"] . "skin/cards/multi-upload.tpl", array("uploads"));

        $data = "";
        for ($i = 1; $i <= $settings["max_uploads"]; $i++)
        {
            $data .= parse_html(array("filename" => preg_replace("/<%ID%>/i", $i, $page["filename"])), $blocks["uploads"]);
        }
        $blocks["uploads"] = $data;

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/cards/multi-upload.tpl", $blocks));
    break;
    case "ren":
        /* ----------------------------
                    Mass rename
           ---------------------------- */
        $info["folders"] = array();
        $info["files"]   = array();

        $dirs            = explode("|", $input["dirs"]);
        $files           = explode("|", $input["files"]);

        // Load the dynamic template blocks
        $blocks = get_blocks($settings["script_dir"] . "skin/cards/rename.tpl", array("folders", "files"));

        unset($files[count($files) - 1]);
        unset($dirs[count($dirs) - 1]);

        $i = 0;
        foreach ($dirs as $var)
        {
            $info["folders"][] = array("ID" => $i, "TARGET" => $var);
            $i++;
        }
        foreach ($files as $var)
        {
            $info["files"][] = array("ID" => $i, "TARGET" => $var);
            $i++;
        }

        $blocks          = parse_blocks($info, $blocks);

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/cards/rename.tpl", $blocks));
    break;
    case "chmod":
        /* ----------------------------
                    Mass CHMOD
           ---------------------------- */

        $blocks = get_blocks($settings["script_dir"] . "skin/cards/chmod.tpl", array("dir"));

        if (isset($input["dirs"]) == false || empty($input["dirs"]) == true)
        {
            $blocks["dir"] = "";
        }

        $page["chmod"] = $settings["default_chmod"];
        // Get the chmod of the file if only 1 is selected
        if ($input["i"] == 1)
        {
            if (empty($input["files"]) == true)
            {
                $path = substr($input["dirs"], 0, strlen($input["dirs"]) - 1);
            }
            else
            {
                $path = substr($input["files"], 0, strlen($input["files"]) - 1);
            }

            $path = empty($input["dir"]) == true ? $permissions["root"] . $path : $permissions["root"] . $input["dir"] . "/" . $path;

            // If the "full chmod" setting is on we need to strip the leading character
            $page["chmod"] = $settings["full_chmod"] == true ? substr(chmod_value($path), 1, 4) : chmod_value($path);
        }

        // Now to get the selected check boxes
        $part["owner"]  = substr($page["chmod"], 0, 1);
        $part["group"]  = substr($page["chmod"], 1, 1);
        $part["public"] = substr($page["chmod"], 2, 1);

        $checked = "checked=\"checked\"";

        // An array containing the patterns to use for the different values
        $patterns = array("1" => array("execute" => $checked, "write" => "", "read" => ""),
                          "2" => array("execute" => "", "write" => $checked, "read" => ""),
                          "3" => array("execute" => $checked, "write" => $checked, "read" => ""),
                          "4" => array("execute" => "", "write" => "", "read" => $checked),
                          "5" => array("execute" => $checked, "write" => "", "read" => $checked),
                          "6" => array("execute" => "", "write" => $checked, "read" => $checked),
                          "7" => array("execute" => $checked, "write" => $checked, "read" => $checked));

        // Populate the owner fields
        $page["owner_read"]     = $patterns[$part["owner"]]["read"];
        $page["owner_write"]    = $patterns[$part["owner"]]["write"];
        $page["owner_execute"]  = $patterns[$part["owner"]]["execute"];

        // Populate the group fields
        $page["group_read"]     = $patterns[$part["group"]]["read"];
        $page["group_write"]    = $patterns[$part["group"]]["write"];
        $page["group_execute"]  = $patterns[$part["group"]]["execute"];

        // Populate the public fields
        $page["public_read"]    = $patterns[$part["public"]]["read"];
        $page["public_write"]   = $patterns[$part["public"]]["write"];
        $page["public_execute"] = $patterns[$part["public"]]["execute"];

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/cards/chmod.tpl", $blocks));
    break;
    case "ver":
        /* ----------------------------
                    MD5 Hash
           ---------------------------- */
        $file_name  = "/" . $input["target"];

        // If we are running on Windows we need to reverse the slashes
        if (is_win() == true)
        {
            $file_name = preg_replace("/[\/]/", "\\", $file_name);
        }

        $page["icon"]           = get_icon($permissions["root"] . $input["target"]);
        $page["md5_hash_value"] = get_file_md5($permissions["root"] . $input["target"]);
        $page["file"]           = $file_name;
        $page["file_name"]      = basename($file_name);

        $page["content"]        = static_template($settings["script_dir"] . "skin/cards/verify.tpl", $page);

    break;
    case "arc":
        /* ----------------------------
                    Archiving
           ---------------------------- */
        $types = get_archives_types();
        natcasesort($types);

        // Create a drop down list of items
        $page["types"] = dropdown("arctype", $types, key($types));

        $blocks = get_blocks($settings["script_dir"] . "skin/cards/archive.tpl", array("options"));

        if ($permissions["arc_save"] != SAVE_AND_DOWNLOAD)
        {
            $blocks["options"] = "";
        }

        $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/cards/archive.tpl", $blocks));
    break;
    case "new":
        /* ----------------------------
               Create new file
           ---------------------------- */
        load_language($permissions["lang"], "templates");

        natcasesort($templates["description"]);

        $page["templates"] = "";
        foreach ($templates["description"] as $key => $var)
        {
            if (file_permission("tmp." . $templates["extension"][$key]) == true && $key > 0)
            {
                $page["templates"] .= "<option value=\"" . $key . "\">" . $var . "</option>";
            }
            else if ($key == 0)
            {
                $page["templates"] .= "<option value=\"" . $key . "\" selected=\"selected\">" . $var . "</option>";
            }
        }

        $page["content"] = static_template($settings["script_dir"] . "skin/cards/mkfile.tpl", $page);
    break;
    case "error":
        // Why is this here? Does it ever trigger? Must be here for a reason, right?
        echo "la la la la";
    break;
    default:
        /* ----------------------------
               All other popup pages
           ---------------------------- */
        $page["content"] = static_template($settings["script_dir"] . "skin/cards/" . $cards[$input["id"]] . ".tpl", $page);
}

// Construct the page
$page["js"]      = $cards[$input["id"]];
$page["dirs"]    = $input["dirs"];
$page["files"]   = $input["files"];
$page["this"]    = $input["dir"];
$page["target"]  = $input["target"];

?>