<?php

/*
 * Invision Power File Manager
 * Note editor
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.2
 * Last Modified: 24th February 2005
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
               Module Functions
   ----------------------------------------- */

// Generates an image
function show_gd_img($content)
{
    $content = "  " . preg_replace( "/(\w)/", "\\1 ", $content ) . " ";

	header("Content-Type: image/png", true);

	$tmp_x = 140;
	$tmp_y = 20;

	$image_x = 210;
	$image_y = 65;

	$circles = 3;

	if ($settings["gd_version"] == 1)
	{
		$tmp = imagecreate($tmp_x, $tmp_y);
		$im  = imagecreate($image_x, $image_y);
	}
	else
	{
		$tmp = imagecreatetruecolor($tmp_x, $tmp_y);
		$im  = imagecreatetruecolor($image_x, $image_y);
	}

	$white  = ImageColorAllocate($tmp, 255, 255, 255);
	$black  = ImageColorAllocate($tmp, 0, 0, 0);
	$grey   = ImageColorAllocate($tmp, 210, 210, 210);

	imagefill($tmp, 0, 0, $white);

	for ($i=1; $i<=$circles; $i++)
	{
		$randomcolor = imagecolorallocate($tmp, rand(100,255), rand(100,255), rand(100,255));
        imagefilledellipse($tmp, rand(0, $tmp_x - 10), rand(0, $tmp_y - 3), rand(20,70), rand(20,70), $randomcolor);
    }

    imagestring($tmp, 5, 0, 2, $content, $tblack);

	// Distort by resizing
	imagecopyresized($im, $tmp, 0, 0, 0, 0, $image_x, $image_y, $tmp_x, $tmp_y);

	imagedestroy($tmp);

	$white   = imagecolorallocate($im, 255, 255, 255);
	$black   = imagecolorallocate($im, 0, 0, 0);
	$grey    = imagecolorallocate($im, 100, 100, 100);

	$random_pixels = $image_x * $image_y / 10;

	for ($i=0; $i<$random_pixels; $i++)
    {
		imagesetpixel($im, rand(0, $image_x), rand(0, $image_y), $black);
	}

	$no_x_lines = ($image_x - 1) / 5;

	for ($i=0; $i<=$no_x_lines; $i++)
	{
		// X lines
		imageline($im, $i * $no_x_lines, 0, $i * $no_x_lines, $image_y, $grey);

		// Diag lines
		imageline($im, $i * $no_x_lines, 0, ($i * $no_x_lines) + $no_x_lines, $image_y, $grey);
	}

    $no_y_lines = ($image_y - 1) / 5;

    for ($i=0; $i<=$no_y_lines; $i++)
	{
		imageline($im, 0, $i * $no_y_lines, $image_x, $i * $no_y_lines, $grey);
	}

	imagePNG($im);
	imagedestroy($im);

	exit();
}

// Shows a single digit image
function show_gif_img($id)
{
    $numbers = array( 0 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIUDH5hiKsOnmqSPjtT1ZdnnjCUqBQAOw==",
					  1 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIUjAEWyMqoXIprRkjxtZJWrz3iCBQAOw==",
					  2 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIUDH5hiKubnpPzRQvoVbvyrDHiWAAAOw==",
					  3 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIVDH5hiKbaHgRyUZtmlPtlfnnMiGUFADs=",
					  4 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIVjAN5mLDtjFJMRjpj1Rv6v1SHN0IFADs=",
					  5 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIUhA+Bpxn/DITL1SRjnps63l1M9RQAOw==",
					  6 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIVjIEYyWwH3lNyrQTbnVh2Tl3N5wQFADs=",
					  7 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIUhI9pwbztAAwP1napnFnzbYEYWAAAOw==",
					  8 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIVDH5hiKubHgSPWXoxVUxC33FZZCkFADs=",
					  9 => "R0lGODlhCAANAJEAAAAAAP////4BAgAAACH5BAQUAP8ALAAAAAAIAA0AAAIVDA6hyJabnnISnsnybXdS73hcZlUFADs=",
					);

	header("Content-type: image/gif", true);
	echo base64_decode($numbers[$id]);
	exit();
}

// Generates the registration form
function show_reg_form($error = "")
{
    global $settings, $queries, $page, $link_id, $input;

    $blocks = get_blocks($settings["script_dir"] . "skin/reg/register.tpl", array("security", "error"));

    if (empty($error) == true)
    {
        $blocks["error"] = "";
    }
    else
    {
        $page["error_msg"] = $error;
    }

    // Show the security image if need be
    if ($settings["security_check"] == true)
    {
	    // Remove old reg codes from the system
		build_query($queries["clean_spambot"], array("TIME" => time() - (60 * (int) $settings["security_timeout"])));
        db_query($queries["clean_spambot"], $link_id);

        if (empty($input["id"]) == false)
        {
            // If the form has already been submitted delete the existing image to prevent
            // someone from "flooding" the database with images
            build_query($queries["remove_spambot"], array("ID" => $input["id"]));
            db_query($queries["remove_spambot"], $link_id);
        }

        // Generate a reg ID
        $id = md5(uniqid(microtime()));

    	// Generate a 6 character reg code
	   	mt_srand ((double) microtime() * 1000000);
		$code = mt_rand(100000, 999999);

        // Insert the reg code into the system
        build_query($queries["add_spambot"], array("MD5" => $id, "PLAIN" => $code, "TIME" => time()));
        db_query($queries["add_spambot"], $link_id);

        if ($settings["security_type"] == "gd")
        {
            // GD spam bot
            $page["img"] = "<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />";
        }
        else
        {
            // GIF spam bot
            $page["img"] = "<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "&amp;p=1\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />&nbsp;<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "&amp;p=2\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />&nbsp;<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "&amp;p=3\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />&nbsp;<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "&amp;p=4\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />&nbsp;<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "&amp;p=5\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />&nbsp;<img src=\"index.php?act=reg&amp;op=img&amp;id=" . $id . "&amp;p=6\" border=\"0\" alt=\"" . $page["security_image"] . "\" title=\"" . $page["security_image"] . "\" />";
        }

        $page["id"] = $id;
    }
    else
    {
        $blocks["security"] = "";
    }

    $page["tos"] = load_lang_file($permissions["lang"], "tos.txt");

    // Set the minimum lengths
    $page["username_tip"] = str_replace("<%MIN_USER_LEN%>", $settings["min_user_length"], $page["username_tip"]);
    $page["password_tip"] = str_replace("<%MIN_PASS_LEN%>", $settings["min_pass_length"], $page["password_tip"]);

    // Fill in the form fields
    $page["input_user"]      = empty($input["username"])  == true ? "" : $input["username"];
    $page["input_email"]     = empty($input["email"])     == true ? "" : $input["email"];
    $page["input_email2"]    = empty($input["email2"])    == true ? "" : $input["email2"];
    $page["input_password"]  = empty($input["password"])  == true ? "" : $input["password"];
    $page["input_password2"] = empty($input["password2"]) == true ? "" : $input["password2"];

    // Stop users complaining that they have already checked the agree field
    $page["input_agree"]  = "<input type=\"checkbox\" name=\"agree\" value=\"1\"";
    $page["input_agree"]  .= $input["agree"] == 1 ? " checked=\"checked\"" : "";
    $page["input_agree"]  .= " />";

    // Construct the page
    $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/reg/register.tpl", $blocks));

    return;
}

// Shows the manual validation form
function show_manual_form($error = "")
{
    global $page, $settings, $input;

    $blocks = get_blocks($settings["script_dir"] . "skin/reg/validation.tpl", array("error"));

    if (empty($error) == true)
    {
        $blocks["error"] = "";
    }
    else
    {
        $page["error_msg"] = $error;
    }

    // Fill in the form fields
    $page["input_uid"] = empty($input["uid"]) == true ? "" : $input["uid"];
    $page["input_key"] = empty($input["key"]) == true ? "" : $input["key"];

    $page["title"]   = $page["title_manual"];
    $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/reg/validation.tpl", $blocks));

    return;
}

// Shows the mail send form
function show_send_form($error = "")
{
    global $page, $settings, $input;

    $blocks = get_blocks($settings["script_dir"] . "skin/reg/send.tpl", array("error"));

    if (empty($error) == true)
    {
        $blocks["error"] = "";
    }
    else
    {
        $page["error_msg"] = $error;
    }

    // Fill in the form fields
    $page["input_user"]  = empty($input["username"]) == true ? "" : $input["username"];
    $page["input_email"] = empty($input["email"])    == true ? "" : $input["email"];

    $page["content"] = parse_html($page, dynamic_template($settings["script_dir"] . "skin/reg/send.tpl", $blocks));

    return;
}

// Generates a random password
function random_password($length)
{
	$possible = "01234567890!@#$%^&*()_+abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
	$str = "";

	while(strlen($str) < $length)
    {
		$str .= substr($possible, (rand() % strlen($possible)), 1);
	}
	return $str;
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

// If registration is disabled go back to the main page
if ($settings["allow_reg"] == false && $input["op"] != "lostpass" && $input["op"] != "sendpass")
{
    go_to($settings["script_url"] . "index.php");
}

// Delete cookies
setcookie($settings["user_cookie"]);
setcookie($settings["pass_cookie"]);

switch ($input["op"])
{
     case "img":
        /* ----------------------------
              Show the security code
           ---------------------------- */
        build_query($queries["get_spambot"], array("ID" => $input["id"]));
        $result     = db_query($queries["get_spambot"], $link_id);
        list($code) = db_fetch_array($result, $link_id);

        if ($settings["security_type"] == "gd")
        {
            show_gd_img($code);
        }
        else
        {
		    $id = substr($code, intval($input["p"]) - 1, 1);

            show_gif_img($id);
        }
     break;
     case "reg":
        /* ----------------------------
            Check/process registration
           ---------------------------- */
        build_query($queries["get_spambot"], array("ID" => $input["id"]));
        $result     = db_query($queries["get_spambot"], $link_id);
        list($code) = db_fetch_array($result, $link_id);

        $input["username"]  = trim($input["username"]);
        $input["password"]  = trim($input["password"]);
        $input["password2"] = trim($input["password2"]);
        $input["email"]     = trim($input["email"]);
        $input["email2"]    = trim($input["email2"]);

        if (strlen($input["username"]) < $settings["min_user_length"] || strlen($input["username"]) > 32)
        {
            // Invalid length username
            show_reg_form($page["username_length_invalid"]);
        }
        else if (strlen($input["password"]) < $settings["min_pass_length"] || strlen($input["password"]) > 32)
        {
            // Invalid length password
            show_reg_form($page["password_length_invalid"]);
        }
        else if ($input["password"] != $input["password2"])
        {
            // Non-matching passwords
            show_reg_form($page["password_mismatch"]);
        }
        else if (strlen($input["email"]) > 75)
        {
            // Email address too long
            show_reg_form($input["email_too_long"]);
        }
        else if (preg_match("/^[^@ ]+@[^@ ]+[\.][^@ \.]+$/", $input["email"]) == false || strlen($input["email"]) < 6)
        {
            // Invalid email address
            show_reg_form($page["email_invalid"]);
        }
        else if ($input["email"] != $input["email2"])
        {
            // Non-matching email addresses
            show_reg_form($page["email_mismatch"]);
        }
        else if ($code != $input["security"])
        {
            // Incorrect security code
            show_reg_form($page["security_code_invalid"]);
        }
        else if ($input["agree"] != 1)
        {
            // Did not agree
            show_reg_form($page["must_agree"]);
        }
        else if (preg_match("/\.\.\//", $input["username"]) == true || preg_match("/\\\/", $input["username"]) == true)
        {
            // A directory traversal character in the username
            show_reg_form($page["username_invalid"]);
        }
        else if (preg_match("/\.\.\//", $input["email"]) == true || preg_match("/\\\/", $input["email"]) == true)
        {
            // A directory traversal character in the email
            show_reg_form($page["email_invalid"]);
        }
        else
        {
            if ($settings["security_check"] == true)
            {
	            // Remove old reg codes from the system
        		build_query($queries["clean_spambot"], array("TIME" => time() - (60 * (int) $settings["security_timeout"])));
                db_query($queries["clean_spambot"], $link_id);

                if (empty($input["id"]) == false)
                {
                    // If the form has already been submitted delete the existing image to prevent
                    // someone from "flooding" the database with images
                    build_query($queries["remove_spambot"], array("ID" => $input["id"]));
                    db_query($queries["remove_spambot"], $link_id);
                }
            }

    		$input["username"] = preg_replace("/\s{2,}/", " ", $input["username"]);

            $email    = strtolower($input["email"]);
            $username = strtolower($input["username"]);

            build_query($queries["check_unique"], array("EMAIL" => $email, "USERNAME" => $username));
            $result = db_query($queries["check_unique"], $link_id);

            // Check for username and email address
            $found = false;
            if (db_num_rows($result, $link_id) > 0)
            {
                while ($query_data = db_fetch_array($result, $link_id))
                {
                    if (strtolower($query_data["email"]) == $email)
                    {
                        show_reg_form($page["email_used"]);
                        $found = true;
                        break;
                    }
                    else if (strtolower($query_data["username"]) == $username)
                    {
                        show_reg_form($page["username_used"]);
                        $found = true;
                        break;
                    }
                }
            }

            // Username and email were not found so continue with registration
            if ($found == false)
            {
                // Get the group name if needed
                if (preg_match("/<%GROUP%>/i", $settings["new_path"]) == true || preg_match("/<%GROUP%>/i", $settings["new_url"]) == true)
                {
                    build_query($queries["get_group_name"], array("GID" => $settings["default_group"]));
                    $result = db_query($queries["get_group_name"], $link_id);
                    list($group) = db_fetch_array($result, $link_id);
                }

                /*
                    Now to generate the path and URL

                    Variables which can be used:
                        <%USERNAME%> - Username
                        <%GROUP%>    - Groupname
                        <%TIME%>     - Timestamp
                        <%EMAIL%>    - Email address
                */

                $path_data = array("USERNAME" => $input["username"],
                                   "GROUP"    => $group,
                                   "TIME"     => time(),
                                   "EMAIL"    => $input["email"]
                                  );

                // Parse HTML??? What a silly function name, but its used in
                // our templating system and it does exactly what we want so
                // no need to write a new function
                $path = parse_html($path_data, $settings["new_path"]);
                $url  = parse_html($path_data, $settings["new_url"]);

                $details = array("USERNAME" => $input["username"],
                                 "PASSWORD" => md5($input["password"]),
                                 "EMAIL"    => $input["email"],
                                 "GID"      => $settings["default_group"],
                                 "PATH"     => $path,
                                 "URL"      => $url
                                );

                build_query($queries["add_member"], $details);
                $result = db_query($queries["add_member"], $link_id);

                if (empty($result) == true)
                {
                    $page["msg"]     = $page["error_adding_user"];
                    $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);
                }
                else
                {
                    if ($settings["auth_user_type"] != AUTH_NONE)
                    {
                        // Generate a new validating ID
                        $code = md5(uniqid(microtime()));

                        $id = db_insert_id($link_id);

                        // Insert the validation code
                        build_query($queries["add_validate"], array("VID" => $code, "UID" => $id, "TIME" => time(), "IP" => $input["IP_ADDRESS"], "TYPE" => (int) $settings["auth_user_type"]));
                        db_query($queries["add_validate"], $link_id);
                    }

                    if (create_directory_structure($path) == false)
                    {
                        $page["msg"]     = preg_replace("/<%EMAIL%>/i", $settings["admin_in_email"], $page["error_creating_root"]);
                        $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);

                        // Delete email validation since email isn't being sent
                        if ($settings["auth_user_type"] == AUTH_EMAIL)
                        {
                            build_query($queries["delete_validate"], array("VID" => $code));
                            db_query($queries["delete_validate"], $link_id);
                        }
                        else if ($settings["auth_user_type"] == AUTH_BOTH)
                        {
                            build_query($queries["set_admin_validate"], array("VID" => $code));
                            db_query($queries["set_admin_validate"], $link_id);
                        }
                    }
                    else
                    {
                        if ($settings["auth_user_type"] != AUTH_NONE)
                        {
                            if ($settings["auth_user_type"] == AUTH_ADMIN)
                            {
                                $page["msg"] = $page["registration_done_admin"];
                            }
                            else
                            {
                                $page["msg"] = $page["registration_done_email"];

                                // Load the registration email
                                $body = load_lang_file($permissions["lang"], "register.txt");

                                // Parse the variables
                                $info = array("NAME"           => $input["username"],
                                              "ADDRESS"        => $settings["script_url"],
                                              "ID"             => $id,
                                              "CODE"           => $code,
                                              "ADMIN_NAME"     => $settings["admin_name"],
                                              "AUTOMATIC_LINK" => $settings["script_url"] . "index.php?act=reg&op=validate&code=" . $code,
                                              "MANUAL_LINK"    => $settings["script_url"] . "index.php?act=reg&op=manual"
                                              );

                                $body = parse_html($info, $body);

                                sendmail($input["email"], $page["registration_email_subject"], $body);
                            }

                            $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);
                        }
                        else
                        {
                            $page["msg"] = $page["registration_done_login"];

                            // Add has selected to login on registration complete
                            if ($settings["login_on_reg"] == true)
                            {
                                if ($settings["cookie_time"] != "")
                                {
                                    // Find out the time the cookie should last
                                    $settings["cookie_time"] = time() + $settings["cookie_time"];
                                }

                                // Set the cookies
                                $permissions = auth_user($input["username"], md5($input["password"]));
                                
                                setcookie($settings["user_cookie"], $permissions["uid"], (int) $settings["cookie_time"]);
                                setcookie($settings["pass_cookie"], md5($input["password"]), (int) $settings["cookie_time"]);

                                $page["msg"] = $page["registration_done_start"];
                            }

                            $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);
                        }
                    }
                }
            }
        }
     break;
     case "lostpass":
     case "svalid":
        /* ----------------------------
              Lost pass & validation
           ---------------------------- */
        if ($input["op"] == "lostpass")
        {
            $page["op"]                  = "sendpass";

            $page["title"]               = $page["lost_password_title"];
            $page["instruct_title_send"] = $page["lost_password_title"];
        }
        else
        {
            $page["op"]                  = "sendval";

            $page["title"]               = $page["resend_title"];
            $page["instruct_title_send"] = $page["resend_title"];
        }

        show_send_form();
     break;
     case "sendpass":
     case "sendval":
        /* ----------------------------
             Send password/validation
           ---------------------------- */
        $page["op"]                  = $input["op"];

        if ($input["op"] == "sendpass")
        {
            // Send password
            $page["title"]               = $page["lost_password_title"];
            $page["instruct_title_send"] = $page["lost_password_title"];

            $newval = LOST_PASS;
        }
        else
        {
            // Send validation
            $page["title"]               = $page["resend_title"];
            $page["instruct_title_send"] = $page["resend_title"];

            $newval = AUTH_EMAIL;
        }

        if (empty($input["email"]) == true && empty($input["username"]) == true)
        {
            show_send_form($page["no_user_or_email"]);
        }
        else
        {
            $sql = $queries["check_username"];
            if (empty($input["email"]) == false)
            {
                $sql = $queries["check_email"];
            }

            build_query($sql, array("EMAIL" => $input["email"], "USERNAME" => $input["username"]));
            $result = db_query($sql, $link_id);

            if (db_num_rows($result, $link_id) < 1)
            {
                show_send_form($page["resend_no_account"]);
            }
            else
            {
                $query_data = db_fetch_array($result, $link_id);

                if ($query_data["type"] == AUTH_ADMIN)
                {
                    // Awaiting admin validation
                    show_send_form($page["validation_admin_only"]);
                }
                else if ($query_data["type"] == AUTH_BOTH && $input["op"] == "sendpass")
                {
                    // Awaiting email and admin validation so don't allow password validation
                    show_send_form($page["password_validation_not_allowed"]);
                }
                else if (isset($query_data["vtime"]) == true && $query_data["vtime"] - (time() - 60 * (int) $settings["email_timeout"]) > 0)
                {
                    show_send_form($page["resend_email_slow"]);
                }
                else
                {
                    // Delete any old validating requests for this user
                    build_query($queries["delete_uid_validate"], array("UID" => $query_data["uid"]));
                    db_query($queries["delete_uid_validate"], $link_id);

                    // Generate a new validating ID
                    $code = md5(uniqid(microtime()));

                    // Insert the new validation code
                    build_query($queries["add_validate"], array("VID" => $code, "UID" => $query_data["uid"], "TIME" => time(), "IP" => $input["IP_ADDRESS"], "TYPE" => $newval));
                    db_query($queries["add_validate"], $link_id);

                    if ($input["op"] == "sendpass")
                    {
                        // Load the lost password email
                        $body = load_lang_file($permissions["lang"], "password.txt");

                        // Parse the variables
                        $info = array("NAME"           => $query_data["username"],
                                      "ADDRESS"        => $settings["script_url"],
                                      "ID"             => $query_data["uid"],
                                      "CODE"           => $code,
                                      "ADMIN_NAME"     => $settings["admin_name"],
                                      "AUTOMATIC_LINK" => $settings["script_url"] . "index.php?act=reg&op=validate&code=" . $code,
                                      "MANUAL_LINK"    => $settings["script_url"] . "index.php?act=reg&op=manual",
                                      "IP_ADDRESS"     => $input["IP_ADDRESS"]
                                      );

                        $body = parse_html($info, $body);

                        sendmail($query_data["email"], $page["lostpass_email_subject"], $body);

                        $page["msg"] = $page["lostpass_sent"];
                    }
                    else
                    {
                        // Load the registration email
                        $body = load_lang_file($permissions["lang"], "register.txt");

                        // Parse the variables
                        $info = array("NAME"           => $query_data["username"],
                                      "ADDRESS"        => $settings["script_url"],
                                      "ID"             => $query_data["uid"],
                                      "CODE"           => $code,
                                      "ADMIN_NAME"     => $settings["admin_name"],
                                      "AUTOMATIC_LINK" => $settings["script_url"] . "index.php?act=reg&op=validate&code=" . $code,
                                      "MANUAL_LINK"    => $settings["script_url"] . "index.php?act=reg&op=manual"
                                      );

                        $body = parse_html($info, $body);

                        sendmail($query_data["email"], $page["registration_email_subject"], $body);

                        $page["msg"] = $page["resend_done_email"];
                    }

                    $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);
                }
            }
        }
     break;
     case "validate":
        /* ----------------------------
                Validate account
           ---------------------------- */
        build_query($queries["check_validate"], array("VID" => $input["code"]));
        $result = db_query($queries["check_validate"], $link_id);
        list($uid, $type, $username, $email) = db_fetch_array($result, $link_id);

        $page["title"] = $page["validation_title"];

        // Check the validation type
        if ($type == AUTH_EMAIL)
        {
            // The account is waiting for email validation
            build_query($queries["delete_validate"], array("VID" => $input["code"]));
            db_query($queries["delete_validate"], $link_id);

            $page["msg"] = $page["validation_complete"];
        }
        else if ($type == AUTH_BOTH)
        {
            // The account is waiting for email and admin validation
            build_query($queries["set_admin_validate"], array("VID" => $input["code"]));
            db_query($queries["set_admin_validate"], $link_id);

            $page["msg"] = $page["validation_email_complete"];
        }
        else if ($type == AUTH_ADMIN)
        {
            // The account is waiting for admin validation, the user shouldn't be here
            $page["msg"] = $page["validation_admin_only"];
        }
        else if ($type == LOST_PASS)
        {
            // The account is waiting for a new password
            build_query($queries["delete_validate"], array("VID" => $input["code"]));
            db_query($queries["delete_validate"], $link_id);

            // Set the new password
            $newpass = random_password(round(rand(7, 15)));
            build_query($queries["new_password"], array("PASSWORD" => md5($newpass), "UID" => $uid));
            db_query($queries["new_password"], $link_id);

            // Load the password reset
            $body = load_lang_file($permissions["lang"], "newpass.txt");

            // Parse the variables
            $info = array("NAME"           => $username,
                          "ADDRESS"        => $settings["script_url"],
                          "PASSWORD"       => $newpass,
                          "ADMIN_NAME"     => $settings["admin_name"],
                          "MANUAL_LINK"    => $settings["script_url"] . "index.php?act=login",
                          "IP_ADDRESS"     => $input["IP_ADDRESS"]
                          );

            $body = parse_html($info, $body);

            sendmail($email, $page["resetpass_email_subject"], $body);

            $page["msg"] = $page["lostpass_sent"];
            $page["title"] = $page["lost_password_title"] ;
        }
        else
        {
            // The account doesn't exist
            $page["msg"] = $page["no_such_validation_key"];
        }

        $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);
     break;
     case "manual":
        /* ----------------------------
              Manual validation form
           ---------------------------- */
        // Email validation isn't on so redirect to main page
        if ($settings["auth_user_type"] == AUTH_NONE || $settings["auth_user_type"] == AUTH_ADMIN)
        {
            go_to($settings["script_url"] . "index.php");
        }

        show_manual_form();
     break;
     case "confirm":
        /* ----------------------------
           Manual validation processing
           ---------------------------- */
        // Email validation isn't on so redirect to main page
        if ($settings["auth_user_type"] == AUTH_NONE || $settings["auth_user_type"] == AUTH_ADMIN)
        {
            go_to($settings["script_url"] . "index.php");
        }

        build_query($queries["check_validate"], array("VID" => $input["key"]));
        $result = db_query($queries["check_validate"], $link_id);

        if (db_num_rows($result, $link_id) < 1)
        {
            show_manual_form($page["invalid_key"]);
        }
        else
        {
            list($uid, $type) = db_fetch_array($result, $link_id);

            $page["title"] = $page["validation_title"];

            // A record was found, but again it was an invalid key
            if ($uid != $input["uid"])
            {
                show_manual_form($page["invalid_key"]);
            }
            else if ($type == AUTH_BOTH)
            {
                // The account is waiting for email and admin validation
                build_query($queries["set_admin_validate"], array("VID" => $input["key"]));
                db_query($queries["set_admin_validate"], $link_id);

                $page["msg"] = $page["validation_email_complete"];
            }
            else if ($type == AUTH_EMAIL)
            {
                // The account is waiting for email validation
                build_query($queries["delete_validate"], array("VID" => $input["key"]));
                db_query($queries["delete_validate"], $link_id);

                $page["msg"] = $page["validation_complete"];
            }
            else if ($type == LOST_PASS)
            {
                // The account is waiting for a new password
                build_query($queries["delete_validate"], array("VID" => $input["code"]));
                db_query($queries["delete_validate"], $link_id);

                // Set the new password
                $newpass = random_password(round(rand(7, 15)));
                build_query($queries["new_password"], array("PASSWORD" => md5($newpass), "UID" => $uid));
                db_query($queries["new_password"], $link_id);

                // Load the password reset
                $body = load_lang_file($permissions["lang"], "newpass.txt");

                // Parse the variables
                $info = array("NAME"           => $username,
                              "ADDRESS"        => $settings["script_url"],
                              "PASSWORD"       => $newpass,
                              "ADMIN_NAME"     => $settings["admin_name"],
                              "MANUAL_LINK"    => $settings["script_url"] . "index.php?act=login",
                              "IP_ADDRESS"     => $input["IP_ADDRESS"]
                              );

                $body = parse_html($info, $body);

                sendmail($email, $page["resetpass_email_subject"], $body);

                $page["msg"] = $page["lostpass_sent"];
                $page["title"] = $page["lost_password_title"];
            }
            else if ($type == AUTH_ADMIN)
            {
                // The account is waiting for admin validation, the user shouldn't be here
                $page["msg"] = $page["validation_admin_only"];
            }

            if (empty($page["msg"]) == false)
            {
                $page["content"] = static_template($settings["script_dir"] . "skin/msg.tpl", $page);
            }
        }

     break;
     default:
        /* ----------------------------
            Show the registration form
           ---------------------------- */
        show_reg_form();
}

$page["js"] = "reg";

?>