<?php

/*
 * Invision Power File Manager
 * Source viewer
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 19th November 2004
 *
 */

// Security check
if (defined("IPFM_RUNNING") == false)
{
    die("You can not access this module directly");
}

/* -----------------------------------------
                Program Execution
   ----------------------------------------- */

// Clean the user input
$target     = clean_path($input["target"]);

// Set some parameters
$global_tpl = "skin/popup.tpl";
$file_name  = "/" . $target;

// If we are running on Windows we need to reverse the slashes
if (is_win() == true)
{
    $file_name = preg_replace("/[\/]/", "\\", $file_name);
}

if (file_exists($permissions["root"] . $target) == false)
{
    // The user didn't select any existing object
    $page["title"]  = $page["usererr"];
    $page["source"] = $page["noexist"];
    $page["file"]   = $file_name;
    $page["icon"]   = get_icon("");
}
else if (is_file($permissions["root"] . $target) == false)
{
    // The user didn't select a file, but selected folder or none supported file type, eg socket or block device
    $page["title"]  = $page["usererr"];
    $page["source"] = $page["nofile"];
    $page["file"]   = $file_name;
    $page["icon"]   = is_dir($permissions["root"] . $target) ? "<img src=\"images\icons\folder.gif\" alt=\"$target\" title=\"$target\" />" : get_icon("");
}
else if (file_permission($target) == false || $permissions["source"] == 0 || is_ascii($target) == false)
{
    // The user doesn't have filetype permissions
    $page["title"]  = $page["usererr"];
    $page["source"] = $page["noperm"];
    $page["file"]   = $file_name;
    $page["icon"]   = get_icon(basename($target));
}
else if (filesize($permissions["root"] . $target) == 0)
{
    // The file is empty
    $page["title"]  = $page["blank"];
    $page["source"] = $page["empty"];
    $page["file"]   = $file_name;
    $page["icon"]   = get_icon(basename($target));
}
else
{
    // Open the file
    $fp = fopen($permissions["root"] . $target, "r");

    if (empty($fp) == true)
    {
        // The file could not be opened

        $page["title"]  = $page["system"];
        $page["source"] = $page["noopen"];
        $page["file"]   = $file_name;
        $page["icon"]   = get_icon(basename($target));
    }
    else
    {
        // Read the data
        $page["source"] = fread($fp, filesize($permissions["root"] . $target));
        fclose($fp);

        $page["source"] = wordwrap($page["source"], 75, "\n", 1);

        ob_start();                             // Start the output buffer
        highlight_string($page["source"]);      // Highlight the file
        $page["source"] = ob_get_contents();    // Collect the content of the buffer
        ob_end_clean();                         // Empty the buffer, and end

        // Remove the code tags
        $page["source"] = preg_replace("/^<code>(.+?)<\/code>$/ims", "\\1", $page["source"]);

        $page["file"]   = $file_name;
        $page["icon"]   = get_icon(basename($target));
    }
}

$page["js"]      = "";
$page["content"] = static_template($settings["script_dir"] . "skin/cards/source.tpl", $page);

?>