<?php

/*
 * Invision Power File Manager
 * Template List
 * Copyright (c) 2005 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball
 * Version: 1.0.1
 * Last Modified: 18th January 2005
 *
 */

// This script is for internal use in the Control Panel only so you should NOT edit it
// Numerical indexes are defined when not neeeded because it makes it easier to keep track of the current index

// Template categories
$skin["categories"]   = array(1 => $page["wrappers"],
                              2 => $page["dialogs"],
                              3 => $page["database"],
                              4 => $page["registration"],
                              5 => $page["usercp"],
                              6 => $page["index"]
                        );

// Category descriptions
$skin["descriptions"] = array(1 => $page["wrappers_info"],
                              2 => $page["dialogs_info"],
                              3 => $page["database_info"],
                              4 => $page["registration_info"],
                              5 => $page["usercp_info"],
                              6 => $page["index_info"]
                        );

// The index in the first array indicates the template section, the index in the second array indicates the template ID, for example
// the global template belongs to the "wrappers" section (2) and is template number 1, no two templates can have the same ID
$skin["templates"]    = array(1 => array(1 => $page["global_wrapper"],
                                         2 => $page["popup"]
                                   ),
                              2 => array(3 => $page["archiver"],
                                         4 => $page["bookmarks"],
                                         5 => $page["chmod"],
                                         6 => $page["delete"],
                                         7 => $page["extraction"],
                                         8 => $page["legend"],
                                         9 => $page["links"],
                                         10 => $page["mkdir"],
                                         11 => $page["mkfile"],
                                         12 => $page["move"],
                                         13 => $page["multi"],
                                         14 => $page["notes"],
                                         15 => $page["password"],
                                         16 => $page["rename"],
                                         17 => $page["source"],
                                         18 => $page["upload"],
                                         19 => $page["verify"],
                                         44 => $page["mp3"]
                                   ),
                              3 => array(20 => $page["sql_input"],
                                         21 => $page["results"],
                                         22 => $page["sql_error"]
                                   ),
                              4 => array(23 => $page["regform"],
                                         24 => $page["lostpass"],
                                         25 => $page["manual"]
                                   ),
                              5 => array(26 => $page["cleanup"],
                                         27 => $page["edit"],
                                         28 => $page["email"],
                                         29 => $page["main"],
                                         30 => $page["language"],
                                         31 => $page["ucp"],
                                         32 => $page["cperror"],
                                         33 => $page["chpass"],
                                         34 => $page["report"],
                                         35 => $page["chart"],
                                         36 => $page["timezone"]
                                   ),
                              6 => array(37 => $page["fileeditor"],
                                         38 => $page["err_page"],
                                         39 => $page["tools"],
                                         40 => $page["listing"],
                                         41 => $page["login"],
                                         42 => $page["msg"],
                                         43 => $page["toolbar"],
                                         45 => $page["guestToolbar"]
                                   )
                     );

// The file names for the template, the index/key relates to the template ID
$skin["files"]     = array(0 => "styles.css",
                           1 => "global.tpl",
                           2 => "popup.tpl",
                           3 => "cards/archive.tpl",
                           4 => "cards/bookmark.tpl",
                           5 => "cards/chmod.tpl",
                           6 => "cards/delete.tpl",
                           7 => "cards/extract.tpl",
                           8 => "cards/legend.tpl",
                           9 => "cards/link.tpl",
                           10 => "cards/mkdir.tpl",
                           11 => "cards/mkfile.tpl",
                           12 => "cards/move.tpl",
                           13 => "cards/multi-upload.tpl",
                           14 => "cards/notes.tpl",
                           15 => "cards/protect.tpl",
                           16 => "cards/rename.tpl",
                           17 => "cards/source.tpl",
                           18 => "cards/upload.tpl",
                           19 => "cards/verify.tpl",
                           20 => "db/query.tpl",
                           21 => "db/result.tpl",
                           22 => "db/error.tpl",
                           23 => "reg/register.tpl",
                           24 => "reg/send.tpl",
                           25 => "reg/validation.tpl",
                           26 => "usercp/cleanup.tpl",
                           27 => "usercp/edit.tpl",
                           28 => "usercp/email.tpl",
                           29 => "usercp/index.tpl",
                           30 => "usercp/languages.tpl",
                           31 => "usercp/main.tpl",
                           32 => "usercp/msg.tpl",
                           33 => "usercp/password.tpl",
                           34 => "usercp/report.tpl",
                           35 => "usercp/stats.tpl",
                           36 => "usercp/timezone.tpl",
                           37 => "editor.tpl",
                           38 => "error.tpl",
                           39 => "filetools.tpl",
                           40 => "index.tpl",
                           41 => "login.tpl",
                           42 => "msg.tpl",
                           43 => "toolbar.tpl",
                           44 => "cards/mp3.tpl",
                           45 => "guestToolbar.tpl"
                     );

// An array where the index is the same as the template ID and the value is the related language file
$skin["languages"]  = array(3 => "archive.lng.php",
                            4 => "bookmarks.lng.php",
                            5 => "chmod.lng.php",
                            6 => "delete.lng.php",
                            7 => "extract.lng.php",
                            8 => "legend.lng.php",
                            9 => "link.lng.php",
                            10 => "mkdir.lng.php",
                            11 => "mkfile.lng.php",
                            12 => "move.lng.php",
                            13 => "multi-upload.lng.php",
                            14 => "notes.lng.php",
                            15 => "protect.lng.php",
                            16 => "rename.lng.php",
                            17 => "source.lng.php",
                            18 => "upload.lng.php",
                            19 => "verify.lng.php",
                            20 => "database.lng.php",
                            21 => "database.lng.php",
                            22 => "database.lng.php",
                            23 => "register.lng.php",
                            24 => "register.lng.php",
                            25 => "register.lng.php",
                            26 => "usercp.lng.php",
                            27 => "usercp.lng.php",
                            28 => "usercp.lng.php",
                            29 => "usercp.lng.php",
                            30 => "usercp.lng.php",
                            31 => "usercp.lng.php",
                            32 => "usercp.lng.phpl",
                            33 => "usercp.lng.php",
                            34 => "usercp.lng.php",
                            35 => "usercp.lng.php",
                            36 => "usercp.lng.php",
                            37 => "editor.lng.php",
                            38 => "error.lng.php",
                            39 => "listing.lng.php",
                            40 => "listing.lng.php",
                            41 => "login.lng.php",
                            44 => "mp3.lng.php"
                      );

// An array of the variables used in a template the index of the first array is the template ID, the second array is the variable as the key and the description as the value
$skin["variables"] = array(1 => array("JS"          => $page["jsid"],
                                      "CONTENT"     => $page["document"],
                                      "EXECUTE"     => $page["execution"],
                                      "COMPRESS"    => $page["gzip"],
                                      "LOAD"        => $page["load"],
                                      "QUERIES"     => $page["count"],
                                      "COPYRIGHT"   => $page["legal"]
                                ),
                           2 => array("JS"          => $page["jsid"],
                                      "CONTENT"     => $page["document"],
                                      "EXECUTE"     => $page["execution"],
                                      "COMPRESS"    => $page["gzip"],
                                      "LOAD"        => $page["load"],
                                      "QUERIES"     => $page["count"],
                                      "COPYRIGHT"   => $page["legal"]
                                ),
                           3 => array("THIS"        => $page["curdir"],
                                      "FILES"       => $page["archive_files"],
                                      "DIRS"        => $page["archive_dirs"],
                                      "TYPES"       => $page["archive_types"]
                                ),
                           4 => array("THIS"        => $page["curdir"],
                                      "TARGET"      => $page["bookmark_target"]
                                ),
                           5 => array("THIS"           => $page["curdir"],
                                      "FILES"          => $page["chmod_files"],
                                      "DIRS"           => $page["chmod_dirs"],
                                      "CHMOD"          => $page["chmod_value"],
                                      "OWNER_READ"     => $page["owner_read"],
                                      "GROUP_READ"     => $page["group_read"],
                                      "PUBLIC_READ"    => $page["public_read"],
                                      "OWNER_WRITE"    => $page["owner_write"],
                                      "GROUP_WRITE"    => $page["group_write"],
                                      "PUBLIC_WRITE"   => $page["public_write"],
                                      "OWNER_EXECUTE"  => $page["owner_execute"],
                                      "GROUP_EXECUTE"  => $page["group_execute"],
                                      "PUBLIC_EXECUTE" => $page["public_execute"]
                                ),
                           6 => array("THIS"             => $page["curdir"],
                                      "FILES"            => $page["del_files"],
                                      "DIRS"             => $page["del_dirs"]
                                ),
                           7 => array("TARGET"           => $page["extract_target"],
                                      "THIS"             => $page["curdir"],
                                      "ARCHIVE"          => $page["extract_archive"],
                                      "THIS_FOLDER_ICON" => $page["folder_icon"],
                                      "NAV"              => $page["folder_nav"],
                                      "MSG"              => $page["error"],
                                      "ICON"             => $page["file_icon"],
                                      "BACK_IMG"         => $page["back_img"],
                                      "UP"               => $page["back_link"],
                                      "NAME_LINK"        => $page["name_link"],
                                      "OPEN"             => $page["open_url"],
                                      "BOOKLIST"         => $page["bookmark_list"]
                                ),
                           9 => array("LINK"             => $page["link_to"],
                                      "THIS"             => $page["link_source"],
                                      "TARGET"           => $page["link_target"],
                                      "THIS_FOLDER_ICON" => $page["folder_icon"],
                                      "NAV"              => $page["folder_nav"],
                                      "MSG"              => $page["error"],
                                      "ICON"             => $page["file_icon"],
                                      "BACK_IMG"         => $page["back_img"],
                                      "UP"               => $page["back_link"],
                                      "NAME_LINK"        => $page["name_link"],
                                      "OPEN"             => $page["open_url"],
                                      "BOOKLIST"         => $page["bookmark_list"]
                                ),
                            10 => array("THIS"           => $page["curdir"]
                                  ),
                            11 => array("THIS"           => $page["curdir"],
                                        "TEMPLATES"      => $page["file_templates"],
                                  ),
                            12 => array("TYPE"             => $page["copy_action"],
                                        "THIS"             => $page["copy_source"],
                                        "FILES"            => $page["copy_files"],
                                        "DIRS"             => $page["copy_dirs"],
                                        "TARGET"           => $page["copy_to"],
                                        "THIS_FOLDER_ICON" => $page["folder_icon"],
                                        "NAV"              => $page["folder_nav"],
                                        "MSG"              => $page["error"],
                                        "ICON"             => $page["file_icon"],
                                        "BACK_IMG"         => $page["back_img"],
                                        "UP"               => $page["back_link"],
                                        "NAME_LINK"        => $page["name_link"],
                                        "OPEN"             => $page["open_url"],
                                        "BOOKLIST"         => $page["bookmark_list"]
                                  ),
                            13 => array("THIS"             => $page["curdir"],
                                  ),
                            14 => array("THIS"             => $page["curdir"],
                                        "ICON"             => $page["icon"],
                                        "FILE"             => $page["fname"],
                                        "NOTES"            => $page["curnotes"]
                                  ),
                            15 => array("THIS"             => $page["curdir"],
                                        "TARGET"           => $page["protect_dir"],
                                        "NAME"             => $page["curuser"]
                                  ),
                            16 => array("THIS"             => $page["curdir"],
                                        "DIRNAME"          => $page["dirname"],
                                        "FILENAME"         => $page["filename"],
                                        "ID"               => $page["oldname"],
                                        "TARGET"           => $page["safe_oldname"]
                                  ),
                            17 => array("ICON"             => $page["icon"],
                                        "FILE"             => $page["fname"],
                                        "SOURCE"           => $page["filesource"]
                                  ),
                            18 => array("THIS"             => $page["curdir"]
                                  ),
                            19 => array("ICON"             => $page["icon"],
                                        "FILE"             => $page["fname"],
                                        "MD5_HASH_VALUE"   => $page["filehash"]
                                  ),
                            20 => array("USERLINKS"        => $page["usertools"],
                                        "DB_VERSION"       => $page["dbversion"],
                                        "DATABASE_LIST"    => $page["dblist"]
                                  ),
                            21 => array("USERLINKS"         => $page["usertools"],
                                        "SELECTED_DATABASE" => $page["curdb"],
                                        "SQL"               => $page["cursql"],
                                        "RESULT"            => $page["sqlresults"]
                                  ),
                            23 => array("ERROR_MSG"         => $page["error"],
                                        "INPUT_USERNAME"    => $page["entered_username"],
                                        "INPUT_PASSWORD"    => $page["entered_password"],
                                        "INPUT_PASSWORD2"   => $page["entered_password2"],
                                        "INPUT_EMAIL"       => $page["entered_email"],
                                        "INPUT_EMAIL2"      => $page["entered_email2"],
                                        "IMG"               => $page["security_img"],
                                        "ID"                => $page["security_id"],
                                        "TOS"               => $page["terms"]
                                  ),
                            24 => array("OP"                => $page["lostpass_type"],
                                        "ERROR_MSG"         => $page["error"],
                                        "INPUT_USERNAME"    => $page["entered_username"],
                                        "INPUT_EMAIL"       => $page["entered_email"]
                                  ),
                            25 => array("ERROR_MSG"         => $page["error"],
                                        "INPUT_UID"         => $page["userid"],
                                        "INPUT_KEY"         => $page["valid_key"]
                                  ),
                            26 => array("INVALID"           => $page["invalid_bookmarks"],
                                        "DUPLICATE_PATHS"   => $page["duplicate_paths"],
                                        "DUPLICATE_NAMES"   => $page["duplicate_names"]
                                  ),
                            27 => array("NAME"              => $page["bookmark_name"],
                                        "PATH"              => $page["bookmark_path"],
                                        "VIEW"              => $page["bookmark_view"]
                                  ),
                            29 => array("USERLINKS" => $page["usertools"],
                                        "USERCP"    => $page["ucp_content"]
                                  ),
                            30 => array("LANGUAGE_LIST" => $page["lang_list"]
                                  ),
                            31 => array("EMAIL"      => $page["users_email"],
                                        "PERMISSION" => $page["permission_values"],
                                        "ALLOW"      => $page["access_type"],
                                        "ALLOW_LIST" => $page["access_list"],
                                        "EDIT_LIST"  => $page["editable"]
                                  ),
                            32 => array("CAPTION"    => $page["error_caption"],
                                        "MSG"        => $page["error"]
                                  ),
                            34 => array("LARGEST_FILE"         => $page["largest_file"],
                                        "LARGEST_SIZE"         => $page["largest_size"],
                                        "DIR"                  => $page["largest_dir"],
                                        "FOLDER_KEY"           => $page["folder_key"],
                                        "ONCE"                 => $page["once_bit"],
                                        "FOLDER_COUNT"         => $page["folder_count"],
                                        "KEY"                  => $page["file_key"],
                                        "COUNT"                => $page["file_count"],
                                        "SIZE"                 => $page["file_size"],
                                        "PERCENTAGE"           => $page["file_percentage"],
                                        "FILTER"               => $page["file_filter"],
                                        "TOTAL_COUNT"          => $page["total_files"],
                                        "TOTAL_SIZE"           => $page["total_size"],
                                        "SYSTEM_FILES"         => $page["sys_size"],
                                        "IMG1"                 => $page["total_chart"],
                                        "IMG2"                 => $page["type_chart"]
                                       ),
                            35 => array("USED"                 => $page["amount_used"],
                                        "USED_PERCENTAGE"      => $page["percent_used"],
                                        "FREE"                 => $page["amount_free"],
                                        "FREE_PERCENTAGE"      => $page["percent_free"],
                                        "TOTAL"                => $page["total_space"],
                                        "FREE_KEY"             => $page["free_key"],
                                        "USED_KEY"             => $page["used_key"],
                                        "IMG"                  => $page["space_usage"]
                                  ),
                            36 => array("CURRENT_USER_TIME"    => $page["current_time"],
                                        "TIMEZONE_LIST"        => $page["timezones"],
                                        "ISDST"                => $page["daylight"]
                                  ),
                            37 => array("USERLINKS" => $page["usertools"],
                                        "TARGET"    => $page["target"],
                                        "ISNEW"     => $page["is_new"],
                                        "MSG"       => $page["error"],
                                        "ICON"      => $page["icon"],
                                        "FILE"      => $page["fname"],
                                        "FILE_DATA" => $page["filebody"],
                                        "FILENAME"  => $page["filename"],
                                        "LINK"      => $page["documentation"]
                                  ),
                            38 => array("MSG"       => $page["error"]
                                  ),
                            39 => array("FILETOOLS" => $page["filetools_content"]
                                  ),
                            40 => array("THIS"             => $page["curdir"],
                                        "FILETOOLS"        => $page["filetools"],
                                        "THIS_FOLDER_ICON" => $page["folder_icon"],
                                        "NAV"              => $page["folder_nav"],
                                        "DIR"              => $page["cur_working_dir"],
                                        "MSG"              => $page["error"],
                                        "ICON"             => $page["file_icon"],
                                        "BACK_IMG"         => $page["back_img"],
                                        "UP"               => $page["back_link"],
                                        "NAME_LINK"        => $page["name_link"],
                                        "OPEN"             => $page["open_url"],
                                        "MDATE"            => $page["last_modified"],
                                        "CHMOD_VAL"        => $page["chmod_value"],
                                        "OWNER"            => $page["file_owner"],
                                        "GROUP"            => $page["file_group"],
                                        "NAME"             => $page["checkbox_name"],
                                        "FSIZE"            => $page["fsize"],
                                        "PAGE_LINKS"       => $page["pages"],
                                        "TOTAL"            => $page["totalsize"],
                                        "FILTER"           => $page["file_filter"],
                                        "BOOKLIST"         => $page["bookmark_list"],
                                        "IS_READ"          => $page["folder_read"],
                                        "IS_WRITE"         => $page["folder_write"],
                                        "TOTAL_FILES"      => $page["number_files"],
                                        "TOTAL_FOLDERS"    => $page["number_folders"],
                                        "NOTES"            => $page["dirnotes"]
                                    ),
                              42 => array("MSG"            => $page["error"]
                                    ),
                              43 => array("USERNAME"       => $page["current_user"],
                                          "GROUPNAME"      => $page["current_group"],
                                          "AREAS"          => $page["area_links"],
                                          "TOOLS"          => $page["tool_links"]
                                    ),
                              44 => array("ARTIST"         => $page["artist_tag"],
                                          "TRACK"          => $page["track_tag"],
                                          "ALBUM"          => $page["album_tag"],
                                          "YEAR"           => $page["year_tag"],
                                          "GENRE"          => $page["genre_tag"],
                                          "COMMENTS"       => $page["comments_tag"],
                                          "BITRATE"        => $page["bitrate"],
                                          "SAMPLE"         => $page["sample"],
                                          "CHANNELS"       => $page["channels"],
                                          "LENGTH"         => $page["length"],
                                          "SIZE"           => $page["fsize"]
                                    ),
                              45 => array("USERNAME"       => $page["current_user"],
                                          "AREAS"          => $page["area_links"],
                                          "TOOLS"          => $page["tool_links"]
                                    )                                    
                     );

// Required variables for each template, the index is the template ID
$skin["required"]  = array(1  => array("JS", "CONTENT", "COPYRIGHT"),
                           2  => array("JS", "CONTENT", "COPYRIGHT"),
                           3  => array("THIS", "FILES", "DIRS"),
                           4  => array("THIS", "TARGET"),
                           5  => array("THIS", "FILES", "DIRS", "CHMOD", "OWNER_READ", "GROUP_READ", "PUBLIC_READ", "OWNER_WRITE", "GROUP_WRITE", "PUBLIC_WRITE", "OWNER_EXECUTE", "GROUP_EXECUTE", "PUBLIC_EXECUTE"),
                           6  => array("THIS", "FILES", "DIRS"),
                           7  => array("TARGET", "THIS", "ARCHIVE", "UP", "NAME_LINK"),
                           9  => array("LINK", "THIS", "TARGET"),
                           10 => array("THIS"),
                           11 => array("THIS", "TEMPLATES"),
                           12 => array("TYPE", "THIS", "FILES", "DIR", "TARGET", "UP", "NAME_LINK"),
                           13 => array("THIS"),
                           14 => array("THIS", "FILE", "NOTES"),
                           15 => array("THIS", "TARGET", "NAME"),
                           16 => array("THIS", "ID"),
                           17 => array("SOURCE"),
                           18 => array("THIS"),
                           19 => array("MD5_HASH_VALUE"),
                           20 => array("USERLINKS", "DATABASE_LIST"),
                           21 => array("USERLINKS", "RESULT"),
                           23 => array("ERROR_MSG", "IMG", "ID"),
                           24 => array("ERROR_MSG", "OP"),
                           25 => array("ERROR_MSG"),
                           27 => array("NAME", "PATH"),
                           29 => array("USERLINKS", "USERCP"),
                           30 => array("LANGUAGE_LIST"),
                           32 => array("MSG"),
                           34 => array("IMG1", "IMG2"),
                           35 => array("USED", "FREE", "TOTAL"),
                           37 => array("USERLINKS", "TARGET", "ISNEW" , "MSG" , "FILE_DATA", "FILENAME"),
                           38 => array("MSG"),
                           39 => array("FILETOOLS"),
                           40 => array("THIS", "DIR", "UP", "NAME_LINK"),
                           42 => array("MSG"),
                           43 => array("AREAS", "TOOLS"),
                           44 => array("ARTIST", "TRACK", "ALBUM", "BITRATE", "SAMPLE", "CHANNELS", "LENGTH"),
                           45 => array("AREAS", "TOOLS")                           
                     );

// Skin sections
$skin["sections"]  = array(3 => array("OPTIONS"   => $page["archive_options"]
                                ),
                           5 => array("DIR"       => $page["chmod_recurse"]
                                ),
                           7 => array("MSG"       => $page["error_block"],
                                      "UP"        => $page["up_block"],
                                      "FOLDERS"   => $page["folder_block"],
                                      "OVERWRITE" => $page["overwrite_block"],
                                      "DELETE"    => $page["delete_block"],
                                      "BOOKMARKS" => $page["bookmark_block"]
                                ),
                           9 => array("MSG"       => $page["error_block"],
                                      "UP"        => $page["up_block"],
                                      "FOLDERS"   => $page["folder_block"],
                                      "BOOKMARKS" => $page["bookmark_block"]
                                 ),
                           12 => array("MSG"       => $page["error_block"],
                                       "UP"        => $page["up_block"],
                                       "FOLDERS"   => $page["folder_block"],
                                       "BOOKMARKS" => $page["bookmark_block"]
                                 ),
                           13 => array("UPLOADS"   => $page["single_block"]
                                 ),
                           15 => array("INSTRUCTION" => $page["info_block"],
                                       "USERS"       => $page["existing_user_block"]
                                 ),
                           16 => array("FILES"       => $page["file_entry"],
                                       "FOLDERS"     => $page["folder_entry"]
                                 ),
                           23 => array("ERROR"       => $page["error_block"],
                                       "SECURITY"    => $page["bot_block"]
                                 ),
                           24 => array("ERROR"       => $page["error_block"]
                                 ),
                           25 => array("ERROR"       => $page["error_block"]
                                 ),
                           26 => array("BOOKMARK"    => $page["single_bookmark"]
                                 ),
                           29 => array("BOOKMARKS"   => $page["bookmark_block"]
                                 ),
                           31 => array("PERMISSION"  => $page["permission_block"],
                                       "FILETYPES"   => $page["filelist"],
                                       "EDITABLE"    => $page["editlist"]
                                 ),
                           34 => array("ALL"         => $page["full_report"],
                                       "DIR"         => $page["small_report"],
                                       "GD"          => $page["gd_installed"],
                                       "LOWSPACE"    => $page["lowspace_prompt"],
                                       "FOLDERS"     => $page["folder_statistics"],
                                       "FILE"        => $page["file_statistics"]
                                 ),
                           35 => array("KEY"         => $page["gd_installed"],
                                       "NOGD"        => $page["gd_missing"],
                                       "LOWSPACE"    => $page["lowspace_prompt"]
                                 ),
                           37 => array("ERROR"         => $page["error_block"],
                                       "DOCUMENTATION" => $page["documentation_block"]
                                 ),
                           40 => array("UPPER_FILETOOLS" => $page["toolbar_block"],
                                       "MSG"             => $page["error_block"],
                                       "UPPERALL"        => $page["multifiles"],
                                       "LOWERALL"        => $page["multifiles"],
                                       "UNIX"            => $page["unix_block"],
                                       "UP"              => $page["up_block"],
                                       "FOLDERS"         => $page["folder_block"],
                                       "FILES"           => $page["file_block"],
                                       "BOOKMARKS"       => $page["bookmark_block"],
                                       "TOTAL_SIZE"      => $page["files_in_dir"],
                                       "EDITNOTE"        => $page["notes_block"]
                                 ),
                           41 => array("ERROR"       => $page["error_block"],
                                       "REGISTER"    => $page["reg_enabled"],
                                       "GUEST"       => $page["guest_enabled"]
                                 )
                     );

?>