// A function to increase the RGB value
function increase(field, type)
{
    if (parseInt(window.document.forms["colours"].elements[field + "_" + type].value) + 1 >= 255)
    {
        // If the new value is going to be more than 255 set it to 255
        window.document.forms["colours"].elements[field + "_" + type].value = 255;
        window.clearInterval(timerID); // Ensure the timer has stopped, just in case
    }
    else
    {
        window.document.forms["colours"].elements[field + "_" + type].value = parseInt(window.document.forms["colours"].elements[field + "_" + type].value) + 1;
    }

    updateRGB(field);
}

// A function to decrease the RGB value
function decrease(field, type)
{
    if (parseInt(window.document.forms["colours"].elements[field + "_" + type].value) - 1 <= 0)
    {
        // If the new value is less than 0 set it to 0
        window.document.forms["colours"].elements[field + "_" + type].value = 0;
        window.clearInterval(timerID); // Ensure the timer has stopped, just in case
    }
    else
    {
        window.document.forms["colours"].elements[field + "_" + type].value = parseInt(window.document.forms["colours"].elements[field + "_" + type].value) - 1;
        
    }

    updateRGB(field);
}

// A function to update the RGB colour sample
function updateRGB(field)
{
    if (isRGB(window.document.forms["colours"].elements[field + "_red"]) == false || isRGB(window.document.forms["colours"].elements[field + "_green"]) == false || isRGB(window.document.forms["colours"].elements[field + "_blue"]) == false)
    {
        // One of the fields doesn't contain a valid number so return
        return;
    }

    var red     = window.document.forms["colours"].elements[field + "_red"].value;
    var green   = window.document.forms["colours"].elements[field + "_green"].value;
    var blue    = window.document.forms["colours"].elements[field + "_blue"].value;

    window.document.forms["colours"].elements[field + "_preview"].style.backgroundColor = "rgb(" + red + "," + green + "," + blue + ")";

    ConvertToHex(field);
}

function updateRGBfield(field, type)
{
    if (isRGB(window.document.forms["colours"].elements[field + "_" + type]) == false)
    {
        // Apparently 
        window.document.forms["colours"].elements[field + "_" + type].focus();
        return false;
    }
    else
    {
        updateRGB(field);
        return true;
    }
}

// A function which checks if the value is valid
function isRGB(field)
{
    if (field.value == null || field.value == "")
    {
        // Value is empty
        return false;
    }
    else if (isNaN(field.value) == true)
    {
        // Value is not a number
        return false;
    }
    else if (field.value < 0 || field.value > 255)
    {   
        // Value too high/low
        return false;
    }
    else
    {
        // We got through all the check so convert to an Integer not a decimal
        //field.value = parseInt(field.value);
        return true;
    }
}

// Converts a Hex character to a Decimal
function DecValue(Hex)
{
    if (Hex == "A")
    {
        return 10;
    }
    else if (Hex == "B")
    {
        return 11;
    }
    else if (Hex == "C")
    {
        return 12;
    }
    else if (Hex == "D")
    {
        return 13;
    }
    else if (Hex == "E")
    {
        return 14;
    }
    else if (Hex == "F")
    {
        return 15;
    }
    else
    {
        return eval(Hex);
    }
}

// Converts a Decimal to a Hex character
function HexValue(Dec)
{
    if (Dec == 10)
    {
        return "A";
    }
    else if (Dec == 11)
    {
        return "B";
    }
    else if (Dec == 12)
    {
        return "C";
    }
    else if (Dec == 13)
    {
        return "D";
    }
    else if (Dec == 14)
    {
        return "E";
    }
    else if (Dec == 15)
    {
        return "F";
    }
    else
    {
        return "" + Dec;
    }
}

// Converts the Hex string to RGB
function ConvertToRGB(field)
{
    var valid = new RegExp("^[A-Fa-f0-9]+$");

    var red     = window.document.forms["colours"].elements[field + "_red"].value;
    var green   = window.document.forms["colours"].elements[field + "_green"].value;
    var blue    = window.document.forms["colours"].elements[field + "_blue"].value;
    var input   = window.document.forms["colours"].elements[field + "_hex"];

    if (valid.test(input.value) == false)
    {
        input.focus();
        return;
    }    
    else if (input.value.length != 6)
    {
        input.focus();
        return;
    }

    input = input.value.toUpperCase();

    var a = DecValue(input.substring(0, 1));
    var b = DecValue(input.substring(1, 2));
    var c = DecValue(input.substring(2, 3));
    var d = DecValue(input.substring(3, 4));
    var e = DecValue(input.substring(4, 5));
    var f = DecValue(input.substring(5, 6));

    var x = (a * 16) + b;
    var y = (c * 16) + d;
    var z = (e * 16) + f;

    red.value   = x;
    green.value = y;
    blue.value  = z;

    updateRGB(field);
}

// Converts the RGB values to a Hex string
function ConvertToHex(field)
{
    var red     = window.document.forms["colours"].elements[field + "_red"].value;
    var green   = window.document.forms["colours"].elements[field + "_green"].value;
    var blue    = window.document.forms["colours"].elements[field + "_blue"].value;

    var a       = HexValue(Math.floor(red / 16));
    var b       = HexValue(red % 16);
    var c       = HexValue(Math.floor(green / 16));
    var d       = HexValue(green % 16);
    var e       = HexValue(Math.floor(blue / 16));
    var f       = HexValue(blue % 16);

    var z = a + b + c + d + e + f;

    while (z.length < 6)
    {
        z = z + "0";
    }

    window.document.forms["colours"].elements[field + "_hex"].value = z;
}

// A pair of functions to increase the value when the user "holds" the button
var timerID;
function start_timer(method, field, type)
{
    window.clearInterval(timerID); // Ensure the timer has stopped, just in case

    if (method == "inc")
    {
        var func = "increase('" + field + "','" + type + "')";
        increase(field, type); // Run the function once before starting the timer
    }
    else
    {
        var func = "decrease('" + field + "','" + type + "')";
        decrease(field, type); // Run the function once before starting the timer
    }
    
    timerID = window.setInterval(func, 100);
}

function stop_timer()
{
    window.clearInterval(timerID);
}

function updateIcon(id, field)
{
    window.document.images[id].src = "images/icons/" + field.value;

    return true;
}